<?php 

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/**
 *  Virtuemart Stripe SSC
 *  Online Store Copyright 2024
 *  This code is copyright of online-store.co.uk
 *  You are not allowed to distribute or sell this code.
 *  https://plugins.online-store.co.uk/
*/


if (!class_exists('VmConfig'))
	require(JPATH_ADMINISTRATOR . '/' . 'components' . '/' . 'com_virtuemart' . '/' . 'helpers' . '/' . 'config.php');
 
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . '/' . 'vmpsplugin.php');
    
//ini_set('display_errors', 1);
//error_reporting(E_ALL);
//error_reporting(E_ALL & ~E_DEPRECATED);

    

class plgVmPaymentStripessc extends vmPSPlugin
	{
    // instance of class
    public static $_this = false;
    private $_rest = false;
	 private $_ap = false;
	 
    function __construct(& $subject, $config) {
	//if (self::$_this)
	//   return self::$_this;
	parent::__construct($subject, $config);
	
	$this->_loggable = false;
	$this->tableFields = array_keys($this->getTableSQLFields());
	$this->_tablepkey = 'id';
	$this->_tableId = 'id';

	
	$varsToPush = array(

     "ssc_api_username" => array('', 'char'),
     "ssc_api_password" => array('', 'char'),
     "ssc_api_signature" => array('', 'char'),
     "ssc_environment" => array('', 'char'),
     "ssc_api_sb_username" => array('', 'char'),
     "ssc_api_sb_password" => array('', 'char'),
     "ssc_api_sb_signature" => array('', 'char'),
     "ssc_payment_action" => array('Sale', 'char'),
     "ssc_user_action" => array('', 'char'),
     "ssc_multi_currency" => array(0, 'int'),
     "ssc_one_page" => array(0, 'int'),
     "ssc_third_party_payments" => array(1, 'int'),
     
	 "payment_currency" => array('', 'int'),
	 // "email_currency" => array('', 'int'),
	 "sandbox" => array(0, 'int'),
	 
	 "ssc_address_required" => array(2, 'int'),
	 "ssc_address_override" => array(1, 'int'),
	  
	 "payment_logos" => array('', 'char'),
	 "debug" => array(0, 'int'),
	 "status_pending" => array('', 'char'),
	 "status_success" => array('', 'char'),
	 "status_canceled" => array('', 'char'),
	 
	"status_partial_refunded" => array('R', 'char'),
	"status_refunded" => array('R', 'char'),
	"status_denied" => array('D', 'char'),

	 "countries" => array('', 'char'),
	 "min_amount" => array('', 'int'),
	 "max_amount" => array('', 'int'),
		
	"categories" => array('', 'char'),
	"blocking_categories" => array('', 'char'),

	// "cost_per_transaction" => array('', 'int'),
	"cost_per_transaction" => array(0, 'float'),
	// "cost_percent_total" => array('', 'int'),
	 "cost_percent_total" => array(0, 'float'),
	 "countries" => array('', 'char'),
	 "tax_id" => array(-1, 'int'),
	 "ssc_landing_page" => array('', 'char'),
	 "ssc_solution_type" => array('', 'char'),
	 "ssc_ssc1" => array('', 'char'),
	 "ssc_ssc2" => array('', 'char'),	
	"ssc_whsec" => array('', 'char'),
		 
	"ssc_ssc1_sb" => array('', 'char'),
	"ssc_ssc2_sb" => array('', 'char'),	
	"ssc_whsec_sb" => array('', 'char'),
	
//	"ssc_localecode" => array('', 'char'),
//	"ssc_api_PAGESTYLE" => array('', 'char'),
	"ssc_HDRIMG" => array('', 'char'),
//	"ssc_api_HDRBORDERCOLOR" => array('', 'char'),
//	"ssc_api_HDRBACKCOLOR" => array('', 'char'),
	"ssc_PAYFLOWCOLOR" => array('', 'char'),
	"ssc_BRANDNAME" => array('', 'char'),
	"ssc_show_thank_you" => array(1, 'int'),
	"ssc_show_receipt_address" => array(1, 'int'),
	"ssc_show_order_details" => array(1, 'int'),
		 	 
	"ssc_payment_header" => array('', 'char'),
	"ssc_payment_footer" => array('', 'char'),
	"ssc_receipt_header" => array('', 'char'),
	"ssc_receipt_footer" => array('', 'char'),
	"ssc_raw" => array('', 'char'),
	"ssc_short_cut_cart" => array('', 'char'),
	"ssc_ipn_updates" => array(0, 'int'),
	"ssc_ajax" => array(0, 'int'),
	"ssc_template_fix" => array(1, 'int'),
	"ssc_use_patch" => array(1, 'int'),
	"ssc_ppp_lib" => array(0, 'int'),
	"ssc_order_button_background" => array('#0000FF', 'char'),
	"ssc_order_button_foreground" => array('#FFFFFF', 'char'),
		 
	"ssc_BILLINGPERIOD" => array('None', 'char'),
	"ssc_BILLINGFREQUENCY" =>array(0, 'int'),
	"ssc_TOTALBILLINGCYCLES" => array(0, 'int'),
	"ssc_INITAMT" => array(0, 'int'),

	"ssc_TRIALBILLINGPERIOD" => array('None', 'char'),
	"ssc_TRIALBILLINGFREQUENCY" =>array(0, 'int'),
	"ssc_TRIALAMT" => array(0, 'int'),
	"ssc_TRIALTOTALBILLINGCYCLES" =>array(0, 'int'),
	
	"ssc_pplan_BILLINGPERIOD" => array('None', 'char'),
	"ssc_pplan_BILLINGFREQUENCY" =>array(0, 'int'),
	"ssc_pplan_TOTALBILLINGCYCLES" => array(0, 'int'),
	"ssc_pplan_INITAMT" => array(0, 'int'),
	
	"ssc_pplan_defer" => array(0, 'int'),
	"ssc_pplan_defer_date" => array('', 'char'),
	
	"ssc_pplan_admin_fee" => array(0, 'int'),

	'ssc_pplan_defer_strtotime' => array('', 'char'),
							
	'ssc_pplan_auto_billing_type' => array('', 'char'),
   'ssc_pplan_auto_billing_max_amount' => array('', 'int'),
		 
	'ssc_show_paypal' => array(0, 'int'),
 
  	'show_cc_fields' => array(0, 'int'),
   'ssc_pplan_id' => array('PPlan', 'char'),
		 
	'ssc_enable_conected_payments' => array(0, 'int'),
		 
	'ssc_connected_account_id' => array('', 'char'),
		 
	'ssc_application_fee_percent' => array('', 'char'),
		 	 
	'ssc_privacy_policy_url' => array('', 'char'),
	'ssc_terms_of_service_url' => array('', 'char'),
	'ssc_return_url' => array('', 'char'),
	'ssc_headline' => array('', 'char')
		 
	);



	
	
	

	$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

	//self::$_this = $this;
    }

    public function getVmPluginCreateTableSQL() {

	return $this->createTableSQL('PayPal Payments Pro Table');
    }

    function getTableSQLFields() {


$SQLfields = array(
	    "id" => 'int(1) unsigned NOT NULL AUTO_INCREMENT',
	    "virtuemart_order_id" => 'int(1) UNSIGNED',
	    "order_number" => 'char(32)',
	    "virtuemart_paymentmethod_id" => 'mediumint(1) UNSIGNED',
	    "payment_name" => 'char(255) NOT NULL DEFAULT \'\'',
	    "payment_order_total" => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
	    "payment_currency" => 'char(3)',
	    "currency_code" => 'varchar(3)',
	    //  "prices_currency" => 'smallint(1)',
	  //  "prices_currency_code" => 'varchar(3)',
     //  "email_currency" => 'char(7)',
	    "cost_per_transaction" => 'decimal(10,2)',
	    "cost_percent_total" => 'decimal(10,2)',
	    "tax_id" => 'smallint(1)',
	    "plg_session_id" => 'varchar(255)',

 
	    "alt_currency" => 'char(3)',
	    "paypal_fullresponse" => "text",
		"paymentId" => 'char(64)',
	 "subscriptionId" => 'char(64)',
	 
	 
	 
	 "total_instalments" => 'int(1) UNSIGNED',
				
	 "immediate_payment" => 'int(1) UNSIGNED',
	 
	 "total_payments" => 'decimal(15,5)',
	 
	 "first_payment" => 'decimal(15,5)',
	 
	 "no_of_monthly_payments" => 'int(1) UNSIGNED',
	 
	 "monthly_payment" => 'decimal(15,5)',
	 
	 "defer_installments" => 'int(16) UNSIGNED',
	 
	 "defer_date" => 'char(16)',
	 
	 "paymentMethod" => 'char(64)',
	 
	 "payment_type" => 'char(64)',
	 
	 "setupFutureUsage" => 'char(64)',
	 
	 "stripe_customer_id" => 'char(64)',

	"token" => 'char(64)',
	 
	"order_seconds" => 'int(1) UNSIGNED'
	);


$db = JFactory::getDBO();

if($this->table_exist('virtuemart_payment_plg_stripessc',0))

{

try
	{
	$columns = $db->getTableColumns('#__virtuemart_payment_plg_stripessc');
		
	if(!isset($columns['token']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_stripessc` ADD COLUMN `token` char(64) AFTER `paymentId`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}
		
		
		if(!isset($columns['defer_installments']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_stripessc` ADD COLUMN `defer_installments` int(1) AFTER `paymentId`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}

// fields to add		
//_virtuemart_payment_plg_stripessc_customers 		
// stripe_customer_id
// vm_email
//	virtuemart_user_id	
		
		
	}
catch (Exception $e)
	{
	echo '01:';
	echo $e->getMessage();
	}
}





/*

if($this->table_exist('virtuemart_payment_plg_stripessc_customers',0))

{

try
	{
	$columns = $db->getTableColumns('#__virtuemart_payment_plg_stripessc_customers');
		
	if(!isset($columns['first_name']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_stripessc_customers` ADD COLUMN `first_name` char(127) AFTER `vm_email`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}
		
	if(!isset($columns['last_name']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_stripessc_customers` ADD COLUMN `last_name` char(127) AFTER `first_name`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}		

		
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}
	
	//		
}






if($this->table_exist('virtuemart_payment_plg_stripessc_customers',0))

{

try
	{
	$columns = $db->getTableColumns('#__virtuemart_payment_plg_stripessc_customers');
		
	if(!isset($columns['first_name']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_stripessc_customers` ADD COLUMN `first_name` char(127) AFTER `vm_email`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}
		
	if(!isset($columns['last_name']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_stripessc_customers` ADD COLUMN `last_name` char(127) AFTER `first_name`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}		

		
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}
	
	//		
}

*/

/*

try {
	

	$q = 'DROP TABLE`#__virtuemart_payment_plg_stripessc_customers`';
	
	echo '---------------';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		
		
		$q = 'DROP TABLE`#__virtuemart_payment_plg_stripessc_products`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();

} catch (Exception $ex) {
	
	echo $ex;
	
}


*/















//load scripts after jQuery or perhaps VP core.js?


	return $SQLfields;
    }




function plgVmConfirmedOrder($cart, $order)
{

//error_reporting(-1);
	
	#print_r($_POST);
	#print_r($_GET);

$db = JFactory::getDbo();

//$param_get = J Request::get('get');


$jinput =JFactory::getApplication()->input;
	 
$param_get['ecocheckout'] = $jinput->get->get('ecocheckout', null, 'CMD');


$eco=0;

if (isset($param_get['ecocheckout']))
	{
	$eco=1;
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	}
else
	{
	if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
		{
		return null; // Another method was selected, do nothing
		}
	}	
	
if (!$this->selectedThisElement($method->payment_element))
	{
	return false;
	}
	
	
	$html='';
	$state='';
	$country='';
	$session = JFactory::getSession();
	$return_context = $session->getId();
	$this->_debug = $method->debug;
	
	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	if (!class_exists('VirtueMartModelCurrency'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'currency.php');

	$new_status = '';

	$address = $order['details']['BT'];
	$del_address = null;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }


if($eco == 0)
	{
	if(method_exists($this,'setInConfirmOrder'))
		{
		//$this->setInConfirmOrder($cart); //xxx    //??? double order check $_cart->_inConfirm ???
		}
	//$html .= ' Set Inconfirmed<br>';	//$html .= ' Set Inconfirmed<br>';
	//echo ' Set Inconfirmed<br>';
	
   if (!class_exists('TableVendors'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'table' . '/' . 'vendors.php');
	$vendorModel = new VirtueMartModelVendor();
	$vendorModel->setId(1);
	$vendor = $vendorModel->getVendor();
	$vendorModel->addImages($vendor, 1);
	
	
	$extension_id='17';	
	
	try
	{	 
	$db = JFactory::getDBO();
	$query =
	"SELECT " . $db->quoteName('virtuemart_userfield_id') .
	" FROM " . $db->quoteName('#__virtuemart_userfields') .
	" WHERE " . $db->quoteName('name') ." = " . $db->quote('virtuemart_state_id').";";
	$db->setQuery($query);
	$extension_id = $db->loadResult();
	}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}

	try
	{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	$fields = array($db->quoteName('required') . '=1');
	//$conditions = array($db->quoteName('name') . '=' . 'virtuemart_state_id');
	$conditions = array($db->quoteName('virtuemart_userfield_id') . '=' . $extension_id);  //set user fields back to required
	$query->update($db->quoteName('#__virtuemart_userfields'))->set($fields)->where($conditions);
	$db->setQuery($query);
	//$result = $db->query();
	$result = $db->execute();
	}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}
	
	
	}


	$this->getPaymentCurrency($method); //?????

	
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();
	
	$processor_currency_code_3 = $currency_code_3;
	
	//$method->ssc_multi_currency=0;
	
	if($method->ssc_multi_currency)
		{
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $cart->pricesCurrency . '" ';
		
		$db->setQuery($q);
		$processor_currency_code_3 = $db->loadResult();
		}

	$dp=2;
	
	if($processor_currency_code_3 == 'JPY')
		{
		$dp=0;
		}
//echo '------------';
//echo $processor_currency_code_3;
//echo '+++++++++++++';

	if (!class_exists('CurrencyDisplay'))
   require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');


	$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
	$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
	
	if($eco == 0)
	{
	$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total,false), $dp);
	// Prepare data that should be stored in the database
	$dbValues["order_number"] = $order["details"]["BT"]->order_number;
	$dbValues["payment_name"] = $this->renderPluginName($method, $order);
	$dbValues["virtuemart_paymentmethod_id"] = $cart->virtuemart_paymentmethod_id;
	$dbValues["plg_session_id"] = $return_context;
	$dbValues["cost_per_transaction"] = $method->cost_per_transaction;
	$dbValues["cost_percent_total"] = $method->cost_percent_total;
	
	$dbValues["payment_currency"] = $method->payment_currency;
	
//	$dbValues["payment_currency"] = $method->prices_currency;
		
	$dbValues["currency_code"] = $currency_code_3;
	
	//$method->ssc_multi_currency=0;
	
	if($method->ssc_multi_currency)
		{
		$dbValues["alt_currency"] = $cart->pricesCurrency;
		}
	else
		{
		$dbValues["alt_currency"] = $method->payment_currency;
		}
	
	$dbValues["payment_order_total"] = $totalInPaymentCurrency;
	$dbValues['tax_id'] = $method->tax_id;
	$this->storePSPluginInternalData($dbValues);
	}

$invoice_num='';

if($eco == 0)
	{
	if(isset($order["details"]["BT"]->order_number))
		{
		$invoice_num = $order["details"]["BT"]->order_number;
		}
	
	$session = JFactory::getSession();
	//$session->set('session_token', $token);

	$session_token = $session->get('session_token');
	$session_PayerID = $session->get('session_PayerID');

	if(is_null($session->get('session_token')))
		{
		//echo 'Session Token is null<br/>';
		}
	else
		{
		//echo 'Session Token ' . $session_token . '<br/>';
	
	//	$ret = $this->doexpress($session_token,$session_PayerID,$invoice_num);
	
		$session->set('session_token', null);
		$session->set('session_PayerID', null);
		$session->set('session_ssc_total', null);

		return $ret;	
		}

	}

$description 	= "";
$label 			= "Submit Payment"; // The is the label on the "submit" button


$loginID = "";

$product_des = "";
$short_product_des = "";

$order_form_line_item='';
$br = "\n";	

$currency_type = '0';

//if($method->ssc_multi_currency)
//	{
	$currency_type = $cart->pricesCurrency;
//	}
//else
//	{
//	$currency_type = $method->payment_currency;
//	}

$pppitems = array();

if($order)
	{
	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$currency_type);
	}
else
	{
	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form_cart($order,$method,$currency_type);
	}

$country = '';
$cc_state = '';
$del_country = '';
$del_state = '';
$del_state_name = '';
$cc_country='';

if($eco == 0)
{
	
$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


if($country === 'US' || $del_country === 'CA')
  {
  $cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id,"state_2_code") : "";
  }


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
$del_state_name = $del_state;
// possible bug
if($del_country === 'US' || $del_country === 'CA')
  {
  $del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id,"state_2_code") : "";
  }

//list($order_form,$order_form_html_billing) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);


//// new custom field 23-11-11
$pro_shipping = urlencode("Overland");
////#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"];

$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");


#if(isset($method->ssc_localecode) &&  $method->ssc_localecode != '-')
#	{
	//$cc_country = $method->ssc_localecode;
#	}

$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
}



if($eco == 0)
	{
	$ReturnURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&e=0');
	$CancelURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . urlencode($order['details']['BT']->order_number) . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);
	}
else
	{
	$ReturnURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&e=1');
	$CancelURL = $this->https_check(JURI::root() . 'index.php');
	}




############# Begin Rest V2 ######################


	$virtuemart_order_id = $order['details']['BT']->virtuemart_order_id;


	date_default_timezone_set('UTC');
	$zulu = date("Y-m-d\TH:i:s\Z");

	#echo '<div style="font-size: x-large;text-align: center" id="log_ssc">' . vmText::_('COM_VIRTUEMART_CART_SELECTPAYMENT') . '</div><br>';
	

	
	

	///// start recurring code imported from paypal pro 3d
	$i = 1;
$line_desc='';
$sub_line_desc='';
$first_profile = 0;

$use_profile=0;
$this_profile=0;

$profile_trig = 0;
$no_profile_trig = 0;
$recurring=0;
$pplan=0;

$profile_error=0;


//$method->ssc_pplan_BILLINGPERIOD
//$method->ssc_BILLINGPERIOD
//$method->ssc_TRIALBILLINGPERIOD
//None
$PPlan = $method->ssc_pplan_id;
#echo $PPlan;


foreach ($order["items"] as $key => $product)
	{
	$line_desc .= substr(strip_tags($product->order_item_name), 0, 127);
	$sub_line_desc = $line_desc;
	
	$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
	
//	if ((preg_match("/Day/i",$line_id)) || (preg_match("/Week/i",$line_id)) || (preg_match("/Month/i",$line_id)) || (preg_match("/SemiMonth/i",$line_id)) || (preg_match("/Year/i",$line_id)))
//		{
	if((preg_match("/Recurring/i",$line_id)) || (preg_match("/Month/i",$line_id)) || (preg_match("/$PPlan/i",$line_id)))
		{
	
		


		if(preg_match("/$PPlan/i",$line_id))
			{
			///rm
			if($method->ssc_pplan_BILLINGPERIOD != 'None')
				{
				$use_profile=1;
				$profile_trig = 1;
				$pplan=1;
				}
			}
		
	  
	

  	//	if (preg_match("/Day/i",$line_id))
	//		{
	//		$billing_period = 'Day';
	//		}
			
	//	if (preg_match("/Week/i",$line_id))
	//		{
	//		$billing_period = 'Week';
	//		}

	//	if (preg_match("/SemiMonth/i",$line_id))
	//		{
	//		$billing_period = 'SemiMonth';
	//		}

	//	if (preg_match("/Year/i",$line_id))
	//		{
	//		$billing_period = 'Year';
	//		}
	
	   
		}
	else
		{
		$no_profile_trig = 1;
		}
	
	
	if($no_profile_trig == 1 && $profile_trig == 1)
		{
		$profile_error=1;
		}

	//echo '--this:' . $this_profile . '++first' . $first_profile . '===';
	$i++;
	}
	
	
	
	
	
	
//$line_desc = substr($line_desc . $method->payment_name, 0, 127);

$line_desc = substr($method->payment_name . '-' . $line_desc, 0, 126);

//echo "******Debug Pro end" . $method->ssc_BILLINGPERIOD ." *********";



date_default_timezone_set('UTC');

$zulu = date("Y-m-d\TH:i:s\Z");

if($method->ssc_one_page == '0')
	{
	//JHtml::_('jquery.framework');
	$document = JFactory::getDocument();
	$document->addScript('https://js.stripe.com/v3/');

	$url = JURI::root() . "plugins/vmpayment/stripessc/checkout.css";
	$document->addStyleSheet($url);

	//$this->show_order_buttons($method,$order,$currency_code_3,$virtuemart_order_id,$del_address,$zulu);
	$this->show_order_buttons($method,$order,$currency_code_3,$virtuemart_order_id,$use_profile);
	}
 else {
	 
	 
		
	
	$source='JS';
	
	$order_rank=0;
	
	if($pplan == 1)
		{
		$order_rank=1;
		}
		
		
	$confirmation_token_id = $jinput->get->get('confirmationTokenId', null, 'CMD');
	

		
		
	if ($confirmation_token_id)
	   {
//echo 'Confirmation id: ' . $confirmation_token_id;			

$INITAMT=0;

$installment=0;

$button_url='';

list($table,$return_button,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$rest_line_items,$req,$line_items_total,$INITAMT,$installment) = $this->order_form_checkout($order,$method,$button_url);
	
		if($method->ssc_pplan_BILLINGPERIOD != 'None' && $use_profile == 1 && $INITAMT > 0)
			{
			$order_total=$INITAMT;
			}
	
		
$account_id = $method->ssc_ssc1;
$secret_key = $method->ssc_ssc2;
//$merchant_id = $method->ssc_merchant_id;


if($method->ssc_environment == "sandbox")
   {
	$account_id = $method->ssc_ssc1_sb;
	$secret_key = $method->ssc_ssc2_sb;
	//$merchant_id = $method->ssc_sb_merchant_id;
   }
	
$account_id = trim($account_id);
$secret_key = trim($secret_key);	 
		 

require_once __DIR__  . '/stripe-php/init.php';
$stripe = new \Stripe\StripeClient(
  $secret_key
);
		//pi_3OkCQnGhPg0yig8B1MFR6

	\Stripe\Stripe::setApiKey($secret_key);
	
	$total = round($order_total*100);


//	$payment_intent = $stripe->paymentIntents->retrieve($payment_intent_id, []);
//	echo $payment_intent->payment_method;

$html_pplan = '';
$no_of_monthly_payments = '1';

$stripe_customer_id = $this->retrieve_stripe_customer_id($method,$order,$cart);

if($order)	
	{
	$button_url = '';
		
	list($table,$return_button,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$rest_line_items,$req,$line_items_total,$INITAMT,$installment) = $this->order_form_checkout($order,$method,$button_url);
	
	list($html_pplan,$use_profile,$profile_error,$first_payment_html,$INITAMT,$installment,$no_of_monthly_payments) = $this->get_payment_name($method,$order_total,$order);
	
	if($method->ssc_pplan_BILLINGPERIOD != 'None' && $use_profile == 1 && $INITAMT > 0)
		{
		$order_total=$INITAMT;
		}

	}
else
	{

	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$pppitems,$rest_line_items,$line_items_total) = $this->order_form_cart(null,$method,$currency_type);
	
	$INITAMT=0;
	$installment=0;

	list($html_pplan,$use_profile,$profile_error,$first_payment_html,$INITAMT,$installment,$no_of_monthly_payments) = $this->get_payment_name($method,$order_total,null);

	// requires rechecking	

	if($method->ssc_pplan_BILLINGPERIOD != 'None' && $use_profile == 1 && $INITAMT > 0)
		{
		$order_total=$INITAMT;
		}
	}
			
	if($method->debug)
		{
		echo '<br>Order Total Order: ';
		echo $order_total;
		echo '<br>Line Order Total:';
		echo $line_order_total;
		echo '<br>Total Discount: ';
		echo $total_discount;
		echo '<br>Total Tax: ';
		echo $total_tax;
		echo '<br>Total Shipping: ';
		echo $total_shipping;
		echo '<br>Line Items Total: ';
		echo $line_items_total;
		echo '<br>';
		echo $rest_line_items;
		echo '<br>';
		}			
			
		
#### get Stripe Product ID #################

###############################
###############################
		
		
		
			if($order)
		{
		$address = $order['details']['BT'];
		
		$cc_name = trim($address->first_name) . ' ' . trim($address->last_name);
		$first_name = trim($address->first_name);
		$last_name = $address->last_name;
		$cc_address_line_1 = $address->address_1;
		$cc_address_line_2 = $address->address_2;
		//$admin_area_2 = $address->city;
		$cc_city = $address->city;
		$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, 'country_2_code');
		$cc_postal_code = $address->zip;
		$cc_phone = $address->phone_1;
		$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";	
		$cc_email = $address->email;
		
		
		$del_address = $order['details']['BT'];

		if($order['details']['BT']->STsameAsBT == 0)
			{
			$del_address = $order['details']['ST'];
			}
	
		
		$del_recipient_name = $del_address->first_name . ' ' . $del_address->last_name;
		$del_address_line_1 = $del_address->address_1;
		$del_address_line_2 = $del_address->address_2;
		$del_admin_area_2 = $del_address->city;
		$del_city = $del_address->city;
		$del_country_code = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, 'country_2_code');
		$del_postal_code = $del_address->zip;
		$del_phone = $del_address->phone_1;
		$del_state = isset($del_address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
		
		
		}
else
{		
		
		//$cart = VirtueMartCart::getCart ();
		//$cart->prepareCartData(); //xxx
		//$cart->getCartPrices();
		
		$address = $cart->BT;
	
//		$cart->STsameAsBT = 1;
			
		$cart_country = '';
		$cart_state = '';

		$cart_country = ShopFunctions::getCountryByID($address['virtuemart_country_id'], "country_2_code");
		$cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id']) : "";

		if($cart_country === 'US' || $cart_country === 'CA')
		  {
		  $cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id'],"state_2_code") : "";
		  }
				
		$cc_name = trim($address['first_name']) . ' ' . trim($address['last_name']);
		$first_name = trim($address['first_name']);
		$last_name = trim($address['last_name']);
		
		$cc_address_line_1 = $address['address_1'];
		$cc_address_line_2 = $address['address_2'];
		//$admin_area_2 = $address['city'];
		$cc_city = $address['city'];
		$cc_country = $cart_country;
		$cc_postal_code = $address['zip'];
		$cc_phone = $address['phone_1'];
		$cc_state = $cart_state;
		$cc_email = $address['email'];
		
		$del_address = $cart->getST();
		
		$del_cart_country = ShopFunctions::getCountryByID($del_address['virtuemart_country_id'], "country_2_code");
		$del_cart_state = isset($del_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($del_address['virtuemart_state_id']) : "";
		
		$del_recipient_name = $del_address['first_name'] . ' ' . $del_address['last_name'];
		$del_address_line_1 =  $del_address['address_1'];
		$del_address_line_2 =  $del_address['address_2'];
		$del_admin_area_2 = $del_address['city'];
		$del_city = $del_address['city'];
		$del_country_code = $del_cart_country;
		$del_postal_code = $del_address['zip'];
		$del_phone = $del_address['phone_1'];
		$del_state = $del_cart_state;
		
		
	
		}
		


$description = trim($this->description($cart,$method));

$order_number = $order["details"]["BT"]->order_number;

$description = $order_number . ' (1 / ' .  $no_of_monthly_payments . ') ' . $description;
//$description = $order_number . ' 1/' .  $no_of_monthly_payments . ' ' . $description;

if(strlen($description) > 349)
	{
	$description = substr($description,0,348);
	}

//$description = str_pad($description, 600, "-=", STR_PAD_LEFT);	

$order_total = round($order_total*100);

$application_fee_percent = $method->ssc_application_fee_percent;

$application_fee_percent = ($order_total/100)*$application_fee_percent;

$application_fee_percent = number_format($application_fee_percent,0,'.','');

$setup_future_usage = "off_session";


//off_session or on_session or null

	//$payment_intent = $stripe->paymentIntents->retrieve($payment_intent_id, []);
			
		//	echo $payment_intent->payment_method;

$return_url = JURI::root() . "index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&order_number=" . urlencode($order_number);

	if($method->ssc_enable_conected_payments)
		{
		$paymentIntent = $this->connected_payments($method,$application_fee_percent,$order_total,$currency_code_3,$description,$use_profile,$stripe_customer_id,$confirmation_token_id,$setup_future_usage,$order_number,$return_url);
		}
	else
		{
		$paymentIntent = $this->non_connected_payments($method,$application_fee_percent,$order_total,$currency_code_3,$description,$use_profile,$stripe_customer_id,$confirmation_token_id,$setup_future_usage, $order_number,$return_url);
		}
		


		

if(isset($paymentIntent->next_action->redirect_to_url->url))
	{    
	$url = $paymentIntent->next_action->redirect_to_url->url;

	$js = "window.location = '$url';";
		 

	if(!$method->debug)
		{
		print '<script type="text/javascript">';
		echo $js;
		print '</script>';
		}
	} 
		 
		 
		 	}
		 
		 
		 
		 
		 
		 
		 
		 
		 
		 

    $stripe_intent_json = json_encode($paymentIntent);
	 

	 
		 $publishable_key='';
		 
	if($paymentIntent->status === 'succeeded')
		{
		 
		$this->add_stripe_payment_intent($paymentIntent->id, $stripe_intent_json, $order_number,$publishable_key);
	//$this->add_stripe_payment_intent($paymentIntent->id, $stripe_intent_json, $order_number,$publishable_key,$get_data['payment_no']);
		 
		   	    
	      
	 	
			
		
	$this->process_stripe_payment($paymentIntent,$source,$order["details"]["BT"]->order_number,$html_pplan);	
	
		}
 else
 
 {

		
		echo 'We have been unable to process this payment <br><br><br> This payment has not been processed. Your card has not been charged.';	
		
	echo '
		
<br><br>
		<input
    action="action"
    onclick="window.history.go(-2); return false;"
    type="submit"
    value="Click to Return"
/>
		';
		
	
		
		}

}

	echo $this->hidessc();
	
	return;


	



}



/*

	if($method->ssc_enable_conected_payments)
		{
		$paymentIntent = $this->connected_payments($method,$application_fee_percent,$order_total,$currency_code_3,$description,$use_profile,$stripe_customer_id,$confirmation_token_id,$setup_future_usage);
		}
	else
		{
		$paymentIntent = $this->non_connected_payments($method,$application_fee_percent,$order_total,$currency_code_3,$description,$use_profile,$stripe_customer_id,$confirmation_token_id,$setup_future_usage);
		}
		
	
*/

function connected_payments($method,$application_fee_percent,$order_total,$currency_code_3,$description,$use_profile,$stripe_customer_id,$confirmation_token_id,$setup_future_usage,$order_number,$return_url)

{

try {
	

		if($method->debug)
			{
			echo '#Application Fee:';
			echo $application_fee_percent;
			}
			
		
	if($method->ssc_pplan_BILLINGPERIOD == 'None' || $use_profile == 0)
			{

		
	//echo '1111111111111111111111111111111111111111111';
		
			$paymentIntent = \Stripe\PaymentIntent::create([
				"amount" => $order_total,
				"currency" => "$currency_code_3",
				"description" => "$description",
		'customer' => $stripe_customer_id,
    "automatic_payment_methods" => ["enabled" => true],
//	"customer" => $stripe_customer_id,
//    "payment_method" => $payment_method,
    "return_url" => $return_url,
"use_stripe_sdk" => false,
	"confirmation_token" => $confirmation_token_id,
    "confirm" => true,
				  
			"application_fee_amount" => $application_fee_percent,
			 	"metadata"=> ["invoice"=> $order_number,"payment_no"=> "1"]
				 
    ],
					  
		  ["stripe_account" => $method->ssc_connected_account_id],		  
					  
					  );
			


		}
		else
		{
			//	echo '22222222222222222222222222222222222222222222222222222';	
				
					//if($method->ssc_enable_conected_payments)
	//	{
			
		$paymentIntent = \Stripe\PaymentIntent::create([
        "amount" => $order_total,
        "currency" => "$currency_code_3",
			"description" => "$description",
		  "setup_future_usage" => "$setup_future_usage",
    'automatic_payment_methods' => ['enabled' => true],
	'customer' => $stripe_customer_id,
//    'payment_method' => $payment_method,
    'return_url' => $return_url,
			 "use_stripe_sdk" => false,
  //  'off_session' => false,
	'confirmation_token' => $confirmation_token_id,
    'confirm' => true,
	"application_fee_amount" => $application_fee_percent,
			 	"metadata"=> ["invoice"=> $order_number,"payment_no"=> "1"]
	],
		  ["stripe_account" => $method->ssc_connected_account_id]			  			  
			  
				  );	
		
		}
		
		
		
		
		
		
		
		
		
			/*
				$payment_method = \Stripe\PaymentMethod::create([
  'customer' => $stripe_customer_id,
  'payment_method' => $paymentIntent->payment_method],
['stripe_account' => $method->ssc_connected_account_id,]);
	*/
		
	
/*	
$connected_customer = $stripe->customers->create
(
  ['payment_method' => $payment_method
],
  ['stripe_account' => $method->ssc_connected_account_id
]
);
*/			

			
	$output = [
        "clientSecret" => "$paymentIntent->client_secret",
    ];	
			
			
			
	
		return $paymentIntent;
		
	
	 

	 
} catch (Error $e) {
   // http_response_code(500);
    echo json_encode(['error' => $e->getMessage()]);
}
		
		return null;
}


function non_connected_payments($method,$application_fee_percent,$order_total,$currency_code_3,$description,$use_profile,$stripe_customer_id,$confirmation_token_id,$setup_future_usage,$order_number,$return_url)
{
	//	echo '3333333333 non_connected_payments one off payment';
	
try {
	

		 
		 // Create a PaymentIntent with amount and currency
		
	if($method->ssc_pplan_BILLINGPERIOD == 'None' || $use_profile == 0)
			{
		
		
			$paymentIntent = \Stripe\PaymentIntent::create([
				"amount" => $order_total,
				"currency" => "$currency_code_3",
				"description" => "$description",
    'automatic_payment_methods' => ['enabled' => true],
	'customer' => $stripe_customer_id,
//    'payment_method' => $payment_method,
    'return_url' => $return_url,
'use_stripe_sdk'=> false,
	'confirmation_token' => $confirmation_token_id,
    'confirm' => true,
	"metadata"=> ["invoice"=> $order_number,"payment_no"=> "1"]
    ]);


		}
		else
		{
	//				echo '4444444 non_connected_payments installments payment';
			
			
			try
			{
			
		$paymentIntent = \Stripe\PaymentIntent::create([
        "amount" => $order_total,
        "currency" => "$currency_code_3",
			 	"description" => "$description",
		  "setup_future_usage" => "$setup_future_usage",
    'automatic_payment_methods' => ['enabled' => true],
	'customer' => $stripe_customer_id,
//    'payment_method' => $payment_method,
    'return_url' => $return_url,
			 'use_stripe_sdk'=> false,
//   'off_session' => false,
	'confirmation_token' => $confirmation_token_id,
    'confirm' => true,
	"metadata"=> ["invoice"=> $order_number,"payment_no"=> "1"]
		]);	
			
		}
			catch (Exception $e)
				{
				echo $e->getMessage();
				}
		
		}
			
			
			
	$output = [
        "clientSecret" => "$paymentIntent->client_secret",
    ];	
				 
		return $paymentIntent;
	
		
		
		
	 

	 
} catch (Error $e) {
   // http_response_code(500);
    echo json_encode(['error' => $e->getMessage()]);
}
		
	return null;
}





function make_payment_intent_db()
{

$db = JFactory::getDBO();
$query = "CREATE TABLE IF NOT EXISTS `#__virtuemart_payment_plg_stripessc_intents` (
`order_rank` int(11) NOT NULL DEFAULT 0,
`stripe_intent_id` char(128) NOT NULL DEFAULT '',
`stripe_publishable_key` char(128) NOT NULL DEFAULT '',
`vm_order_no` char(128) NOT NULL DEFAULT '',
`vm_email` char(128) NOT NULL DEFAULT '',
`description` text NOT NULL DEFAULT '',
`stripe_intent_json` text NOT NULL DEFAULT '',
`created_on` datetime NOT NULL default '0000-00-00 00:00:00',
`created_seconds` int(11) NOT NULL default 0,
`created_by` int(11) NOT NULL DEFAULT 0,
`modified_on` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`modified_by` int(11) NOT NULL DEFAULT 0,
`locked_on` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`locked_by` int(11) NOT NULL DEFAULT 0,
PRIMARY KEY (`stripe_intent_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
$db->setQuery($query);
$db->query();

}


function add_stripe_payment_intent($stripe_intent_id , $stripe_intent_json,$vm_order_no,$ssc_ssc1,$order_rank=0)
	{
	
	$debug  = '1';
	$email='';
	$description='';
	
	$datetime = new JDate('now');
	
	
	$this->make_payment_intent_db();


	
		//if($debug == '1')
		//	{
		//	echo 'Create new Subscription Id Record' . $stripe_intent_id . '<br>';
		//	}
		
	$db = JFactory::getDbo();
	$q = 'SELECT `stripe_intent_id` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `stripe_intent_id` = "'. $stripe_intent_id . '"';// AND `stripe_publishable_key` = "'. $ssc_ssc1 . '"';
	$db->setQuery($q);

	$id = $db->loadResult();

	
	if(empty($id))
		{		

		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);
		
		$created_seconds = time();
		
		// Insert columns.
		$columns = array('order_rank','stripe_intent_id','stripe_intent_json' , 'stripe_publishable_key', 'vm_order_no', 'vm_email', 'created_on','created_seconds', 'created_by','modified_on','modified_by','locked_on','locked_by');

		// Insert values.
		$values = array($db->quote($order_rank), $db->quote($stripe_intent_id) , $db->quote($stripe_intent_json) , $db->quote($ssc_ssc1), $db->quote($vm_order_no),$db->quote($email),$db->quote($datetime),$created_seconds,0, $db->quote('0000-00-00 00:00:00'),0, $db->quote('0000-00-00 00:00:00'),0);

			
		// Prepare the insert query.
		$query
		->insert($db->quoteName('#__virtuemart_payment_plg_stripessc_intents'))
		->columns($db->quoteName($columns))
		->values(implode(',', $values));
		
		// Set the query using our newly populated query object and execute it.
		$db->setQuery($query);

		$db->execute();                
	
//created_on
		}
		
		else
		{
				if($id !== null)
			{
			try
				{
				$q =  "UPDATE `#__virtuemart_payment_plg_stripessc_intents` SET `stripe_intent_json` = '" . $stripe_intent_json . "' WHERE  `stripe_intent_id` = '" . $id . "'";
	//		echo $q;
			
	//		return;
				$db->setQuery($q);
				$result = $db->execute();
				}
			catch (Exception $e)
				{
					echo '02:';
				echo $e->getMessage();
				}
			}	
		}
		
}

//stripe_customer_id
//stripe_publishable_key
//vm_customer_id


function make_customers_db()
{

$db = JFactory::getDBO();
$query = "CREATE TABLE IF NOT EXISTS `#__virtuemart_payment_plg_stripessc_customers` (
`stripe_customer_id` char(127) NOT NULL DEFAULT '',
`stripe_publishable_key` char(127) NOT NULL DEFAULT '',
`vm_customer_id` char(127) NOT NULL DEFAULT '',
`vm_email` char(255) NOT NULL DEFAULT '',
`first_name` char(127) NOT NULL DEFAULT '',
`last_name` char(127) NOT NULL DEFAULT '',
`created_on` datetime NOT NULL default '0000-00-00 00:00:00',
`created_seconds` int(11) NOT NULL default 0,
`created_by` int(11) NOT NULL DEFAULT 0,
`modified_on` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`modified_by` int(11) NOT NULL DEFAULT 0,
`locked_on` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`locked_by` int(11) NOT NULL DEFAULT 0,
PRIMARY KEY (`stripe_customer_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
$db->setQuery($query);
$db->query();

}


function add_stripe_customer_id($vm_customer_id,$vm_email,$stripe_customer_id,$vm_first_name,$vm_last_name,$ssc_ssc1)
	{
	
	$debug  = '1';

	
	$datetime = new JDate('now');
	
	
	$this->make_customers_db();


	
	//	if($debug == '1')
	//		echo 'Create new Customer Record' . $vm_customer_id . '<br>';
	//		}

			
		$db = JFactory::getDbo();
	$q = 'SELECT `stripe_customer_id` FROM `#__virtuemart_payment_plg_stripessc_customers` WHERE `vm_customer_id` = "'. $vm_customer_id . '" AND `stripe_publishable_key` = "'. $ssc_ssc1 . '"';
	$db->setQuery($q);
	$found = $db->loadResult();

	
	if(empty($found))
		{		
			
			
			
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);
		
		$created_seconds = time();
		
		
		
		//stripe_customer_id
//stripe_publishable_key
//vm_customer_id
		
		$stripe_publishable_key = $ssc_ssc1;

		// Insert columns.
		$columns = array('stripe_customer_id', 'stripe_publishable_key','vm_customer_id', 'vm_email','first_name','last_name', 'created_on','created_seconds', 'created_by','modified_on','modified_by','locked_on','locked_by');

		// Insert values.
		$values = array($db->quote($stripe_customer_id),$db->quote($stripe_publishable_key), $db->quote($vm_customer_id),$db->quote($vm_email),$db->quote($vm_first_name),$db->quote($vm_last_name),$db->quote($datetime),$created_seconds,0, $db->quote('0000-00-00 00:00:00'),0, $db->quote('0000-00-00 00:00:00'),0);
		
		
		// Prepare the insert query.
		$query
		->insert($db->quoteName('#__virtuemart_payment_plg_stripessc_customers'))
		->columns($db->quoteName($columns))
		->values(implode(',', $values));
	
		
		// Set the query using our newly populated query object and execute it.
		$db->setQuery($query);
		$db->execute();                
	
//created_on
		}
}


function make_products_db()
{

$db = JFactory::getDBO();
$query = "CREATE TABLE IF NOT EXISTS `#__virtuemart_payment_plg_stripessc_products` (
`stripe_product_id` char(127) NOT NULL DEFAULT '',
`stripe_publishable_key` char(127) NOT NULL DEFAULT '',
`vm_product_id` text NOT NULL DEFAULT '',
`vm_description` text NOT NULL DEFAULT '',
`created_on` datetime NOT NULL default '0000-00-00 00:00:00',
`created_seconds` int(11) NOT NULL default 0,
`created_by` int(11) NOT NULL DEFAULT 0,
`modified_on` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`modified_by` int(11) NOT NULL DEFAULT 0,
`locked_on` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`locked_by` int(11) NOT NULL DEFAULT 0,
PRIMARY KEY (`stripe_product_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
$db->setQuery($query);
$db->query();

}


//function add_stripe_product_id($virtuemart_product_id,$stripe_product_id,$ssc_ssc1)
function add_stripe_product_id($virtuemart_product_id,$stripe_product_id,$ssc_ssc1)
	{
	
	$debug  = '1';
	$vm_description = '';
	$virtuemart_product_id = trim($virtuemart_product_id);
	$datetime = new JDate('now');
	
	
	$this->make_products_db();


		if($debug == '1')
			{
			echo 'Create new Record' . $virtuemart_product_id . '<br>';
			}

			
		$db = JFactory::getDbo();
		
		
	$q = 'SELECT `vm_product_id` FROM `#__virtuemart_payment_plg_stripessc_products` WHERE `vm_product_id` = '. $db->quote($virtuemart_product_id) . ' AND `stripe_publishable_key` = "'. $ssc_ssc1 . '"';
	
	$db->setQuery($q);
	$vm_product_id = $db->loadResult();


	if(empty($vm_product_id))
		{
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);
		
		$created_seconds = time();
		
		// Insert columns.
		$columns = array('stripe_product_id', 'stripe_publishable_key', 'vm_product_id', 'vm_description', 'created_on','created_seconds', 'created_by','modified_on','modified_by','locked_on','locked_by');

		// Insert values.
		$values = array($db->quote($stripe_product_id), $db->quote($ssc_ssc1), $db->quote($virtuemart_product_id),$db->quote($vm_description),$db->quote($datetime),$created_seconds,0, $db->quote('0000-00-00 00:00:00'),0, $db->quote('0000-00-00 00:00:00'),0);
		
		
		// Prepare the insert query.
		$query
		->insert($db->quoteName('#__virtuemart_payment_plg_stripessc_products'))
		->columns($db->quoteName($columns))
		->values(implode(',', $values));
	
		
		// Set the query using our newly populated query object and execute it.
		$db->setQuery($query);
		$db->execute();                
	
//created_on
		}
}



function retrieve_stripe_id($virtuemart_customer_id,$stripe_id)
	{
	
	//$debug  = '0';	
		
	$this->make_records_db();

	$db = JFactory::getDBO();
	$q = 'SELECT `stripe_customer_id` FROM `#__virtuemart_payment_plg_stripessc_customers` WHERE `vm_customer_id` = "' . $virtuemart_customer_id . '" AND `stripe_publishable_key` = "'. $stripe_id . '"';
	$db->setQuery($q);
	$virtuemart_customer_id = $db->loadResult();


	return $virtuemart_customer_id;
}



function retrieve_vm_customer_id($stripe_customer_id)
	{
	
	//$debug  = '0';	
		
	//$this->make_records_db();

	$db = JFactory::getDBO();
	//$q = 'SELECT `vm_customer_id` FROM `#__virtuemart_payment_plg_stripessc_customers` WHERE `stripe_customer_id` = "' . $stripe_customer_id . '" AND `stripe_publishable_key` = "'. $stripe_id . '"';
	$q = 'SELECT `vm_customer_id` FROM `#__virtuemart_payment_plg_stripessc_customers` WHERE `stripe_customer_id` = "' . $stripe_customer_id . '"';
	$db->setQuery($q);
	$virtuemart_customer_id = $db->loadResult();


	return $virtuemart_customer_id;
}






function show_order_buttons($method,$order,$currency_code_3,$virtuemart_order_id,$use_profile)
{
	require_once __DIR__  . '/stripe-php/init.php';
	
	$this_profile=1;
	$billing_period = '';
	$order_total=0;
	
	$INITAMT=0;
	$installment=0;
	
	$return_button = '';
	

	$account_id = $method->ssc_ssc1;
	
	
$account_id = $method->ssc_ssc1;
$secret_key = $method->ssc_ssc2;
//$merchant_id = $method->ssc_merchant_id;


if($method->ssc_environment == "sandbox")
   {
	$account_id = $method->ssc_ssc1_sb;
	$secret_key = $method->ssc_ssc2_sb;
	//$merchant_id = $method->ssc_sb_merchant_id;
   }
	
$account_id = trim($account_id);
$secret_key = trim($secret_key);
//$merchant_id = trim($merchant_id);

	
	
	
	//if($method->ssc_enable_conected_payments)
	//	{
	//	$account_id = $method->ssc_connected_account_id;
	//	}
	
	
$cart = VirtueMartCart::getCart ();
$cart->prepareCartData(); //xxx
$cart->getCartPrices();

$currency_type = '0';
$currency_type = $cart->pricesCurrency;

#echo $currency_type;




if($order)
	{
	$invoice_num = $order["details"]["BT"]->order_number;
	}
else
	{
	$invoice_num = uniqid();	
	}

///###///###echo $table;





require_once __DIR__  . '/stripe-php/init.php';
$stripe = new \Stripe\StripeClient(
  $secret_key
);

//$accounts = $stripe->accounts->all(['limit' => 3]);
//echo $secret_key;
//`print_r($accounts);


/*
	}
	catch (Exception $e)
		{
		echo $e->getMessage();
		return;
		}
*/
### get Stripe customer address id

$stripe_customer_id = $this->retrieve_stripe_customer_id($method,$order,$cart);


	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$pppitems,$rest_line_items,$line_items_total) = $this->order_form_cart(null,$method,$currency_type);
	
	$INITAMT=0;
	$installment=0;

	list($cart_html,$use_profile,$profile_error,$first_payment_html,$INITAMT,$installment,$no_of_monthly_payments) = $this->get_payment_name($method,$order_total,null);

	// requires rechecking	

	if($method->ssc_pplan_BILLINGPERIOD != 'None' && $use_profile == 1 && $INITAMT > 0)
		{
		$order_total=$INITAMT;
		}

			
	if($method->debug)
		{
		echo '<br>Order Total Order: ';
		echo $order_total;
		echo '<br>Line Order Total:';
		echo $line_order_total;
		echo '<br>Total Discount: ';
		echo $total_discount;
		echo '<br>Total Tax: ';
		echo $total_tax;
		echo '<br>Total Shipping: ';
		echo $total_shipping;
		echo '<br>Line Items Total: ';
		echo $line_items_total;
		echo '<br>';
		echo $rest_line_items;
		echo '<br>';
		}			
			
		
#### get Stripe Product ID #################


	
	$description = trim($this->description($cart,$method));	


/*

//JHtml::_('jquery.framework');
$document = JFactory::getDocument();
$document->addScript('https://js.stripe.com/v3/');


$url = JURI::root() . "plugins/vmpayment/stripessc/checkout.css";
$document->addStyleSheet($url);
*/
$cart = VirtueMartCart::getCart ();

		$address = $cart->BT;
	
//		$cart->STsameAsBT = 1;
			
		$cart_country = '';
		$cart_state = '';

		$cart_country = ShopFunctions::getCountryByID($address['virtuemart_country_id'], "country_2_code");
		$cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id']) : "";

		if($cart_country === 'US' || $cart_country === 'CA')
		  {
		  $cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id'],"state_2_code") : "";
		  }

		$cc_name = trim($address['first_name']) . ' ' . trim($address['last_name']);
	
	//	$first_name = trim($address['first_name']);
	//	$last_name = trim($address['last_name']);
		
	//	$cc_address_line_1 = $address['address_1'];
	//	$cc_address_line_2 = $address['address_2'];
		//$admin_area_2 = $address['city'];
	//	$cc_city = $address['city'];
	//	$cc_country = $cart_country;
	//	$cc_postal_code = $address['zip'];
	//	$cc_phone = $address['phone_1'];
	//	$cc_state = $cart_state;
	//	$cc_email = $address['email'];
		
	//	$del_address = $cart->getST();
	

	
$order_form = '


<form id="payment-form" class="stripe-payment-form">
		  
	<div id="payment-element">
	<!--Stripe.js injects the Payment Element-->
	</div>
		  
	<button class="stripe-button" id="submit">
	<div class="spinner hidden" id="spinner"></div>
	<span id="button-text">' . JText::_('VMPAYMENT_STRIPE_SSC_BUY_NOW') . '</span>
	</button>
		  
	<div id="payment-message" class="stripe-payment-form"></div>
		  
</form>

';



$description = trim($this->description($cart,$method));

	
	\Stripe\Stripe::setApiKey($secret_key);


$order_total = round($order_total*100);


$application_fee_percent = $method->ssc_application_fee_percent;

$application_fee_percent = ($order_total/100)*$application_fee_percent;

$application_fee_percent = number_format($application_fee_percent,0,'.','');

$setup_future_usage = "off_session";


//off_session or on_session or null

$lower_cc3 = strtolower($currency_code_3);


	
	if($method->ssc_pplan_BILLINGPERIOD == 'None' || $use_profile == 0)
		{
			$setup_future_usage = '';

		}
 else 
		{
	 
	 		$setup_future_usage =  "
		setupFutureUsage: 'off_session',
		";
	 
		
		}
		
$js_code = 	"

<script>
var link = document.getElementById('checkoutFormSubmit');
link.style.display = 'none';
";

if(!$method->ssc_enable_conected_payments)
	{
	$js_code .= 	"var stripe = Stripe('" . $account_id . "');";
	}
else
	{
	$js_code .= 	"var stripe = Stripe('" . $account_id . "', {stripeAccount: '". $method->ssc_connected_account_id . "'});";
	}

$js_code .= 	"
const options = {
  mode: 'payment',
  amount: $order_total,
  currency: '$lower_cc3'," .
$setup_future_usage .
 "paymentMethodCreation: 'manual',
  // Fully customizable with appearance API.
  appearance: {/*...*/},
};

// Set up Stripe.js and Elements to use in checkout form
const elements = stripe.elements(options);

// Create and mount the Payment Element
var paymentElement = elements.create('payment');
paymentElement.mount('#payment-element');


";


$cc_name_html = htmlentities($cc_name);

$js_code .= "
	
var form = document.getElementById('payment-form');
var submitBtn = document.getElementById('submit');

var handleError = (error) => {
  var messageContainer = document.querySelector('#payment-message');
  messageContainer.textContent = error.message;
  submitBtn.disabled = false;
}

form.addEventListener('submit', async (event) => {
  // We don't want to let default form submission happen here,
  // which would refresh the page.
  event.preventDefault();
 setLoading(true);

  // Prevent multiple form submissions
  if (submitBtn.disabled) {
    return;
  }

  // Disable form submission while loading
  submitBtn.disabled = true;

  // Trigger form validation and wallet collection
  const {error: submitError} = await elements.submit();
  if (submitError) {
  	  setLoading(false);
    handleError(submitError);

    return;
  }

  // Create the ConfirmationToken using the details collected by the Payment Element
  const {error, confirmationToken} = await stripe.createConfirmationToken({
    elements,
    params: {
      payment_method_data: {
        billing_details: {
          name: \"$cc_name_html\",
        }
      }
    }
  });

  if (error) {
    // This point is only reached if there's an immediate error when
    // creating the ConfirmationToken. Show the error to your customer (for example, payment details incomplete)
	 	  setLoading(false);
    handleError(error);

    return;
  }

  // Now that you have a ConfirmationToken, you can use it in the following steps to render a confirmation page or run additional validations on the server
  //return fetchAndRenderSummary(confirmationToken)
  
//alert(confirmationToken.id);
//console.log(JSON.stringify(confirmationToken));

msg='Please Wait';

jQuery('body').addClass('vmLoading');

if (!jQuery('div.vmLoadingDiv').length)
	{
	jQuery('body').append('<div class=\"vmLoadingDiv\"><div class=\"vmLoadingDivMsg\">' + msg + '</div></div>');
	}


window.location.href = '" . JURI::root() . "index.php?option=com_virtuemart&view=cart&task=confirm&confirm=1&tos=1&confirmationTokenId=' + confirmationToken.id;


});




// Show a spinner on payment submission
function setLoading(isLoading) {
  if (isLoading) {
    // Disable the button and show a spinner
 //   document.querySelector('#submit').disabled = true;
    document.querySelector('#spinner').classList.remove('hidden');
    document.querySelector('#button-text').classList.add('hidden');
  } else {
  //  document.querySelector('#submit').disabled = false;
    document.querySelector('#spinner').classList.add('hidden');
    document.querySelector('#button-text').classList.remove('hidden');
  }
}


</script>
";


/*

const fetchAndRenderSummary = async (confirmationToken) => {
  const res = await fetch('/summarize-payment', {
    method: \"POST\",
    body: JSON.stringify({ confirmation_token_id: confirmationToken.id }),
  });

  const summary = await res.json();

  // Render the summary object returned by your server
};



  const {error, confirmationToken} = await stripe.createConfirmationToken({
    elements,
    params: {
      shipping: {
        name: 'Jenny Rosen',
        address: {
          line1: '1234 Main Street',
          city: 'San Francisco',
          state: 'CA',
          country: 'US',
          postal_code: '94111',
        },
      },
      return_url: 'https://example.com/order/123/complete'
    }
*/

$test_card_number = '';


if($method->ssc_environment == "sandbox")
   {
	$test_card_number = "<br>Test Credit Card Number: 4242424242424242  Amount: " . number_format(($order_total/100),2,'.','') . "<br><br>";
	
	$test_card_number .= "<br>Test 3D Secure Number: 4000002760003184  Amount: " . number_format(($order_total/100),2,'.','') . "<br><br>";
	
	
	}

	return $test_card_number . $order_form . $js_code;	

	
}



function retrieve_stripe_customer_id($method,$order,$cart)
 
{

	
		$account_id = $method->ssc_ssc1;
	
	
$account_id = $method->ssc_ssc1;
$secret_key = $method->ssc_ssc2;
//$merchant_id = $method->ssc_merchant_id;


if($method->ssc_environment == "sandbox")
   {
	$account_id = $method->ssc_ssc1_sb;
	$secret_key = $method->ssc_ssc2_sb;
	//$merchant_id = $method->ssc_sb_merchant_id;
   }
	
$account_id = trim($account_id);
$secret_key = trim($secret_key);
//$merchant_id = trim($merchant_id);

	
if($method->ssc_enable_conected_payments)
	{
	$account_id = $method->ssc_environment . '_' . $method->ssc_connected_account_id;
	}
	

	
	
require_once __DIR__  . '/stripe-php/init.php';

$stripe = new \Stripe\StripeClient(
  $secret_key
);	
	
	//$order = null;
	
	$address = null;
	$del_address = null;	
	
	$first_name = '';
	$last_name = '';
	
	if($order)
		{
		$address = $order['details']['BT'];
		
		$cc_name = trim($address->first_name) . ' ' . trim($address->last_name);
		$first_name = trim($address->first_name);
		$last_name = $address->last_name;
		$cc_address_line_1 = $address->address_1;
		$cc_address_line_2 = $address->address_2;
		//$admin_area_2 = $address->city;
		$cc_city = $address->city;
		$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, 'country_2_code');
		$cc_postal_code = $address->zip;
		$cc_phone = $address->phone_1;
		$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";	
		$cc_email = $address->email;
		
		
		$del_address = $order['details']['BT'];

		if($order['details']['BT']->STsameAsBT == 0)
			{
			$del_address = $order['details']['ST'];
			}
	
		
		$del_recipient_name = $del_address->first_name . ' ' . $del_address->last_name;
		$del_address_line_1 = $del_address->address_1;
		$del_address_line_2 = $del_address->address_2;
		$del_admin_area_2 = $del_address->city;
		$del_city = $del_address->city;
		$del_country_code = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, 'country_2_code');
		$del_postal_code = $del_address->zip;
		$del_phone = $del_address->phone_1;
		$del_state = isset($del_address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
		
		
		}
else
{		
		
		//$cart = VirtueMartCart::getCart ();
		//$cart->prepareCartData(); //xxx
		//$cart->getCartPrices();
		
		$address = $cart->BT;
	
//		$cart->STsameAsBT = 1;
			
		$cart_country = '';
		$cart_state = '';

		$cart_country = ShopFunctions::getCountryByID($address['virtuemart_country_id'], "country_2_code");
		$cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id']) : "";

		if($cart_country === 'US' || $cart_country === 'CA')
		  {
		  $cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id'],"state_2_code") : "";
		  }
				
		$cc_name = trim($address['first_name']) . ' ' . trim($address['last_name']);
		$first_name = trim($address['first_name']);
		$last_name = trim($address['last_name']);
		
		$cc_address_line_1 = $address['address_1'];
		$cc_address_line_2 = $address['address_2'];
		//$admin_area_2 = $address['city'];
		$cc_city = $address['city'];
		$cc_country = $cart_country;
		$cc_postal_code = $address['zip'];
		$cc_phone = $address['phone_1'];
		$cc_state = $cart_state;
		$cc_email = $address['email'];
		
		$del_address = $cart->getST();
		
		$del_cart_country = ShopFunctions::getCountryByID($del_address['virtuemart_country_id'], "country_2_code");
		$del_cart_state = isset($del_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($del_address['virtuemart_state_id']) : "";
		
		$del_recipient_name = $del_address['first_name'] . ' ' . $del_address['last_name'];
		$del_address_line_1 =  $del_address['address_1'];
		$del_address_line_2 =  $del_address['address_2'];
		$del_admin_area_2 = $del_address['city'];
		$del_city = $del_address['city'];
		$del_country_code = $del_cart_country;
		$del_postal_code = $del_address['zip'];
		$del_phone = $del_address['phone_1'];
		$del_state = $del_cart_state;
		
		
	
		}
$user = JFactory::getUser();

	$stripe_customer_id = null;

	$user_id = $user->id;
	
	if($user_id > 1)
		{
		$this->make_customers_db();
		$db = JFactory::getDbo();
		$q = 'SELECT `stripe_customer_id` FROM `#__virtuemart_payment_plg_stripessc_customers` WHERE `vm_customer_id` = "'. $user_id . '" AND `stripe_publishable_key` = "'. $account_id . '"';
		$db->setQuery($q);
		$stripe_customer_id = $db->loadResult();

		if($method->debug)
			{
			echo 'logged in : ';
			echo $user_id;
			}

		}
	else
		{
		$db = JFactory::getDbo();
		$q = 'SELECT `stripe_customer_id` FROM `#__virtuemart_payment_plg_stripessc_customers` WHERE  `vm_customer_id` = "1" AND `vm_email` = "'. $cc_email . '"'					  
			. ' AND `first_name` = "'. $first_name . '"'
			. ' AND `last_name` = "'. $last_name . '" AND `stripe_publishable_key` = "'. $account_id . '"';
		$db->setQuery($q);
		$stripe_customer_id = $db->loadResult();
		
		if($method->debug)
			{
			echo '<br>email : ';
			echo $cc_email;
			echo '<br>stripe id : ';
			echo $stripe_customer_id;
			echo '<br>-------------<br>';
			}
		}
		
	/*
		if($stripe_customer_id !== null)
			{
			try
				{
				$q =  "UPDATE `#__virtuemart_payment_plg_stripessc_customers` SET `vm_customer_id` = \"" . $user_id . '"  WHERE  `vm_customer_id` = "0" AND `vm_email` = "'. $cc_email . '"'
						  
					. ' AND `first_name` = "'. $first_name . '"'
					. ' AND `last_name` = "'. $last_name . '" AND `stripe_publishable_key` = "'. $account_id . '"';
		
				
				$db->setQuery($q);
				$result = $db->execute();
				}
			catch (Exception $e)
				{
				echo '04:';
				echo $e->getMessage();
				}
			}
		
		}
	
	else
		{
		if($method->debug)
			{
			echo '<br>User Found : ' . $stripe_customer_id . '<br>';
			}
		}
*/
	
//'SELECT `payment_params` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';	
	
	if($method->debug)
		{
		echo $stripe_customer_id;
		}

	if($stripe_customer_id === null)
		{

	$address = array(
		"line1" => $cc_address_line_1,
		"line2" => $cc_address_line_2,
		"city" => $cc_city,
		"country" => $cc_country,
		"state" => $cc_state,
		"postal_code" => $cc_postal_code
		);
	
	
	
	
		if($method->ssc_enable_conected_payments)
			{
			//['stripe_account' => trim($method->ssc_connected_account_id)]
         	if($method->debug){echo 'create customer';}

	try{
		$customer = $stripe->customers->create(
			[
			'description' => 'VM Customer: ' . $user->id,
			"address" => $address,
			"name" => $cc_name,
			"phone" => $cc_phone,
			"email" => $cc_email,
			],
			['stripe_account' => trim($method->ssc_connected_account_id)]);
		
			if($method->debug){echo $customer->id;}
		}
	catch (Exception $e)
		{
		echo '05:';
		echo $e->getMessage();
		return;
		}
		}
	else
	
//		{		
		try{
		$customer = $stripe->customers->create([
		'description' => 'VM Customer: ' . $user->id,
		"address" => $address,
		"name" => $cc_name,
		"phone" => $cc_phone,
		"email" => $cc_email,
		]);
		}
		catch (Exception $e)
		{
		echo '06:';
		echo $e->getMessage();
		return;
		}		
					
			
//		}
			
			
	
			
			

	#print_r($cart->BT);
	#print_r($order['details']['BT']);
	#print_r($customer);

	$stripe_customer_id = $customer->id;

$this->add_stripe_customer_id($user_id,$cc_email,$stripe_customer_id,$first_name,$last_name,$account_id);
	
	
	}

return $stripe_customer_id;	
	
	}


function description($cart,$method)

{
$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);

$cart = VirtueMartCart::getCart ();

$product_des = "";
$short_product_des = "";
$currency_symbol = '';
//iso-8859-1.
//utf8

$br = "\n";	

	  $i = 1;
	  foreach ($cart->products as $key => $product)
	     {
	     $item_name = strip_tags($product->product_name);
   //      $line_description = strip_tags($product->customfields);
	     $id = strip_tags($product->product_sku);
	     $cost = $cart->pricesUnformatted[$key]["salesPrice"];
	     
	     $cost = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $cost, false),2);
//	     $cost = number_format($cost,2,".","");
         $qty = $product->quantity;
	     $product_des .= $id . " " . $item_name . "(" . $qty . "x " . $currency_symbol . $cost . ")" . " ";
	     $short_product_des .= $id . " " . "(" . $qty . "x " . $currency_symbol . $cost . ")" . " ";
         
	     $i++;
	     }
	     
	     	     	     
	  if($cart->pricesUnformatted ["salesPriceShipment"] > 0)
	     {  
	     $shipping = $cart->pricesUnformatted ["salesPriceShipment"];
	     
	     $shipping = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $shipping, false),2);
//	     $shipping =  number_format($shipping,2,".","");
	     $short_product_des .= "Shipping: " . $currency_symbol . $shipping;
	     $product_des .= "Shipping: " . $currency_symbol . $shipping;
          
	     }
	  	  


if(strlen($product_des) >255)
   {
   $product_des = $short_product_des;
   }

$product_des = str_replace('"',"''",$product_des);

return $product_des;
	}


function description_order($order,$virtuemart_order_id)

{
		
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	
	//	$virtuemart_paymentmethod_id = $order_data["pm"];

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);


$product_des = "";
$short_product_des = "";
$currency_symbol = '';
//iso-8859-1.
//utf8	


	  $i = 1;

	  foreach ($order["items"] as $key => $product)
	     {
	     $item_name = substr(strip_tags($product->order_item_name), 0, 127);
	     $id = substr(strip_tags($product->order_item_sku), 0, 127);
	     
	     //$cost = number_format($product->product_item_price,2,'.','');
	     
	     
	     $cost = $product->product_item_price;
	     
	     $cost = $paymentCurrency->convertCurrencyTo($method->payment_currency, $cost, false);
	     
	     $cost = number_format($cost,2,'.','');
	     
	

	     $line = $product->product_subtotal_with_tax;
	     
	     $line = $paymentCurrency->convertCurrencyTo($method->payment_currency, $line, false);
	     
	     $line = number_format($line,2,'.','');
	     

     
	     $qty = $product->product_quantity;
	     
	     $product_des .= $id . " " . $item_name . "(" . $qty . "x " . $currency_symbol . $cost . ")" . " ";
	     $short_product_des .= $id . " " . "(" . $qty . "x " . $currency_symbol . $cost . ")" . " ";
         
	     $i++;
	     }
	     
	
	  	  


if(strlen($product_des) >255)
   {
   $product_des = $short_product_des;
   }

$product_des = str_replace('"',"''",$product_des);

return $product_des;
	}














function order_form_checkout($order,$method,$button_url='')
{


	if (!class_exists('CurrencyDisplay'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');
	$paymentCurrency = CurrencyDisplay::getInstance();



$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$req = array();
$trusted_line_items='';    ## Tracking
$line_order_total = 0;

$inc_tax = 0;

	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {
	     $inc_tax = 1;
	     }

$unit_price = JText::_('VMPAYMENT_STRIPE_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

if (!class_exists('VirtueMartModelCurrency'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'currency.php');

	$this->getPaymentCurrency($method);  // code 0 is default ??
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();


    $q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	//$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_symbol = $db->loadResult();





$background = $method->ssc_order_button_background;
$foreground = $method->ssc_order_button_foreground;

$background = preg_replace("/[^A-Za-z0-9]/", "", $background);
$foreground = preg_replace("/[^A-Za-z0-9]/", "", $foreground);

///index.php?option=com_virtuemart&view=cart

$back = JText::_('VMPAYMENT_STRIPE_SSC_BACK_TO_CART');

if($button_url == '')
	{
	$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=cart');
	
	if(isset($_POST["APIOperation"]))
		{
		$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&update_order');
		}

	//echo 'No Button URL';
	}
else
	{
	$url = $button_url;
	}
	
	$return_button = '';
	
if(!isset($_POST["APIOperation"]))
	{
	$return_button = "<input style=\"background:#$background;color:#$foreground;border-style: solid;border-color:#$background;border-width:6x;border-radius:16px;font-weight:bold;cursor:pointer\" value=\"$back\" name=\"B2\" type=\"button\" onclick=\"window.location.href='$url'\"><br/><br/>";
	}

$table= '<table border="1" width="600" cellspacing="0" cellpadding="2" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_STRIPE_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_STRIPE_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_TOTALS') . '</font></strong></td>
</tr>';


	  $i = 1;

	  foreach ($order["items"] as $key => $product)
	     {
	     $line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
	     $line_id = substr(strip_tags($product->order_item_sku), 0, 127);
	     
	     //$cost = number_format($product->product_item_price,2,'.','');
	     
	     
	     $cost = $product->product_item_price;
	     
	     $cost = $paymentCurrency->convertCurrencyTo($method->payment_currency, $cost, false);
	     
	     $cost = number_format($cost,2,'.','');
	     
	

	     $line = $product->product_subtotal_with_tax;
	     
	     $line = $paymentCurrency->convertCurrencyTo($method->payment_currency, $line, false);
	     
	     $line = number_format($line,2,'.','');
	     

     
	     $qty = $product->product_quantity;
	     
	 
    	
$line_fields='';
    	
if (!empty($product->product_attribute))
	{
	if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'customfields.php');
	$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
	}
	
$strip_line_fields = strip_tags($line_fields);

if($line_fields === '')
	{
	$line_description = substr($line_id, 0, 127);
	}
else
	{
	$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
	}

//$line_description = substr($line_id . $line_fields, 0, 127);
	     
	    $n = $i-1;
	    
	$line_order_details .= 
    "&L_NAME" . "$n=" . urlencode($line_item_name) .
    "&L_NUMBER" . "$n=" . urlencode($line_description) .
    "&L_QTY" . "$n=" . $qty .  
    "&L_AMT" . "$n=" . $cost;
    
   // $req["L_NAME$n"] = $line_item_name;
   // $req["L_NUMBER$n"] = $line_description;
  //  $req["L_QTY$n"] = $qty;
  //  $req["L_AMT$n"] = $cost;
    
   $req["L_NAME" . $n] = $line_item_name; 
	$req["L_DESC" . $n] = substr($strip_line_fields, 0, 127);
	$req["L_SKU" . $n] =  $line_id;
	$req["L_QTY" . $n] =  $qty;
	$req["L_COST" . $n] = $cost;
    
    
    
#trusted1 items   ## Tacking

	//$trusted_line_items .=
	//'<span class="gts-item">' .
	//'<span class="gts-i-name">' . urlencode($line_item_name) . '</span>' .
	//# urlencode($line_description) .
	//'<span class="gts-i-price">' . $cost . '</span>' .
	//'<span class="gts-i-quantity">' . $qty . '</span>' .
	//'</span>'; 
	
	
	/*
	{
            "name": "Product Name 1",
            "unit_amount": {
                "currency_code": "USD",
                "value": "10.00"
            },
        "quantity": "1"
        }
	 */
	
	if($i>1){$trusted_line_items = $trusted_line_items .  ',';}
	
	$trusted_line_items .=
	'{' .
	'"name": ' . json_encode($line_item_name) . ',' .
	# urlencode($line_description) .
		'"unit_amount":  {
					"value": ' . json_encode($cost) . ',
               "currency_code": ' . json_encode($currency_code_3) . '
               
            },' .
		'"quantity": ' . json_encode($qty) .
	'}'; 
	
	
## Tracking End    
    
   $line_order_total += $qty * $cost;
     
     
   $table = $table . '<tr>';    
   
   $table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
   $table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
   $table = $table . '</td>'; 
      
   $table = $table . '<td valign="top" align="right">' . $currency_symbol . $cost . "</td>"; 
      
   $table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
   $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,2,'.','') . '</td>'; 
  
   
// $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' . number_format($line,2,'.','') . '</td>'; 
  
   $table = $table . '</tr>';
    
	     $i++;
	     
	     } 	  
	     	     


//order_payment ???
	  if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
	     {  
	     $order_payment = $order['details']['BT']->order_payment;
	     
         $order_payment = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,2,'.','');
	     
	     $n = $i-1;
	     
         $payment_fee = JText::_('VMPAYMENT_STRIPE_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=" . urlencode($payment_fee) . 
         "&L_NUMBER" . "$n=" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=" . $order_payment;
         
		//	$req["L_NAME$n"] = urlencode($payment_fee);
		//	$req["L_NUMBER$n"] = '';
		//	$req["L_QTY$n"] = 1;
		//	$req["L_AMT$n"] = $order_payment;
			
			
		$req["L_NAME" . $n] =  $payment_fee;
    	$req["L_DESC" . $n] =  '';
    	$req["L_SKU" . $n] =  '';
    	$req["L_QTY" . $n] =  1;
    	$req["L_COST" . $n] =  $order_payment;
			
  
         
         
      // #trusted 2 payment fee  ## Tracking Begin
      //  $trusted_line_items .=
		//	'<span class="gts-item">' .
		//	'<span class="gts-i-name">' . urlencode($payment_fee) . '</span>' .
			# urlencode($line_description) .
		//	'<span class="gts-i-price">' . $order_payment . '</span>' .
		//	'<span class="gts-i-quantity">1</span>' .
		//	'</span>';
## Tracking End
		  
		  	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode($payment_fee) . ',' .
	'"unit_amount":  {
						"value": ' . json_encode($order_payment) . ',
						"currency_code": ' . json_encode($currency_code_3) . '
							},' .
	'"quantity": "1"' .
	'}';
		  
		  
		  
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">' . htmlspecialchars($payment_fee) . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_payment,2,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,2,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,2);

$line_items_total =  $line_order_total;

$shipping = 0;

	if(isset($order['details']['BT']->order_shipment) && $order['details']['BT']->order_shipment > 0)
		{  
	    $shipping = $order['details']['BT']->order_shipment;
	    
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($method->payment_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,2,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,2,'.','') . '</td></tr>';
	    }


//number_format($amount,2,'.','');

//start of surcharge adjustment

$total_tax = 0;

	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {  
	     $total_tax = $order['details']['BT']->order_tax;
	     
	     $total_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $total_tax, false);
	     }
	     
	  if(isset($order['details']['BT']->order_shipment_tax) && $order['details']['BT']->order_shipment_tax > 0)
	     {
         $order_shippment_tax = $order['details']['BT']->order_shipment_tax;
         
         $order_shippment_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_shippment_tax, false);
         
	     $total_tax += $order_shippment_tax;
	     }

	  if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
	     {
         $order_payment_tax = $order['details']['BT']->order_payment_tax;
         
         $order_payment_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_payment_tax, false);
         
	     $total_tax += $order_payment_tax;
	     }

	  
  	if(isset($order['details']['BT']->order_billTaxAmount) && $order['details']['BT']->order_billTaxAmount > 0)
	     {
         $order_bill_tax = $order['details']['BT']->order_billTaxAmount;
         
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     	//	echo 'Order bill tax set ' . $order_bill_tax;
	     	}
	     }

	  
	  
      if($total_tax > 0)
       {
	    $total_tax = number_format($total_tax,2,'.','');
	    
// add surcharge to tax total	    

	    $line_order_total2 = number_format($line_order_total,2,'.','');
		$shipping2 = number_format($shipping,2,'.','');
		$total_tax2 = number_format($total_tax,2,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,2,'.','');

		$cart_order_total2 = $order['details']['BT']->order_total;
		
#### begin convert ####		
$payment_currency = $method->payment_currency;
$cart_order_total2 = $paymentCurrency->convertCurrencyTo($payment_currency,$cart_order_total2,false);
####  end convert  ####			

		$cart_order_total2 = number_format($cart_order_total2,2,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
			//$order_total2 = $cart_order_total2;
			$total_discount2 = number_format($total_discount2,2,'.','');
			    
	    	//if($total_tax-$total_discount2>0)
	    	//	{
	    		$total_tax += $total_discount2;
	    	//	}
	    
	    	}

//end of surchange adjustment


		$table = $table . '<tr>';
		$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,2,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;
//billDiscountAmount

/*
	  if(isset($order['details']['BT']->coupon_discount) && $order['details']['BT']->coupon_discount > 0)
	     {  
	     $total_discount = $order['details']['BT']->coupon_discount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($method->payment_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,2,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Coupon+Discount" . 
         "&L_NUMBER" . "$n=$order->couponCode" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Coupon:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,2,'.','') . '</td></tr>';

	     }
	     
	     
$total_discount = 0;
//billDiscountAmount
	  if(isset($order['details']['BT']->order_billDiscountAmount) && $order['details']['BT']->order_billDiscountAmount >0)
	     {  
	     $total_discount = $order['details']['BT']->order_billDiscountAmount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($method->payment_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,2,'.','');
	     
	     // $total_discount = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $total_discount, false),2);
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Discount" . 
         "&L_NUMBER" . "$n=Discount" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Discount:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,2,'.','') . '</td></tr>';

	     }
*/


$line_order_total = number_format($line_order_total,2,'.','');
$shipping = number_format($shipping,2,'.','');
$total_tax = number_format($total_tax,2,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,2,'.','');


$cart_order_total = $order['details']['BT']->order_total;

#### begin convert ####		
$payment_currency = $method->payment_currency;
$cart_order_total = $paymentCurrency->convertCurrencyTo($payment_currency,$cart_order_total,false);
####  end convert  ####	

$cart_order_total = number_format($cart_order_total,2,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,2,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Discount" . 
         "&L_NUMBER" . "$n=Discount" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=" . $total_discount;
         
    //$req["L_NAME$n"] = 'Discount';
    //$req["L_NUMBER$n"] = 'Discount';
    //$req["L_QTY$n"] = 1;
    //$req["L_AMT$n"] = $total_discount;
    
  // $req["L_NAME" . "$n"] =  'Discount';
  // $req["L_DESC" . "$n"] =  '';
  //  $req["L_QTY" . "$n"] =  '1';
  //  $req["L_COST" . "$n"] =  $total_discount;
  //  $req["L_SKU" . "$n"] =  'Discount';
    
#trusted3 discount ## Tracking
        
 // 	$trusted_line_items .=
//	'<span class="gts-item">' .
//	'<span class="gts-i-name">Discount</span>' .
	# urlencode($line_description) .
//	'<span class="gts-i-price">$total_discount</span>' .
//	'<span class="gts-i-quantity">1</span>' .
//	'</span>';   
	
	
	
	

## Tracking End

 #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
  	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,2,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $adjustment = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $adjustment = number_format($adjustment,2,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Surcharge" . 
         "&L_NUMBER" . "$n=Surcharge" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=" . $adjustment;
        
    //$req["L_NAME$n"] = 'Surcharge';
    //$req["L_NUMBER$n"] = 'Surcharge';
    //$req["L_QTY$n"] = 1;
    //$req["L_AMT$n"] = $adjustment;
    
    $req["L_NAME" . $n] =  'Adjustment';
    $req["L_DESC" . $n] =  'Adjustment';
    $req["L_QTY" . $n] =  '1';
   // $req["L_COST" . $n] =  $total_surcharge;
	$req["L_COST" . $n] =  $adjustment;
	 
    $req["L_SKU" . $n] =  'Adjustment';
        
        
    
 #trusted4 Surcharge ## Tracking
	//    $trusted_line_items .=
	//		'<span class="gts-item">' .
	//		'<span class="gts-i-name">Adjustment</span>' .
	//		# urlencode($line_description) .
	//		'<span class="gts-i-price">$adjustment</span>' .
	//		'<span class="gts-i-quantity">1</span>' .
	//		'</span>';

			  	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode('Ajustment') . ',' .
	'"unit_amount":  {
							"value": ' . json_encode($adjustment) . ',
							"currency_code": ' . json_encode($currency_code_3) . '					
							},' .
	'"quantity": "1"' .
	'}';
		
		
		

        #    urlencode($line_item_name) . //## Tracking End
    
         $line_order_total = $line_order_total + $adjustment;
			
			$line_items_total =  number_format($line_order_total,2,'.','');
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($adjustment,2,'.','') . '</td></tr>';


		 
	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,2,'.','') . '</td></tr>';

 $table .= '</table>';


 if(isset($_POST["APIOperation"]))
	{
	 
	 $table = '';
 }
 
##pplan
$INITAMT=0;
$installment=0;

list($html,$use_profile,$profile_error,$first_payment_html,$INITAMT,$installment,$no_of_monthly_payments) = $this->get_payment_name($method,$order_total,$order);

$table .= $html;


	if(isset($order["details"]["BT"]->order_number))
		{
		$invoice_num = $order["details"]["BT"]->order_number;

		


try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `total_payments` = '" . $order_total   . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}



try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `no_of_monthly_payments` = '" . $no_of_monthly_payments   . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}

		
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `first_payment` = '" . $INITAMT  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e) 
	{
	echo $e->getMessage();
	}
	
	
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `monthly_payment` = '" . $installment  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}
	
$datetime = new JDate('now');
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `created_on` = '" . $datetime  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}


$order_seconds = time();
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `order_seconds` = '" . $order_seconds  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}	


	

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `defer_installments` = '" . $method->ssc_pplan_defer  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}	

	date_default_timezone_set('UTC');
	$t=time();
	$zulu = date("Y-m-d");

	
	$defer_installments = '0';

	if($method->ssc_pplan_defer == '1')
		{
		$zulu = $method->ssc_pplan_defer_date;
		
		$defer_installments = '1';
		}	
			
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `defer_date` = '" . $zulu  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}	
	
	
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `defer_installments` = '" . $defer_installments  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}	
	
	
	
	
	
	
	
		}
		
return array($table,$return_button,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$trusted_line_items,$req,$line_items_total,$INITAMT,$installment);

}

  
function get_payment_name($method,$order_total,$order)
	{
	$html ='';
	$first_payment_html = '';
	
	$INITAMT=0;
	$installment=0;
	
	$no_of_payments=0;
	
	$cart = VirtueMartCart::getCart ();
	
	//print_r($cart);
	
	
	#### begin check #####
	

$use_profile = 0;
$no_profile_trig = 0;
$profile_error=0;
$profile_trig = 0;

//if(!isset($cart->pricesUnformatted["billTotal"]))
//	{	
//	return array($html,$use_profile,$profile_error,$first_payment_html);
//	}

//foreach ($order["items"] as $key => $product)
//	{
	
if($order)
	{
	$products = $order["items"];
	}
else
	{
	if(!isset($cart->pricesUnformatted["billTotal"]))
	{	
	return array($html,$use_profile,$profile_error,$first_payment_html,0,0,0);
	}
	
	$products = $cart->products;
	}

foreach ($products as $key => $product)
	{
	
	if($order)
		{
		$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
		$line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
		}
	else
		{
		$line_id = substr(strip_tags($product->product_sku), 0, 127);
		$line_item_name = substr(strip_tags($product->product_name), 0, 127);
		}
	
	$PPlan = $method->ssc_pplan_id;
	
#echo $PPlan;

	if(preg_match("/$PPlan/i",$line_id))
		{
	
	   $use_profile=1;
		$profile_trig = 1;
		
	
		if(preg_match("/$PPlan/i",$line_id))
			{
			///rm
			if($method->ssc_pplan_BILLINGPERIOD != 'None')
				{
				$use_profile=1;
				$profile_trig = 1;
				$pplan=1;
				}
			}	
			
		}
	else
		{
		$no_profile_trig = 1;
		}
	
	if($no_profile_trig == 1 && $profile_trig == 1)
		{
		$profile_error=1;
		}
			
	}	


//	echo '<br> no profile trig';
//	echo $no_profile_trig;
//	echo '<br> profile trig';
//	echo $profile_trig;
//	echo '<br> profile error';
//	echo $profile_error;
//	echo '<br>';
		

if($use_profile == 0)
	{
	//return array($html,$use_profile,$profile_error,$first_payment_html);
	return array('',$use_profile,$profile_error,'',0,0,0);
	}

	//echo '--this:' . $this_profile . '++first' . $first_profile . '===';
	//$i++;

	
	#### end check ####################
	
	
	
	

	$pplan_INITAMT = $method->ssc_pplan_INITAMT;

	$pplan_BILLINGPERIOD = $method->ssc_pplan_BILLINGPERIOD;
	
	
	// Joomla 2.5 begin

	$pplan_TOTALBILLINGCYCLES = 1;

	if($method->ssc_pplan_TOTALBILLINGCYCLES > 1)
		{
		$pplan_TOTALBILLINGCYCLES = $method->ssc_pplan_TOTALBILLINGCYCLES;
		}

	//$pplan_TOTALBILLINGCYCLES = $method->ssc_pplan_TOTALBILLINGCYCLES;
	
	// Joomla 2.5 end
	
	$pplan_BILLINGFREQUENCY = $method->ssc_pplan_BILLINGFREQUENCY;

		
		
	$no_of_payments = $pplan_TOTALBILLINGCYCLES;
		
		
	if($pplan_INITAMT == '1')
		{
		$no_of_payments = $pplan_TOTALBILLINGCYCLES + 1;
		}
		
		
	date_default_timezone_set('UTC');
	$t=time();
	$zulu = date("Y-m-d");

	if($method->ssc_pplan_defer == '1')
		{
		$zulu = $method->ssc_pplan_defer_date;
		}	
		
		
		
//	$pppitems = array();

if($order_total == 0)
	{
	$order_total = $cart->pricesUnformatted["billTotal"];
	}
	
	$order_total = number_format($order_total ,2,'.','');
		
	//echo '<br>Bill Total: ' . 	$cart->pricesUnformatted["billTotal"];
	//echo '<br>Payment Tax' . 	$cart->pricesUnformatted["paymentTax"];
	//echo '<br>Payment Tax' . 	$cart->pricesUnformatted["paymentValue"];
	//echo '<br>Payment Total' . 	$cart->pricesUnformatted["paymentTotal"];
	//echo '<br>Payment Total: ' . 	$order_total;
	
		
	$order_payment = 0;
	
	
	if(isset($cart->pricesUnformatted["paymentValue"]) && $cart->pricesUnformatted["paymentValue"] > 0)
		{  
		//echo 'a';
		$order_payment = $cart->pricesUnformatted["paymentValue"];
		$order_payment  = number_format($order_payment ,2,'.','');
		}

	if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
		{
		//echo 'b'; 
		$order_payment = $order['details']['BT']->order_payment;
		$order_payment  = number_format($order_payment ,2,'.','');
		}
		
	//echo $order_payment;	
		
	$order_payment_tax = 0;
	
	
	if(isset($cart->pricesUnformatted["paymentTax"]) && $cart->pricesUnformatted["paymentTax"] > 0)
		{
		//echo 'c';
		$order_payment_tax = $cart->pricesUnformatted["paymentTax"];
		$order_payment_tax  = number_format($order_payment_tax ,2,'.','');
		}

	
	
	if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
		{
		//echo 'd'; 
		$order_payment_tax = $order['details']['BT']->order_payment_tax;
		$order_payment_tax  = number_format($order_payment_tax ,2,'.','');
		}
		
		
	//echo $order_payment_tax;

		
	if($order_total > 0)
		{
		$payments = $order_total - $order_payment - $order_payment_tax;// - $pplan_admin_fee;
		
		$installment_cents = $payments/$no_of_payments;
		
		$installment = floor($installment_cents * 100) / 100;
		
	//	$installment = round($installment,2);// * 100) / 100;
		
		$remainer = $payments - ($installment*$no_of_payments);
		
		$INITAMT = $installment + $remainer + $order_payment + $order_payment_tax;
		
		$INITAMT = number_format($INITAMT,2,'.','');
		
		$installment = number_format($installment,2,'.','');
		
				//$this->getPaymentCurrency($method); //?????
/*
echo '<br>';
echo '<br>';
		
echo "Order Total: $order_total";
echo '<br>';
echo "- Order Payment: $order_payment";
echo '<br>';
echo "- Order Payment Tax: $order_payment_tax";
echo '<br>';
echo "= Payments: $payments";
echo '<br>';
echo "No of Payments: $no_of_payments";
echo '<br>';


echo "Installment_cents: $installment_cents";
echo '<br>';
echo "= Installment: $installment";
echo '<br>';
echo "Remainer: $remainer";
echo '<br>';
echo "Initial Amount: $INITAMT";
echo '<br>';
echo "Installment: $INITAMT";
echo '<br>';
		
	echo '<br>';
echo '<br>';	
		
		
	*/	
		
		
		
		
		
$paymentCurrency = 0;

if(isset($cart->paymentCurrency))				
	{
	$paymentCurrency = $cart->paymentCurrency;

	
	
//$method->payment_currency				

$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentCurrency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_symbol = $db->loadResult();

	}
	
if($paymentCurrency === 0)
{
	$currency_symbol = '$';
}	


$payment_due = 1;

if($method->ssc_pplan_BILLINGPERIOD == 'None')
	{
	$payment_due = 0;
	}


		if($pplan_INITAMT == '1')
			{
			$no_of_payments = $pplan_TOTALBILLINGCYCLES + 1;
			$html .= "Pay in $no_of_payments instalments.<br>";
			
			if($payment_due == 1)
				{
				$html .= "First payment of $currency_symbol$INITAMT payable immediately,<br>followed by $pplan_TOTALBILLINGCYCLES $pplan_BILLINGPERIOD" . "ly payments of $currency_symbol$installment starting on the $zulu";
				}
			}
		else
			{
			$html .= "<br>Pay in $pplan_TOTALBILLINGCYCLES instalments of $currency_symbol$installment<br>";
			if($payment_due == 1)
				{
				$html .= "First Payment on $pplan_INITAMT $zulu<br/>";
				}
			}
		}
	else
		{
		if($pplan_INITAMT == '1')
			{
			$no_of_payments = $pplan_TOTALBILLINGCYCLES + 1;
			$html .= "<br>Pay in $no_of_payments instalments.<br>";
			if($payment_due == 1)
				{
				$html .= "First payment payable immediately,<br>followed by $pplan_TOTALBILLINGCYCLES $pplan_BILLINGPERIOD" . "ly payments starting on the $zulu";
				}
			}
		else
			{
			$html .= "<br>Pay in $pplan_TOTALBILLINGCYCLES instalments.<br>";
			if($payment_due == 1)
				{
				$html .= "First Payment on $pplan_INITAMT $zulu<br/>";
				}
			}
	
	}
	
	
	$first_payment_html = "First payment of $currency_symbol$INITAMT ";
	
	if($use_profile == 0)
		{
		$html = '';
		$first_payment_html = '';
		}
	
		
if($method->ssc_pplan_BILLINGPERIOD == 'None')
	{
	$first_payment_html = '';
	$html = '';
	}	
		
		
		
		
	return array($html,$use_profile,$profile_error,$first_payment_html,$INITAMT,$installment,$no_of_payments);


	}
	
	
	function create_access_token($clientId,$secret,$paypal_url)
{
	
	 
$ch = curl_init();


$headers = array(
'Content-type: application/json',
'Accept-Language: en_US'
);

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v1/oauth2/token");
#curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
curl_setopt($ch, CURLOPT_POSTFIELDS, "grant_type=client_credentials");
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);


$result = curl_exec($ch);

if(empty($result))
	echo "Error: No response.";
else
	{
   $json = json_decode($result);
 #  print_r($json);
	$access_token = $json->access_token;
	//	 echo '<br>access_token: ';
	//	 echo $access_token;
	//	 echo '<br>';
	}

curl_close($ch);

return $access_token;
	
}

#curl -X POST https://api-m.sandbox.paypal.com/v1/identity/generate-token \

#-H 'Content-Type: application/json' \

#-H 'Authorization: Bearer <ACCESS-TOKEN>' \

#-H 'Accept-Language: en_US' \
	
	
	function generate_client_token($access_token,$paypal_url)

{
	
	
	$ch = curl_init();
 #CURLOPT_HTTPHEADER, array('Connection: Close'));
$headers = array(
'Content-type: application/json',
'Authorization: Bearer ' . $access_token,
'Accept-Language: en_US'
);

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v1/identity/generate-token");
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
//curl_setopt($ch, CURLOPT_POSTFIELDS, "grant_type=client_credentials");
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

if(empty($result))
	echo "Error: No response.";
else
	{
   $json = json_decode($result);
  # print_r($json);
	 
	$client_token = $json->client_token;
	//echo '<br>client_token:&nbsp;';
	//echo $client_token;
	//echo '<br>';
	}

$client_token = trim($json->client_token);

//	$id_token = $json->id_token;

curl_close($ch);

return $client_token;
	
}















function get_payment_params()
	{
	/*
	virtuemart_paymentmethods

	[virtuemart_paymentmethod_id] =>
	[virtuemart_vendor_id] =>
	[payment_jplugin_id] => 
	[payment_name] => 
	[payment_desc] => 
	[slug] => paypal-plus-ssc
	[payment_element] => stripessc
	[payment_params] => 
	[currency_id] => 
	[ordering] => 
	[shared] =>
	[published] =>
	*/
	$payment_params = null;
	
	$db = JFactory::getDbo();
	$q = 'SELECT `payment_params` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
	
	$db->setQuery($q);
		
	$payment_string = $db->loadResult();
	
	$pairs = explode("|", $payment_string);
		
	foreach ($pairs as $pair)
		{
		if (empty($pair))
			{
			continue;
			}
		
		$temp = explode('=', $pair);
		$payment_params[$temp[0]] = substr($temp[1], 1, -1);
		}

	return $payment_params;
	}
	

function redirectToCart ($msg = NULL)
	{
	if($msg != NULL)
		{
		$session = JFactory::getSession();
		$session->set('ssc_message', $msg);
		}
	else
		{
		$session = JFactory::getSession();
		$session->set('ssc_message', '');
		}

	if (!$msg)
		{
		$msg = vmText::_('VMPAYMENT_PAYPAL_ERROR_TRY_AGAIN');
		}
			
			
	//		$app = JFactory::getApplication();

	//$app->enqueueMessage('Redirect to another page was successful', 'success');
	//$app->redirect(JRoute::_('index.php'));	
	//$this->customerData->clear();
	$app = JFactory::getApplication();
	$app->enqueueMessage($msg,JText::_('VMPAYMENT_STRIPE_SSC_ERROR_CONNECTING_TO_SERVER'));
	//$app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart&Itemid=' . JRequest::getInt('Itemid'), false));
	$app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart', false));
	
	}






function opc_enabled()
	{
	$opc = 0;
	$vp_opc = 0;
	$opc_enabled = 0;

	//VmConfig::loadConfig();
	//$vm_opc = vmConfig::get('oncheckout_opc',"0");
	//	vmConfig::set('oncheckout_opc', true);	
	//
	//if($method->ssc_one_page == '1' && $vm_opc == '0')
	
	$db = JFactory::getDbo();
	//$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'plg_system_opc'");
	//$opc_enabled = $db->loadResult();
	//$opc = $opc_enabled;

	if($opc_enabled != '1')
		{
		$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'VP One Page Checkout'");
		$opc_enabled = $db->loadResult();
		$vp_opc = $opc_enabled;
		}

	if($opc_enabled != '1')
		{
		$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'System - VP One Page Checkout'");
		$opc_enabled = $db->loadResult();
		$vp_opc = $opc_enabled;
		}

	return $opc_enabled;
	}

        
        



function handlePaymentUserCancel ($virtuemart_order_id)
	{
	if ($virtuemart_order_id)
		{
		// set the order to cancel , to handle the stock correctly
		if (!class_exists ('VirtueMartModelOrders'))
			{
			require(VMPATH_ADMIN . '/' . 'models' . '/' . 'orders.php');
			}

		$modelOrder = VmModel::getModel ('orders');
		$order['order_status'] = 'X';
		$order['virtuemart_order_id'] = $virtuemart_order_id;
		$order['customer_notified'] = 0;
		$order['comments'] = vmText::_ ('COM_VIRTUEMART_PAYMENT_CANCELLED_BY_SHOPPER');
		$modelOrder->updateStatusForOneOrder ($virtuemart_order_id, $order, TRUE);
		//$modelOrder->remove (array('virtuemart_order_id' => $virtuemart_order_id));
		}
	}



// return from PayPal
// $cart is null
// $order is null
// find cart in session and make order

function update_cart($token,$PayerID)
{

$db = JFactory::getDbo();
$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
$db->setQuery($q);
$virtuemart_paymentmethod_id = $db->loadResult();
$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);

if($virtuemart_paymentmethod_id == null)
{
return;
}

$session = JFactory::getSession();
$session->set('session_token', $token);
$session->set('session_PayerID', $PayerID);

$session_token = $session->get('session_token');


$APIrequest =
"&TOKEN=" . $token .

"&PAYMENTACTION=" . $method->ssc_payment_action;
//"&IPADDRESS=" . $ipaddress .

//"&RETURNURL=". urlencode($ReturnURL) . urlencode('&pectransid=' . $order["details"]["BT"]->order_number) .
//encode twice

//"&CANCELURL=". urlencode($CancelURL) .

//"&INVNUM=" . urlencode($cart->virtuemart_order_id) .
# new custom field 23-11-11
//"&CUSTOM=" . 
#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"] .

//"&LOCALECODE=" . $cc_country .

//"&CURRENCYCODE=" . $currency_code_3 .
//"&ITEMAMT=" . $line_order_total .
//"&SHIPPINGAMT=" . $shipping .
//"&TAXAMT=" . $total_tax .
//"&AMT=" . $amount .

//"&SHIPTONAME=" . urlencode($del_address->first_name . ' ' . $del_address->last_name) .
//"&SHIPTOSTREET=" . urlencode($del_address->address_1) .
//"&SHIPTOSTREET2=" . urlencode($del_address->address_2) .
//"&SHIPTOSTATE=" . urlencode($del_state) . 
//"&SHIPTOCITY=" . urlencode($del_address->city) . 
//"&SHIPTOZIP=" . urlencode($del_address->zip) .
//"&SHIPTOCOUNTRYCODE=" . urlencode($del_country) .
//"&SHIPTOPHONENUM=" . urlencode($address->phone_1) .


//"&EMAIL=" . urlencode($address->email) .

//$line_order_details .


$httpResponse = $this->PPHttpPost($method,"GetExpressCheckoutDetails", $APIrequest);


//if(isset($httpResponse['AMT']))
//	{
//	$ssc_AMT = urldecode($httpResponse['AMT']);
//	$session->set('session_ssc_AMT', $ssc_AMT);
//	}




// ************* begin mods for save address****************************



$first_name = '';
$middle_name ='';
$last_name = '';
$address_1 = '';
$address_2 = '';
$house_no = '';
$zip = '';
$city = '';
$state_name='';
$state_id='0';
$virtuemart_country_id='';
$phone_1='';
$email = '';

//print_r($httpResponse);

if(isset($httpResponse['FIRSTNAME']))
	{
	$first_name = urldecode($httpResponse['FIRSTNAME']);
	}

if(isset($httpResponse['MIDDLENAME']))
	{
	$middle_name = urldecode($httpResponse['MIDDLENAME']);
	}

if(isset($httpResponse['LASTNAME']))
	{
	$last_name = urldecode($httpResponse['LASTNAME']);
	}


if(isset($httpResponse['FIRSTNAME']) && isset($httpResponse['LASTNAME']))
	{
	if(urldecode($httpResponse['SHIPTONAME']) == urldecode($httpResponse['FIRSTNAME']) . ' ' . urldecode($httpResponse['LASTNAME']))
		{
		$first_name = urldecode($httpResponse['FIRSTNAME']);
		$last_name = urldecode($httpResponse['LASTNAME']);
		}
	else
		{
		$shipToName = explode(' ', urldecode($httpResponse['SHIPTONAME']));
		$first_name = $shipToName[0];
		$last_name = '';
		if (count($shipToName) > 1)
			{
			$last_name = str_replace($first_name . ' ', '', urldecode($httpResponse['SHIPTONAME']));
			}
		}
	}	


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']))
	{
	$address_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']))
	{
	$city = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']);
	}

if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']))
	{
	$zip = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']);
	}
	
	
if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']))
	{
	$cc = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']);
	$virtuemart_country_id = ShopFunctions::getCountryIDByName($cc);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']))
	{
	$state_name = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
	
	
	if(strlen($state_name) === 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_2_code`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_2 = $db->loadResult();
		//echo 'state id 2:' . $state_id_2;

		if(!is_null($state_id_2))
			{
			$state_id = $state_id_2;
			}
		
		//$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
		$city = trim($city);	
		}
	
	if(strlen($state_name) > 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_name`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_3 = $db->loadResult();
		//echo 'state id 3:' . $state_id_3;

		if(!is_null($state_id_3))
			{
			$state_id = $state_id_3;
			}
		else
			{
			$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
			$city = trim($city);	
			}
		}

	}

	
//if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']))
//	{
//	$phone_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']);
//	}

if(isset($httpResponse['PHONENUM']))
	{
	$phone_1 = urldecode($httpResponse['PHONENUM']);
	}


	
if(isset($httpResponse['EMAIL']))
	{
	$email = urldecode($httpResponse['EMAIL']);
	}



/////// begin update_data array

if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
		$cart = VirtueMartCart::getCart();

//$test = array_filter($cart->BT);xx
//$cart->BT['last_name']

$address_type='BT';
$cart->STsameAsBT = 1;
$prefix = '';

//if (!empty($test)) xx
//if($cart->BT <> 0)
if(isset($cart->BT['last_name']))
	{
	$address_type='ST';
	$prefix = 'shipto_';
	$cart->STsameAsBT = 0;
//	echo '********* not empty *******************';
	}
//else
//	{
//	echo '********* empty *******************';
//	}


$update_data = array(
$prefix . 'address_type_name'     => 'PayPal Shipping Address',
$prefix . 'company'               => '',
$prefix . 'title'                 => '',
$prefix . 'first_name'            => $first_name,
$prefix . 'middle_name'           => $middle_name,
$prefix . 'last_name'             => $last_name,
$prefix . 'address_1'             => $address_1,
$prefix . 'address_2'             => $address_2,
$prefix . 'house_no'              => '',
$prefix . 'zip'                   => $zip,
$prefix . 'city'                  => $city,
$prefix . 'virtuemart_country_id' => $virtuemart_country_id,
$prefix . 'virtuemart_state_id'   => $state_id,
$prefix . 'phone_1'               => $phone_1,
$prefix . 'phone_2'               => '',
$prefix . 'fax'                   => '',
$prefix . 'birthday'              => '',
$prefix . 'socialNumber'          => '',
'address_type'                    => $address_type
);

//virtuemart_state_id

if ($address_type === 'BT')
	{
	$update_data['email'] = $email;
	}


/////// end update_data array

///if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
///		$cart = VirtueMartCart::getCart();

//*if ($this->cart->BT == 0 or empty($this->cart->BT))
//* $this->cart->STsameAsBT = 0;
//* $this->cart->setCartIntoSession ();
//* $this->cart->saveAddressInCart($addressST, 'ST', true);
	

$cart->saveAddressInCart($update_data, $update_data['address_type']);

$cart = VirtueMartCart::getCart ();
//$cart->dataValidated = TRUE;
$cart->setCartIntoSession();
//print_r($cart);

////////////////////////


//virtuemart_state_id virtuemart_userfields required
//virtuemart_userfield_id
//virtuemart_country_id
//name=
$extension_id='17';	
	
	try
	{	 
	$db = JFactory::getDBO();
	$query =
	"SELECT " . $db->quoteName('virtuemart_userfield_id') .
	" FROM " . $db->quoteName('#__virtuemart_userfields') .
	" WHERE " . $db->quoteName('name') ." = " . $db->quote('virtuemart_state_id').";";
	$db->setQuery($query);
	$extension_id = $db->loadResult();
	}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}


if($state_id === '' || $state_id == '0')
	{
	try
		{
	
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$fields = array($db->quoteName('required') . '=0');
	
		$conditions = array($db->quoteName('virtuemart_userfield_id') . '=' . $extension_id);
		//	$conditions = array($db->quoteName('name') . '=' . 'virtuemart_state_id');
	
		$query->update($db->quoteName('#__virtuemart_userfields'))->set($fields)->where($conditions);
		$db->setQuery($query);
		//$result = $db->query();
		$result = $db->execute();
		}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}
	
	
	}

$url= $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&amp;view=cart&amp;task=checkout&amp;mes=exp');


//echo '<br>Installed Version: ' . VmConfig::getInstalledVersion() . '<br>';

$ver = VmConfig::getInstalledVersion();
echo '<script type="text/javascript">
document.cookie = "c=1;path=/";
</script>
';


if($ver < '2.9')
	{
	print '
<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '">';
	print "
	<input type='hidden' id='token' name='token' value='$token'/>
	<input type='hidden' name='PayerID' value='$PayerID'/>
	<input type='hidden' id='STsameAsBT' name='STsameAsBT' value='" . $cart->STsameAsBT . "'/>
	<input type='hidden' name='task' value='checkout'/>
	<input type='hidden' name='option' value='com_virtuemart'/>
	<input type='hidden' name='view' value='cart'/>
	<input type='submit' value='Connecting to server: Please wait'/>
	</form>";
	}

//VmConfig::getInstalledVersion();


$url= $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&amp;view=cart&amp;mes=exp');

if($ver >= '2.9')
	{
	print '
	<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '">';

	print "
	<input type='hidden' name='token' value='$token'/>
	<input type='hidden' name='PayerID' value='$PayerID'/>
	<input type='hidden' name='task' value='updatecart'/>
	<input type='hidden' name='option' value='com_virtuemart'/>
	<input type='hidden' name='view' value='cart'/>
	<input type='submit' value='Connecting to server: Please wait'/>
	</form>";
	}
	
//*<input type='hidden' name='checkout' value='1'/>
//*<input type="hidden" name="tos" value="1" />
//*<input name="order_language" value="en-GB" type="hidden">
//<input type='hidden' name='STsameAsBT' value='" . $cart->STsameAsBT . "'/>
//<input type='hidden' name='task' value='updatecart'/> xx

//<input type='hidden' name='customer-comment' value=''/>

//<input type='hidden' name='order_language' value='en-GB'/>
//<input type='hidden' id='token' name='customer_comment' value='$customer_comment'/>

if(!$method->debug)
   {
   print '<script type="text/javascript">';
   print 'document.checkoutForm.submit();';
   print '</script>';
   }

if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>1<br/>";
	echo '</span>';
	//print_r($cart);
	echo("Http Response: " . print_r($httpResponse, true));
	echo '<br/>';
	//print_r($update_data);
	//echo '123***';
	//print_r($httpResponse);
	
	}



echo $this->hidessc();

}


function show_payment_details($httpResponse,$virtuemart_order_id, $orders,$use_profile)

{
	
	$this_profile=1;
	$billing_period = '';
	$order_total=0;
	
$html = '';
	
	
	
	
	$modelOrder = new VirtueMartModelOrders(); 
	
	$order = $modelOrder->getOrder($virtuemart_order_id);	
  
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	//	$virtuemart_paymentmethod_id = $order_data["pm"];

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	$modelOrder = VmModel::getModel("orders");
	
	$order = $modelOrder->getOrder($virtuemart_order_id);	
  
//	$payment = $this->getDataByOrderId($virtuemart_order_id);

//	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
		
		$currency = trim($payment->alt_currency);
		
	$payment_processed = true;
	
	

## update9 end
   
		list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$trusted_line_items) = $this->order_form($order,$method,$currency);
   
		
		
   $thank_you =  "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_STRIPE_SSC_THANK_YOU_FOR_YOUR_ORDER') . "</p><br>";

	
	//print Recurring Payment Details $html_pplan
	/*
   if($this_profile==1)
	{
	$billing_period = trim($method->ssc_pplan_BILLINGPERIOD);	
	list($html_pplan,$use_profile,$profile_error,$first_payment_html) = $this->get_payment_name($method,$order_total,$order);
	}
	*/

	if(trim($method->ssc_receipt_header) != '')
		{
		$html .=  $method->ssc_receipt_header;
		$html .=  '<br/>';
		}
   
	
	//if($method->ssc_show_items == 1)
	//   {
	//	$this->print_order_details($virtuemart_order_id,$method,$method->ssc_show_shipping);
	//	
$html .=  '<br/>';

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

// modelorders

$modelOrders = new VirtueMartModelOrders();
$order = $modelOrders->getOrder($virtuemart_order_id);

$button_url = $this->https_check(JURI::root());	
## Tracking
list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$trusted_line_items) = $this->order_form($order,$method,$button_url);





	//	}
	
	
	//if($method->ssc_show_address == 1)
  // 	{
	$address =	$this->print_address($virtuemart_order_id,$method,1);
		//$this->print_address($virtuemart_order_id,$method,$method->ssc_show_shipping);
	//	}


	$html .=  '<p style="font-size: small">';
	
	$html .=  '<table cellspacing="0" cellpadding="2">';
	
	$html .=  '<tr><td style="padding: 2px; border-style:hidden">';
	$html .=  JText::_('VMPAYMENT_STRIPE_SSC_ORDER_NUMBER') . ':</td>';
	$html .=  '<td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
	$html .=  $order["details"]["BT"]->order_number;
	$html .=  '</td></tr>';
	
	
	if(trim(($order["details"]["BT"]->customer_note)) != '')
		{
		$notes = '';	
		$notes .= '<tr><td style="border-style:hidden">';
		$notes .= JText::_('VMPAYMENT_STRIPE_SSC_ORDER_PRINT_CUSTOMER_NOTE') . ':</td>';
		$notes .= '<td style="border-style:hidden">&nbsp;&nbsp;';
		$notes .= $order["details"]["BT"]->customer_note;
		$notes .= '</td></tr>';
		$html .=  $notes;
		}
	
		
	//	$this->getPaymentCurrency($method); //?????
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
//$db = JFactory::getDBO();
$db->setQuery($q);
$currency_symbol = $db->loadResult();
		
		
	
	//custom 2
//	$html .=  '<tr><td style="padding: 2px; border-style:hidden; text-align: right;">';
//	$html .=  'Currency' . ':</td><td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
//	$html .=  $currency_code_3;
//	$html .=  '</td></tr>';

	
	//custom 3
	
	if(isset($httpResponse['ACK']))
	{
	$html .=  '<tr><td style="padding: 2px; border-style:hidden; text-align: right;">';
	$html .=  'Result' . ':</td><td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
	$html .=  $httpResponse['ACK'];
	$html .=  '</td>';
	}

	//custom 4
	
	if(isset($httpResponse['TRANSACTIONID']))
	{
	$html .=  '<tr><td style="padding: 2px; border-style:hidden; text-align: right;">';
	$html .=  'Transaction ID' . ':</td><td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
	$html .=  $httpResponse['TRANSACTIONID'];

	$html .=  '</td></tr>';
	}
	
	$html .=  '</table>';
	
	
	$html .=  '</p>'; # mod4
	
	if(trim($method->ssc_receipt_footer) != '')
		{
		$html .=  '<br/>';
		$html .=  $method->ssc_receipt_footer;
		$html .=  '<br/>';
   	}
	
	if(trim($method->ssc_raw) != '')
		{
		$html .=  $method->ssc_raw;
		}
  	
	if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

	$modelOrder = VmModel::getModel("orders");
	$orders["order_status"] =  $method->status_success;
	
	//$httpResponse['PaymentMethod'] = 'RecurringPayment';
	if($use_profile)
		{
		$orders["order_status"] = $method->status_success;
		}
	
	$orders["virtuemart_order_id"] = $virtuemart_order_id;
	$orders["customer_notified"] = 1;
	
	
	
	if(isset($httpResponse['PaymentMethod']))
		{  
		$orders["comments"] = $httpResponse['PaymentMethod'];
		}
	
		
	$html_pplan = '';
	
	if($use_profile)
		{
		$orders["order_status"] = $method->status_success;
		
		list($html_pplan,$use_profile,$profile_error,$first_payment_html) = $this->get_payment_name($method,$order_total,$order);
		
		
		if(isset($orders["comments"]))
		{
		$orders["comments"] .= "<br/>$html_pplan";
		}
		}




$html .=  $this->hidessc();



//ssc_show_thank_you
//ssc_show_receipt_address
//ssc_api_receipt_header
//ssc_api_receipt_header



if($method->ssc_show_thank_you)
	{
	echo $thank_you;
	}

	
if($method->ssc_show_order_details)
	{
	echo $table;
	echo '<br>';
	echo $html_pplan;
	echo '<br>';
	}

if($method->ssc_show_thank_you)
	{
	echo $html;
	}

if($method->ssc_show_order_details)
	{	
	echo $address;
	}


if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php'); //xxx
	}

$cart = VirtueMartCart::getCart ();
$cart->emptyCart ();




return;

		
	//return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, 'PayPal Checkout');

   

	
	
}




function print_order_details($virtuemart_order_id,$method,$show_shipping)

{
        
echo '<br/>';

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

// modelorders

$modelOrders = new VirtueMartModelOrders();
$order = $modelOrders->getOrder($virtuemart_order_id);

$button_url = $this->https_check(JURI::root());	
## Tracking
list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$trusted_line_items) = $this->order_form($order,$method,$button_url);

echo $table;


}







function print_address($virtuemart_order_id,$method,$show_shipping,$show_edit = 0)

{
$html = '';
	
	
	
$html .= '<br/>';

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

// modelorders

$modelOrders = new VirtueMartModelOrders();
$order = $modelOrders->getOrder($virtuemart_order_id);	

//list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details) = $this->order_form($order,$method);

//$html .= $table;

$address = $order['details']['BT'];

$del_address;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }


$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";

$name = $this->tfield($address->first_name,50) . ' ' . $this->tfield($address->last_name,50);

$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
//$del_state_name = $del_state;


if($country === 'US' || $country === 'CA')
  {
  $cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id,"state_2_code") : "";
  }




if($del_country === 'US' || $del_country === 'CA')
  {
  $del_state = isset($del_address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id,"state_2_code") : "";
  }



$html .= '<table style="width: 600px"  cellspacing="0" cellpadding="2">';
$html .= '<tr><td valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

#if($shipping_address == 1)
#	{
	$html .= '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_BILLING_ADDRESS')  . '</b><br/><br/>';
	$html .= $this->billing_address_html($address,$country,$cc_state);
#	}
#else
#	{
#	$html .= '<a href="' . JROUTE::_(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">' . JText::_('VMPAYMENT_STRIPE_SSC_EDIT_ADDRESS') . '</a></strong>';
#	$html .= $this->billing_address_html($address,$country,$state);
#	}
	
if($show_edit == 1)	
	{
	$html .= '<br>';
	}

$html .= '<a href="' . JROUTE::_(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">' . JText::_('VMPAYMENT_STRIPE_SSC_EDIT_ADDRESS') . '</a></strong>';
	

$html .= '</td><td valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == '1' || isset($order['details']['ST']))

	{
	$html .= '<br/><b>&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING_ADDRESS') . '</b><br/><br/>';
	$html .= $this->shipping_address_html($del_address,$del_country,$del_state);

	}

$html .= '</td></tr></table>';

#list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

$html .= '<br/>';


//This variable is not defined ???????????????????????????????
//echo $order_form_html_shipping;

 return($html);
    
    
}




























function billing_address_html($address,$country,$state)
{

$editbillingaddress =  JText::_('VMPAYMENT_STRIPE_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_STRIPE_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_STRIPE_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_STRIPE_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_STRIPE_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_STRIPE_SSC_ZIP');
#$order_form_telephone = JText::_('VMPAYMENT_STRIPE_SSC_TELEPHONE');
#$order_form_email = JText::_('VMPAYMENT_STRIPE_SSC_EMAIL');
#$order_form_paypal_billing_address = JText::_('VMPAYMENT_STRIPE_SSC_PAYPAL_BILLING_ADDRESS');
#$order_form_item_total = JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL');
#Thani_tax = JText::_('VMPAYMENT_STRIPE_SSC_TAX');
#$order_form_surcharge = JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE');
#$order_form_shipping = JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING');
#$order_form_order_total = JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL');


$order_form_html_shipping = <<<directorderform
<table  cellspacing="0" cellpadding="2">
    <tr align="center">
       <td align="right">$order_form_name:</td>
       <td align="left" >&nbsp;
$address->first_name $address->last_name
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_address:</td>
       <td align="left" >&nbsp;
$address->address_1      
      </td>
    </tr>
    <tr align="center">
       <td align="right"></td>
       <td align="left" >&nbsp;
$address->address_2
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_city:</td>
       <td align="left" >&nbsp;
$address->city
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_state:</td>
       <td align="left" >&nbsp;
$state
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_country:</td>
       <td align="left" >&nbsp;
$country      
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_zip:</td>
       <td align="left" >&nbsp;
$address->zip
      </td>
    </tr>
    </tbody>
  </table>
directorderform;

return $order_form_html_shipping;
}




/*
function shipping_address_html($del_address,$del_country,$del_state)
{

$e*rder_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_STRIPE_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_STRIPE_SSC_ZIP');
#$order_form_telephone = JText::_('VMPAYMENT_STRIPE_SSC_TELEPHONE');
#$order_form_email = JText::_('VMPAYMENT_STRIPE_SSC_EMAIL');
#$order_form_paypal_billing_address = JText::_('VMPAYMENT_STRIPE_SSC_PAYPAL_BILLING_ADDRESS');
#$order_form_item_total = JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL');
#$order_form_tax = JText::_('VMPAYMENT_STRIPE_SSC_TAX');
#$order_form_surcharge = JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE');
#$order_form_shipping = JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING');
#$order_form_order_total = JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL');


$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td align="right">$order_form_name:</td>
       <td align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_address:</td>
       <td align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
    <tr align="center">
       <td align="right"></td>
       <td align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_city:</td>
       <td align="left" >&nbsp;
$del_address->city
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_state:</td>
       <td align="left" >&nbsp;
$del_state
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_country:</td>
       <td align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_zip:</td>
       <td align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>
    </tbody>
  </table>
directorderform;

return $order_form_html_shipping;
}
*/

    
function tfield($field,$len)
	{
	$field = str_replace('"',"''",$field);
	$field = substr($field,0,$len);
	//$field = htmlspecialchars($field);
	return $field;
	}


function capture_payments($order_id,$token,$paypal_url)
{


//curl -v -X POST https://api-m.sandbox.paypal.com/v2/checkout/orders/<ORDER-ID>/capture \

//-H "Content-Type: application/json" \

//-H 'Authorization: Bearer <ACCESS-TOKEN>' \

//-H 'Accept-Language: en_US' \ 
 
$ch = curl_init();
 #CURLOPT_HTTPHEADER, array('Connection: Close'));
$headers = array(
'Content-type: application/json',
'Authorization: Bearer ' . $token,
'Accept-Language: en_US'
);


curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v2/checkout/orders/" . $order_id . "/capture");
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
//curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

/*
(
[name] =&gt; UNPROCESSABLE_ENTITY
    [details] =&gt; Array
        (
            [0] =&gt; stdClass Object
                (
                    [issue] =&gt; ORDER_ALREADY_CAPTURED
                    [description] =&gt; Order already captured.If 'intent=CAPTURE' only one capture per order is allowed.
                )

        )

    [message] =&gt; The requested action could not be performed, semantically incorrect, or failed business validation.
    [debug_id] =&gt; b3a23249f5668
    [links] =&gt; Array
        (
            [0] =&gt; stdClass Object
                (
                    [href] =&gt; https://developer.paypal.com/docs/api/orders/v2/#error-ORDER_ALREADY_CAPTURED
                    [rel] =&gt; information_link
                    [method] =&gt; GET
                )

        )
*/

curl_close($ch);	
	
$this->update_orders($order_id,$result,$paypal_url);	

return $result;	
}




function update_orders($paymentId,$result,$paypal_url)
	{

	$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `paymentId` = '" .  $paymentId . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);

	if (!$virtuemart_order_id)
	  {
	  return;
	  }

	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}
	
	
	if ($virtuemart_order_id)
	   {
		if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

		$modelOrder = VmModel::getModel("orders");
		$orders["order_status"] = $method->status_success;
	
	   $orders['comments'] = 'Capture/Confirm by JS';
		$orders["virtuemart_order_id"] = $virtuemart_order_id;
		$orders["customer_notified"] = 1;
	

	if(empty($result))
		echo "Error: No response.";
	else
		{
		$json = json_decode($result);
		if($method->debug)
		{
		print_r($json);
		}
	

	if((isset($json->status)) && $json->status == 'APPROVED' || $json->status == 'COMPLETED')
		{
		$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	
		if((isset($orderitems['details']['BT']->order_status) && ($orderitems['details']['BT']->order_status == 'P')))
			{
		
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
			}
		//echo $orderitems['details']['BT']->order_status;
		}
	
	}

	
	return;

		
   }

	

	
	
	echo 'Status Updated';
	
	return;
	
	
}



	function retrieve_payment_details($result,$PROFILEID,$online_update)
	{
	$payment = $this->getDataByOrderId($result);
	// paypal pro selected ???
	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
$debug='0';
	//echo $PROFILEID;
#print_r($result);
$this->make_records_db();
$q = "SELECT * FROM `#__virtuemart_payment_plg_paypalpro3dssc_offline` WHERE `virtuemart_order_id` = '" .  $result . "'";
$db = JFactory::getDBO();
$db->setQuery($q);
$card = $db->loadAssoc();
$seconds = time();
//print_r($card);
/*
`response_id` char(31) NOT NULL DEFAULT '',
`response` text NOT NULL DEFAULT '',
`response_3` char(31) NOT NULL DEFAULT '',
`response_4` char(31) NOT NULL DEFAULT '',
`created_on` datetime NOT NULL default '0000-00-00 00:00:00',
`created_seconds` int(11) NOT NULL default 0,
*/
if($card != null)
	{
	$date = $card['created_on']; // created_on
	$seconds = $seconds - strtotime($date);	
	if($debug == '1')
		{
		echo'Found existing Record';
		echo 'File Date: ' . $card['created_on'];	
		echo '<br>';
		echo 'file date in seconds: ' . strtotime($date);
		echo '<br>';
		echo 'Current date in seconds: ' . time();	
		echo '<br>';
		echo '<br>Difference: ' . $seconds  . '<br>';
		echo $date;
		echo '<br>';
		}
	}
// cache time
$override = 0;
$update = 0;
$old = 0;
if($card == null)
	{
	$update = 1;
	$online_update = 1;
	}
else
	{
	$httpResponse = json_decode($card['response'],true);
	if(isset($httpResponse['NEXTBILLINGDATE']))   
  		{
		$next = urldecode($httpResponse['NEXTBILLINGDATE']);
		$next = strtotime($next);
		$today = time();
		$days =  round(($next - $today)/(60*60*24));
		/*
		if(isset($httpResponse['STATUS']))
		{
  		if($httpResponse['STATUS'] == 'Active' && $days < 0)
			{
			$update = 1;
			//echo 'active waiting<br>';
			}
		if($httpResponse['STATUS'] == 'Active' && ($httpResponse['FAILEDPAYMENTCOUNT'] > $httpResponse['MAXFAILEDPAYMENTS']))
			{
			$update = 1;
			//echo 'active failed<br>';
			}
		}
		 */	
		}
	if(empty($httpResponse)){$update=1;$online_update = 1;}
	//if($seconds < (1*60*60))
	//	{
	//	if($debug == '1')
	//		{
	//		echo 'Get old response<br>';
	//		}
	//	$old = 1;
	//	$update = 0;
	//	}	
	}
	if($update == 1 || $online_update == 1)	
		{
		if($debug == '1')
			{
			echo 'updating<br>';
			}
		$APIrequest ='&PROFILEID=' . $PROFILEID;
		$db = JFactory::getDbo();
		//$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalpaymentspro3dssc" AND `published` = 1';
		//$db->setQuery($q);
		//$virtuemart_paymentmethod_id = $db->loadResult();
		//$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
		$httpResponse = $this->PPHttpPost($method,"GetRecurringPaymentsProfileDetails", $APIrequest);
		//print_r($httpResponse);
		$this->update_records_db($result,$httpResponse);
		}
return $httpResponse;	
####### end database  ###################################
}

	
		
function view_customer($order_get)
	{	
	echo 'Customer:';
	echo '<br>';
	return;	
	}
	
	
function view_single_subscription($order_get)
	{	
	echo 'Single Subscription :';
	echo '<br>';
	return;	
	}	
		
		function view_subscriptions($order_get)
	{	
			
				$user = JFactory::getUser();        // Get the user object

$isroot = $user->authorise('core.admin');
	if($user->id != 0)

		//	if($isroot)
		{
	    // you are logged in
		}
	else 
		{
		// Redirect the user
		// $app->redirect(JRoute::_('index.php?option=com_users&view=login'));
		echo '<span style="font-family: Arial, Helvetica, sans-serif; font-size: large; color:red"><strong>
		Please Login </strong></span><br/>'; 
		echo $this->hidessc();
		return;
		}
	
			
			
			
			
			
			
			
			
			
if (!class_exists('VirtueMartModelOrders'))
	require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	$modelOrder = new VirtueMartModelOrders();
			
	//$q = "SELECT `virtuemart_order_id` FROM `#__virtuemart_orders` WHERE `virtuemart_user_id` = '" .  $user->id . "'";
			
	$q = "SELECT `order_number`,`stripe_customer_id` FROM `#__virtuemart_payment_plg_stripessc` WHERE `order_number` != '0'";
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$results = $db->loadObjectList();

	//retrieve_vm_customer_id($stripe_customer_id)
	//$q = "SELECT `stripe_customer_id` FROM `#__virtuemart_payment_plg_stripessc` WHERE `order_number` == '$results[0]'";
	//$db = JFactory::getDBO();
	//$db->setQuery($q);
	//$result = $db->loadResult();

/*
	
	echo '<table width="1500" id="results">
	<tr style="font-weight: bold">
	<td>&nbsp;&nbsp;Name</td>
	<td>Status&nbsp;&nbsp;</td>
	<td>Last Payment&nbsp;&nbsp;</td>
	<td>Last Paid&nbsp;&nbsp;</td>
	<td>Next Payment&nbsp;&nbsp;</td>
	<td>Days&nbsp;&nbsp;</td>
	<td>Skipped&nbsp;</td>
	<td>Failed&nbsp;&nbsp;</td>
	<td>Out<br>Standing&nbsp;</td>
	<td>Regular<br>Amount&nbsp;&nbsp;</td>
	<td>Order No.&nbsp;&nbsp;</td>
	<td>Email&nbsp;&nbsp;</td>
	<td>Last Updated&nbsp;&nbsp;</td>
	</tr>';
	*/
	//<td>Description</td>
	
	
echo '<style>	
	.paymentsTable
	{
  th{  text-align: left;
  height: 32px;
  background-color: #000000;
  color: #ffffff;

}
	
td {
vertical-align: middle;
height: 32px;
}
}

	
</style>';	
	
	
	echo '
	<table id="results" class="paymentsTable">		

<tr>
	<th>&nbsp;&nbsp;Name</th>
	
<th>Email-&nbsp;&nbsp;</th>

	<th>Order Number&nbsp;&nbsp;</th>

		<th>First Payment&nbsp;&nbsp;</th>
	
<th>Order Total-&nbsp;&nbsp;</th>

	<th>Total Received-&nbsp;&nbsp;</th>
	
	<th># Payments&nbsp;&nbsp;</th>	
	<th>Next Due&nbsp;&nbsp;</th>
		<th>&nbsp;&nbsp;</th>

	</tr>';	
	
	$start = 1;
	$end = 999;
	$days_covered = 240;
	$online_update = 0;
	if (isset($order_get["online"]))
		{
		$online_update = $order_get["online"];
		}
	if (isset($order_get["days"]))
		{
		$days_covered = $order_get["days"];
		}
	if (isset($order_get["start"]))
		{
		$start = $order_get["start"];
		}
	if (isset($order_get["end"]))
		{
		$end = $order_get["end"];
		}

	

//	foreach ($results as $result)
		
		$ajax_scripts='';
		
			for($i = 0, $n = count ( $results ); $i < $n; $i ++) {
		
		
		$result = $results [$i];
		
	if($isroot)
		{
	    // you are logged in
		}
	else 
		{
		$vm_customer_id =	$this->retrieve_vm_customer_id($result->stripe_customer_id);
		if($user->id !== $vm_customer_id)
			{
			continue;	
			}
		}
		
	//	print_r($result);
	$count = 0;
	
	
	$successful_payments = 0;
	
	$payment_attempts = 0;
	
	$total_paid = 0;		
	    
	//`order_number`,'defer_installments','defer_date'
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($result->order_number);
	

	if(!$virtuemart_order_id)
	{

		echo "<tr>
<td>Order Not Found: </td>
	<td>" . $result->order_number  . "</td>
	<td></td>
	<td></td>
	<td></td>
	<td></td>
	<td></td>


	</tr>";
	continue;	
	}
	
	$order = $modelOrder->getOrder($virtuemart_order_id);
	
	if($order['details']['BT']->order_status === 'P')//$method->status_pending)
		{
		continue;
		}
		
	$description = $this->description_order($order,$virtuemart_order_id);

	//$description ='';	
		$order_total = $order['details']['BT']->order_total;
		
		$order_total = number_format($order_total,2,'.','');
		 
		$address = $order['details']['BT'];
		
		$cc_name = trim($address->first_name) . ' ' . trim($address->last_name);
		
	//	$first_name = trim($address->first_name);
	//	$last_name = $address->last_name;
	//	$cc_address_line_1 = $address->address_1;
	//	$cc_address_line_2 = $address->address_2;
		//$admin_area_2 = $address->city;
	//	$cc_city = $address->city;
	//	$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, 'country_2_code');
	//	$cc_postal_code = $address->zip;
	//	$cc_phone = $address->phone_1;
	//	$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";	
		$cc_email = $address->email;

		
		
		
		$q = "SELECT `stripe_intent_json`,`created_seconds` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = '" .  $result->order_number . "'";
		$db->setQuery($q);
	
		$intents = $db->loadAssocList();
		
	//	$q = "SELECT `created_seconds` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = '" .  $result . "'";
	//	$db->setQuery($q);

		$max_seconds = 0;
		
		$min_seconds = 0;
		
		foreach ($intents as $intent)
			{
		
			$stripe_intent_json = json_decode($intent['stripe_intent_json']);
		

			
			$payment_attempts++;
	

			if(isset($stripe_intent_json->status) && $stripe_intent_json->status ==='succeeded')
				{
				$successful_payments++;
				
				if($intent['created_seconds'] > $max_seconds)
					{
					$max_seconds = $intent['created_seconds'];
					}
					
				if($intent['created_seconds'] < $min_seconds || $min_seconds == 0)
					{
					$min_seconds = $intent['created_seconds'];
					}
	

				$total_paid += $stripe_intent_json->amount;
				}
		   $count++;
		
			}
		

		//echo '<br>';
		//echo 'total paid' . $total_paid;
		//echo '<br>';	
		
		
		$total_paid = ($total_paid)/100;
		$total_paid = number_format($total_paid,2,'.','');
	
		//echo 'grand total' . $total_paid;
		
		

$url = JURI::root() . "administrator/index.php?option=com_virtuemart&view=orders&task=edit&virtuemart_order_id=" . $virtuemart_order_id . '#order_details';


$single_sub_url = JURI::root() . "index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&view_stripe_single_subscription=1&virtuemart_order_id=" . $virtuemart_order_id;


		//view_stripe_single_subscription
$link = $result->order_number;

if($isroot)
	{	
	$link = "<a href='$url' target='_blank'>" . $result->order_number . "</a>";
	}

 
 $single_sub_link =  "<a href='$single_sub_url' target='_blank'>Details </a>";
 
 
 
 #### begin next installemnt button ##########
 
 
 			$db = JFactory::getDBO();
	$q = "SELECT `setupFutureUsage` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	
	$setup_future_usage =  $db->loadResult();
 
 	$db = JFactory::getDBO();
	$q = "SELECT `no_of_monthly_payments` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$no_of_monthly_payments = $db->loadResult();
 
 			$db = JFactory::getDbo();
	$q = "SELECT `defer_installments` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);

	$defer_installments = $db->loadResult();
 
 
 		$db = JFactory::getDbo();
	$q = "SELECT `defer_date` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);

	$defer_date = $db->loadResult();
	
			$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
		
	$db = JFactory::getDbo();
	$q = 'SELECT `created_seconds` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = "'. $order_number . '"';
	$db->setQuery($q);

	$date_seconds = $db->loadResult();
	
	

 
 $defer_time = strtotime($defer_date);

$offset = -1;

if($defer_installments === 'No')
	{
	$defer_time = $date_seconds;
	$offset=0;
	}


	
$next_payment = $successful_payments + $offset;

$next_month = $next_payment+2;
	

//$next_payment = 'No. ' . $next_month .' due ' . date('M j, Y', strtotime('+' . $next_payment . ' month',$defer_time));
$next_payment = date('M j, Y', strtotime('+' . $next_payment . ' month',$defer_time));


$payment_attempts++;

 
##### end next installment button ####

		
		/*
	<td>&nbsp;&nbsp;Name</td>
	<td>Status&nbsp;&nbsp;</td>
	<td>Order Number&nbsp;&nbsp;</td>
	<td>Description</td>
	<td>No of Payments&nbsp;&nbsp;</td>
	 <td>Last Payment-&nbsp;&nbsp;</td>
	<td>Next Payment-&nbsp;&nbsp;</td>

	<td>Total Received-&nbsp;&nbsp;</td>
	<td>Order Total-&nbsp;&nbsp;</td>
	<td>Email-&nbsp;&nbsp;</td>
	<td>View Details&nbsp;&nbsp;</td>

		
		*/
 
$payment_complete = false; 

if($total_paid >= $order_total)
	{
	$payment_complete = true;
	}

$url = JURI::root() . "index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&view_stripe_single_subscription=1&virtuemart_order_id=" . $virtuemart_order_id;

//if($monthly_payment > 0)



if($no_of_monthly_payments > 0 && !$payment_complete && $setup_future_usage !== 'cancelled')
	{
	
		if($isroot)
		{
	
	
	
	
	
	
	
	
	$order_link = '
	<form method="post" class="checkoutForm" id="' . "form-$order_number" . '" name="checkoutForm" action="' . $url . '&payment_no=' . $payment_attempts . '">';

	$order_link .= "

	<input type='hidden' class='ssc_order_rank' name='order_rank' value='$payment_attempts'/>
		
	<input type='hidden' name='future' value='process'/>
	
	<input type='hidden' name='show_details' value='no'/>
		
	<input onclick='return confirm(\"Process this payment. Are you sure?\");' type='submit' value='$next_payment'/>
	</form>";
	
	$link_url = "$url&payment_no=$payment_attempts";
	
	$ajax_scripts .= "
		<script>
	jQuery(function($) {
    $('#form-$order_number').on(\"submit\", function(event) {
        event.preventDefault();

        $.ajax({
            url: '$url&payment_no=$payment_attempts',
            type: 'post',
            data: $(this).serialize(),
            success: function(data) {
           
		$('#div$order_number').replaceWith($('#div$order_number',data));
	
		$('#no$order_number').replaceWith($('#no$order_number',data));
	
		$('#total$order_number').replaceWith($('#total$order_number',data));

            }
        });
    });
});
</script>
";
		
		}
		
 else {
			
		$order_link = $next_payment;
 }
 
	
	}
else
	{
	
	if($setup_future_usage == 'cancelled')
	{
	$order_link = 'Cancelled';		
	}
	else
	{
	
	$order_link = 'Paid in Full';	
	}

	}
	
	
	
	
	
	
	
	
	
	
		//	<td>" . $description . "</td>
echo "<tr>
<td>$cc_name</td>
	<td>$cc_email</td>

	<td>$link</td>

		   <td>" . date("y-m-d", $min_seconds) . " &nbsp;&nbsp;</td>


	<td>$order_total</td>

	<td><div id='total$order_number'>$total_paid</div></td>

	<td><div id='no$order_number'>$successful_payments</div></td>		
<td><div id='div$order_number'>$order_link</div></td>

<td style='vertical-align: top;'>
$single_sub_link</td>
	</tr>";
		

		
		}
		
	
	echo '</table></br></br>';		
	echo '<br>';
	
	echo $ajax_scripts;




	$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";
echo $hidessc;
return null;	
}
		
		
		
		







function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
    

	if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
	    return null; // Another method was selected, do nothing
	}
	if (!$this->selectedThisElement($method->payment_element)) {
	    return false;
	}                                                                                                       
	$this->getPaymentCurrency($method);
	$paymentCurrencyId = $method->payment_currency;
//	$paymentCurrencyId = trim($payment->plg_session_id);
    }

// html response
	 


function plgVmOnPaymentResponseReceived(&$html)
{
    
if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );

	//$order_data = J Request::get('get');
	
	$order_data = $this->get_strings();

	
	//$post_msg ='';
		
	//foreach ($order_data as $key => $value)
	//   {
	//   $post_msg .= $key . "=" . $value . "<br />";
	//   }
	
	//echo $post_msg;
	
	//$post_data = J Request::get('post');
	
	$post_data = $this->post_strings();
	$get_data = $this->get_strings();
	
	
	
	
	
	//https://hooks.stripe.com/3d_secure_2/hosted?
	//merchant=acct_1JrkGtGhPg0yig8B&
	//payment_intent=pi_3PdH55GhPg0yig8B0qzogwlI&amp;
	//payment_intent_client_secret=pi_3PdH55GhPg0yig8B0qzogwlI_secret_2R3kaa4fY5qzgIsHYYp48sIYl&
	//publishable_key=pk_test_51JrkGtGhPg0yig8BSQcCIzYimV6wHovoshpQoM1NpSUgyeJqCO3VXC1AoNmfhlFCaU8OLXAyYQRBoPXbrznc5Z0Y00dYeZqdaO&
	//source=payatt_3PdH55GhPg0yig8B02ZN9u4W
	
	if (isset($get_data["payment_intent"]))
		{
	
		
		
			
		if(isset($get_data["order_number"]))
		{
	
	$order_number = $get_data["order_number"];
	
			 	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
				
				
			//	echo 'Order ID is '. $virtuemart_order_id ;
		}
 else {
	 echo 'Order Number is not set';
	 
		return;	
		}
	
	
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}
	
	
		
		
		
		
		
		
		
		
	//$payment_intent_client_secret = 	$get_data["payment_intent_client_secret"];
	
			$payment_intent = 	$get_data["payment_intent"];
			
		
	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);


	
	
$publishable_key = $method->ssc_ssc1;
$secret_key = $method->ssc_ssc2;
//$merchant_id = $method->ssc_merchant_id;


if($method->ssc_environment == "sandbox")
   {
   $publishable_key = $method->ssc_ssc1_sb;
	$secret_key = $method->ssc_ssc2_sb;
	//$merchant_id = $method->ssc_sb_merchant_id;
   }		
			
			
	require_once __DIR__  . '/stripe-php/init.php';
	try {
		
	
			$stripe = new \Stripe\StripeClient($secret_key);

			$paymentIntent = $stripe->paymentIntents->retrieve($payment_intent, []);
		}
		
		catch (Exception $ex)
		{
		echo $ex->getMessage();
	}
		
		
	//	print_r($paymentIntent);
		
		
    $stripe_intent_json = json_encode($paymentIntent);
	 

	 
		 $publishable_key='';
		 


			
		$this->add_stripe_payment_intent($paymentIntent->id, $stripe_intent_json, $order_number,$publishable_key);
	//$this->add_stripe_payment_intent($paymentIntent->id, $stripe_intent_json, $order_number,$publishable_key,$get_data['payment_no']);
		 
		   	    
	      
	 	$html_pplan="";
		
		$source = 'JS';
			
		
	$this->process_stripe_payment($paymentIntent,$source,$order_number,$html_pplan);	
		
		
		
		
		return;
		}
	
	
	
	
	
	
	
	
	
	if (isset($get_data["view_stripe_customer"]))
		{
		$this->view_customer($get_data);
		return;
		}
	

	if (isset($get_data["view_stripe_subscriptions"]))
		{
		$this->view_subscriptions($get_data);
		return;
		}
		
		
	if (isset($get_data["view_stripe_single_subscription"]))
		{
	//	plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id)
		//$virtuemart_order_number; 	6AEE01012
		
		//virtuemart_order_id=5859
		//$url = JURI::root() . "administrator/index.php?option=com_virtuemart&view=orders&task=edit&virtuemart_order_id=" . $virtuemart_order_id . '#order_details';
		//view_stripe_single_subscription
					$db = JFactory::getDBO();
//	$q = "SELECT `paymentId` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $get_data["virtuemart_order_id"] . "'";
//	$db->setQuery($q);
//	$payment_id = $db->loadResult();
	
	$payment = $this->getDataByOrderId($get_data["virtuemart_order_id"] );
	
	
	
	if(isset($post_data['show_details'])  && $post_data['show_details'] == 'no')
		{
		 $this->plgVmOnShowOrderBEPayment($get_data["virtuemart_order_id"], $payment->virtuemart_paymentmethod_id);
		$this->view_subscriptions($get_data);
		}
	else
		{
		// convert to return $html ?
		$html = $this->plgVmOnShowOrderBEPayment($get_data["virtuemart_order_id"], $payment->virtuemart_paymentmethod_id);
		//	echo $html;
		}
		
		
		
		return;
		}
		
	
		
	$jinput =JFactory::getApplication()->input;
	 
	$value='ecocheckout'; $order_data[$value] = $jinput->get->get($value, null, 'ALNUM');
	$value='pectransid'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	$value='e'; $order_data[$value] = $jinput->get->get($value, null, 'ALNUM');
	$value='token'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	$value='PayerID'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	
	$value='payment_intent'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');

	$value='s'; $post_data[$value] = $jinput->post->get($value, null, 'ALNUM');
	
	
/*
	if (isset($post_data["s"]))
	   {
	   if($post_data["s"] == 'eccheckout')
	      {
          $this->doexpress('','','');
  	      return;
	      }
	   }
*/	
		

   if (isset($order_data["ecocheckout"]))
	   {
	   
	   if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
		$cart = VirtueMartCart::getCart();
		
		$value = $this->plgVmConfirmedOrder($cart,null);

	   return $value;
	   }

		
		
	$virtuemart_order_id='';
	

	
/*	
if(isset($get_data["sp"]))
	{
	$payment_intent_id = $get_data["payment_intent"];

	$source='JS';
	
	$this->process_stripe_payment($payment_intent_id,$source,'',null);		
	
	echo 'Status Updated';
	
	return;
	
	}
*/



if(isset($get_data["sub"]))
	{
	

	
	
	$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `subscriptionId` = '" .  $get_data["subscriptionId"] . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
	
	if (!$virtuemart_order_id)
	  {
	  return;
	  }
	
	
	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}
	

	
	if ($virtuemart_order_id)
	   {
		if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

		$modelOrder = VmModel::getModel("orders");
		$orders["order_status"] = $method->status_success;
	
	   $orders['comments'] = 'Comfirmed by JS';
		$orders["virtuemart_order_id"] = $virtuemart_order_id;
		$orders["customer_notified"] = 1;
		


	$paypal_fullresponse = '';// '{"PROFILEID":"' . urlencode($order_data["subcriptions_id"]) . '"}';
    
	$use_profile=true;
	$this->show_payment_details($paypal_fullresponse,$virtuemart_order_id, $orders,$use_profile);
	

	$orderitems = $modelOrder->getOrder($virtuemart_order_id);	
	
if((isset($orderitems['details']['BT']->order_status) && ($orderitems['details']['BT']->order_status == 'P')))
		{
		
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}


	
	
	return;
	
		
		
	   }

	
	return;
	
	
}


$order_number = '';

	if (!isset($order_data["pectransid"]))
	   {
		
		### find order number from paymentId
		
		if(isset($order_data["paymentId"]))	
			{
			$db = JFactory::getDBO();
			$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `paymentId` = '" .  $order_data["paymentId"] . "'";
			$db->setQuery($q);
			$order_number = $db->loadResult();
			
			$order_data["pectransid"] = $order_number;
			}
		else
			{
			return;
			}
		
	   }
//echo $order_number;


if (isset($order_data["e"]) && $order_data["e"] === '1')
   {
	//echo '- update cart  --<br>';
	$this->update_cart($order_data['token'],$order_data['PayerID']);
	return;
	}

	$order_number = $order_data["pectransid"];
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_data["pectransid"]);
//**	$this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');

	if (!$virtuemart_order_id)
	  {
	  return;
	  }
	
	
	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		//echo $method->payment_element;
		//print 'no order id PP P';
		return false;
		}
	
	
//	&pectransid=G25C0166&api=rest&paymentId=PAY-1L213597SS097060FLFLZIMY&token=EC-4D717483T38936052&PayerID=EMM5HTHZPRXMQ

if(isset($order_data["paymentId"]))
	{
	
	if (!isset($order_data["PayerID"]))
	   {
	   echo 'PayerID is not Set';
	   return;
	   }
	
	$this->process_success($order_data["paymentId"],$order_data["PayerID"],$order_number);
	return;
	}

	

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);

//$method->debug = 0;

//print_r($method);
//print print_r($order);

//print print_r($payment);

//Payment

//[product_attribute] =>


$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

//if($method->ssc_multi_currency)
//	{
	$customer_currency = trim($payment->alt_currency);
//	}
//else
//	{
//	$customer_currency = $method->payment_currency;
//	}


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);

$APIrequest =
"&TOKEN=" . $order_data['token'] .

"&PAYMENTACTION=" . $method->ssc_payment_action;
//"&IPADDRESS=" . $ipaddress .

//"&RETURNURL=". urlencode($ReturnURL) . urlencode('&pectransid=' . $order["details"]["BT"]->order_number) .
//encode twice

//"&CANCELURL=". urlencode($CancelURL) .

//"&INVNUM=" . urlencode($cart->virtuemart_order_id) .
# new custom field 23-11-11
//"&CUSTOM=" . 
#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"] .

//"&LOCALECODE=" . $cc_country .

//"&CURRENCYCODE=" . $currency_code_3 .
//"&ITEMAMT=" . $line_order_total .
//"&SHIPPINGAMT=" . $shipping .
//"&TAXAMT=" . $total_tax .
//"&AMT=" . $amount .

//"&SHIPTONAME=" . urlencode($del_address->first_name . ' ' . $del_address->last_name) .
//"&SHIPTOSTREET=" . urlencode($del_address->address_1) .
//"&SHIPTOSTREET2=" . urlencode($del_address->address_2) .
//"&SHIPTOSTATE=" . urlencode($del_state) . 
//"&SHIPTOCITY=" . urlencode($del_address->city) . 
//"&SHIPTOZIP=" . urlencode($del_address->zip) .
//"&SHIPTOCOUNTRYCODE=" . urlencode($del_country) .
//"&SHIPTOPHONENUM=" . urlencode($address->phone_1) .


//"&EMAIL=" . urlencode($address->email) .

//$line_order_details .





$httpResponse = $this->PPHttpPost($method,"GetExpressCheckoutDetails", $APIrequest);


///// begin mods for save address ///

///*
$method->ssc_address_override=1;

if($method->ssc_address_override == 0)
{
$first_name = '';
$middle_name ='';
$last_name = '';
$address_1 = '';
$address_2 = '';
$house_no = '';
$zip = '';
$city = '';
$state_name='';
$state_id='0';
$virtuemart_country_id='';
$phone_1='';
$email = '';


if(isset($httpResponse['FIRSTNAME']))
	{
	$first_name = urldecode($httpResponse['FIRSTNAME']);
	}

if(isset($httpResponse['MIDDLENAME']))
	{
	$middle_name = urldecode($httpResponse['MIDDLENAME']);
	}

if(isset($httpResponse['LASTNAME']))
	{
	$last_name = urldecode($httpResponse['LASTNAME']);
	}

if(isset($httpResponse['FIRSTNAME']) && isset($httpResponse['LASTNAME']))
	{
	if(urldecode($httpResponse['SHIPTONAME']) == urldecode($httpResponse['FIRSTNAME']) . ' ' . urldecode($httpResponse['LASTNAME']))
		{
		$first_name = urldecode($httpResponse['FIRSTNAME']);
		$last_name = urldecode($httpResponse['LASTNAME']);
		}
	else
		{
		$shipToName = explode(' ', urldecode($httpResponse['SHIPTONAME']));
		$first_name = $shipToName[0];
		$last_name = '';
		if (count($shipToName) > 1)
			{
			$last_name = str_replace($first_name . ' ', '', urldecode($httpResponse['SHIPTONAME']));
			}
		}
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']))
	{
	$address_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']))
	{
	$city = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']);
	}

if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']))
	{
	$zip = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']);
	}
	
	
if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']))
	{
	$cc = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']);
	$virtuemart_country_id = ShopFunctions::getCountryIDByName($cc);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']))
	{
	$state_name = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
	
	
	if(strlen($state_name) === 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_2_code`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_2 = $db->loadResult();
		//echo 'state id 2:' . $state_id_2;

		if(!is_null($state_id_2))
			{
			$state_id = $state_id_2;
			}
		
		//$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
		$city = trim($city);	
		}
	
	if(strlen($state_name) > 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_name`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_3 = $db->loadResult();
		//echo 'state id 3:' . $state_id_3;

		if(!is_null($state_id_3))
			{
			$state_id = $state_id_3;
			}
		else
			{
			$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
			$city = trim($city);	
			}
		}

	}

	
//if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']))
//	{
//	$phone_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']);
//	}
	
if(isset($httpResponse['PHONENUM']))
	{
	$phone_1 = urldecode($httpResponse['PHONENUM']);
	}
	
	
if(isset($httpResponse['EMAIL']))
	{
	$email = urldecode($httpResponse['EMAIL']);
	}


//$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($invoice_num);

//// begin db update ////

$bt=0;
$st=0; 
  
$db = JFactory::getDBO();
$query = $db->getQuery(true);
$query->select($db->quoteName(array('virtuemart_order_userinfo_id','virtuemart_order_id','virtuemart_user_id','address_type')));
$query->from($db->quoteName('#__virtuemart_order_userinfos'));
$query->where(array($db->quoteName('virtuemart_order_id')." = " . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('ST')));
$db->setQuery($query);
//$row = $db->loadObject();
//$db->query();
$db->execute();
$st = $db->getNumRows();


$db = JFactory::getDBO();
$query = $db->getQuery(true);
$query->select($db->quoteName(array('virtuemart_order_userinfo_id','virtuemart_order_id','virtuemart_user_id','address_type','address_type_name','company','title','last_name','first_name','middle_name','phone_1','phone_2','fax','address_1','address_2','city','virtuemart_state_id','virtuemart_country_id','zip','email','agreed','created_on','created_by','modified_on','modified_by','locked_on','locked_by')));
$query->from($db->quoteName('#__virtuemart_order_userinfos'));
$query->where(array($db->quoteName('virtuemart_order_id')." = " . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('BT')));
$db->setQuery($query);
$row = $db->loadObject();
//$db->query();
$db->execute();
$bt = $db->getNumRows();   
   

if($bt == 1 && $st == 1)
	{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	//$fields = array($db->quoteName('first_name') . '=' . $db->quote('1 1 ' . $first_name),
	$fields = array($db->quoteName('first_name') . '=' . $db->quote($first_name),
	$db->quoteName('last_name') . '=' . $db->quote($last_name),
	$db->quoteName('middle_name') . '=' . $db->quote($middle_name),
	$db->quoteName('last_name') . '=' . $db->quote($last_name),
	$db->quoteName('address_1') . '=' . $db->quote($address_1),
	$db->quoteName('address_2') . '=' . $db->quote($address_2),
	$db->quoteName('zip') . '=' . $db->quote($zip),
	$db->quoteName('city') . '=' . $db->quote($city),
	$db->quoteName('virtuemart_state_id') . '=' . $state_id,
	$db->quoteName('virtuemart_country_id') . '=' . $virtuemart_country_id,
	$db->quoteName('phone_1') . '=' . $db->quote($phone_1),
	$db->quoteName('email') . '=' . $db->quote($email));
	$conditions = array($db->quoteName('virtuemart_order_id') . '=' . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('ST'));
	$query->update($db->quoteName('#__virtuemart_order_userinfos'))->set($fields)->where($conditions);
	$db->setQuery($query);
	//$result = $db->query();
	$result = $db->execute();
	}


if($bt == 1 && $st == 0)
	{
	$row->virtuemart_order_userinfo_id = null;
	$row->address_type='ST'; 
//	$row->first_name = '1 0 ' . $first_name;
	$row->first_name = $first_name;
	$row->last_name = $last_name;
	$row->middle_name = $middle_name;
	$row->last_name = $last_name;
	$row->address_1 = $address_1;
	$row->address_2 = $address_2;
	$row->zip = $zip;
	$row->city = $city;
	$row->virtuemart_state_id = $state_id;
	$row->virtuemart_country_id = $virtuemart_country_id;
	$row->phone_1 = $phone_1;
	$row->email = $email;
// Insert the object into the user profile table.
	$result = JFactory::getDbo()->insertObject('#__virtuemart_order_userinfos', $row);
	}
//// end db update ////
	//update $order variable
$order = $modelOrder->getOrder($virtuemart_order_id);
}

//*/


//////// end of save address //////////////////////




//echo '------------------------------------------------------------';
//print_r($httpResponse);
//echo '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++';

//$method->ssc_user_action = "override_commit";


//print("Http Response: " . print_r($httpResponse, true));

//************** end save address ***********************
/*
if($method->ssc_user_action === "commit")
	{
	$this->doexpress(urldecode($httpResponse['TOKEN']),urldecode($httpResponse['PAYERID']),$order_data["pectransid"]);   
	return null;   
	}
*/
if("SUCCESS" == strtoupper($httpResponse["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpResponse["ACK"]))
   {
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_STRIPE_SSC_REVIEW') . "</p>";


$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived');

$button =  
"<form method='POST' action='" . $url . "' onsubmit='return Form_Validator(this)'>
<input type='hidden' name='token' value='" . urldecode($httpResponse['TOKEN']) . "'>" .
"<input type='hidden' name='s' value='eccheckout'>" .
"<input type='hidden' name='PAYERID' value='" . urldecode($httpResponse['PAYERID']) . "'>" .

"<input type='hidden' name='pectransid' value='" . $order_data["pectransid"] . "'>" .

"<input type='submit' value='" . JText::_('VMPAYMENT_STRIPE_SSC_PLACE_ORDER') . "' name='B1'>" . 
"</form>";
   
   
echo $button;
echo '<br/>';
echo $table;

$address = $order['details']['BT'];

$del_address = null;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }

$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";


list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

echo '<br/>';

$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_BILLING_ADDRESS')  . '</b><br/>';
//print $this->billing_address_html($address,$country,$cc_state);
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING_ADDRESS') . '</b><br/>';
	//	print $this->shipping_address_html($del_address,$del_country,$del_state);
	echo $order_form_html_shipping;
	}

print '</td></tr></table>';

	
if($method->debug)
	{
	$real_shipping = $this->real_shipping_address($httpResponse); 
	echo "PayPal's Shipping Address:<br>" . $real_shipping . '<br>';
	}


print $button;
 
//print "<!-- Copyright Online Store 2012";

$html="";

		
//	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);

   }
else
   {
   $s=0;
   $error ="No";
         print "<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>";
   while(isset($httpResponse["L_LONGMESSAGE" . $s]))
   {

   
   if($httpResponse["L_ERRORCODE" . $s] == "500")
      {
	  print JText::_('VMPAYMENT_STRIPE_SSC_UNKNOWN_ERROR');   
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "81234")
      {
      print "";        
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'Security%20header%20is%20not%20valid')
      {
      print "Please check your API Username, Password and Signature for your Live or Sandbox account.";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'You%20do%20not%20have%20permissions%20to%20make%20this%20API%20call')
      {
      print "Do you have a valid Payments Pro Live or Sandbox account with the correct API Username, Password and Signature";	         
      }      
   else
      {
   
      if($error == 'No')
         {      
         print "<br>" . JText::_('VMPAYMENT_STRIPE_SSC_TRY_AGAIN') . ".<br>";
         $error='Yes';
         }
         	         
      print $httpResponse["L_ERRORCODE" . $s] . ": " . urldecode($httpResponse["L_LONGMESSAGE" . $s]) . " <br><br>\r\n";  
      }
   $s++;
     
   }
    print "<br></span><br>";
}
//print '--------- Review 1 -------------';
	

echo $this->hidessc();;
	

//    print 'invnum found<br>';
    
    return null; 
    
    }

	 
	 function process_stripe_payment($payment_intent,$source,$order_number='',$first_payment_html='')
	 {
		 			
			$comments='';
		 
		 $payment_intent_id = $payment_intent->id;
		 
	//		$this->log('order number:' . $order_number);
			/*
		{
		//
//require_once __DIR__  . '/stripe-php/init.php';
//$stripe = new \Stripe\StripeClient(
 // $secret_key
);
		//pi_3OkCQnGhPg0yig8B1MFR6DAz

//pm_1OkCRUGhPg0yig8BquuD2PGP
			 // Create a PaymentIntent with amount and currency
		$paymentIntent = \Stripe\PaymentIntent::create([
        'amount' => 1099,
        'currency' => $currency_code_3,
		  'setup_future_usage' => 'off_session',
		  'description' => $description,
		  'customer' => $stripe_customer_id,
			     'payment_method' => '{{PAYMENT_METHOD_ID}}',
        'automatic_payment_methods' => [
            'enabled' => true,
        ],
    ]);

    $output = [
        'clientSecret' => $paymentIntent->client_secret,
    ];
		

	}
		
	*/

	if($order_number == '')
		{
		$db = JFactory::getDBO();
		$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `paymentId` = '" .  $payment_intent_id . "'";
		$db->setQuery($q);
		$order_number = $db->loadResult();
		}
	
	
		
		
		
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
	
	if (!$virtuemart_order_id)
	  {
	  return;
	  }
	
	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

		
	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);


	
	
$publishable_key = $method->ssc_ssc1;
$secret_key = $method->ssc_ssc2;
//$merchant_id = $method->ssc_merchant_id;


if($method->ssc_environment == "sandbox")
   {
   $publishable_key = $method->ssc_ssc1_sb;
	$secret_key = $method->ssc_ssc2_sb;
	//$merchant_id = $method->ssc_sb_merchant_id;
   }


require_once __DIR__  . '/stripe-php/init.php';

$stripe = new \Stripe\StripeClient(
 $secret_key
);
			




//if($method->ssc_enable_conected_payments)
//		{
//			"transfer_data" => ["destination" => trim($method->ssc_connected_account_id)],








//	$payment_intent = $stripe->paymentIntents->retrieve($payment_intent_id, []);
			
	
	
	
		//	echo $payment_intent->payment_method;
			
	$stripe_intent_json = json_encode($payment_intent);

	
	
	
	
	
	
			 $db = JFactory::getDBO();
	 
	// if($method->debug){
	// print_r($paymentIntent);}
	 
	 // $paymentIntent->id
		 // $stripe_customer_id
		 
			 
			 	if($method->ssc_one_page == '1')
	{

try
	{
	
	
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `paymentId` = '" . $payment_intent_id . "' WHERE `order_number` = '" .  $order_number . "'";

	$db->setQuery($q);
	$result = $db->execute();
	

	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `stripe_customer_id` = '" . $payment_intent->customer . "' WHERE `order_number` = '" .  $order_number . "'";

	$db->setQuery($q);
	$result = $db->execute();
	
	
	$setup_future_usage = $payment_intent->setup_future_usage;
	
	//setup_future_usage == off_session
	
	if(isset($payment_intent->setup_future_usage) && $payment_intent->setup_future_usage == 'off_session')
		{
		$setup_future_usage='off_session';
		$comments = "Recurring Payment<br>";
		}
	else
		{
		$setup_future_usage='No';
		$comments = "One Off Payment";
		}
	
			
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `setupFutureUsage` = '" . $setup_future_usage . "' WHERE `order_number` = '" .  $order_number . "'";

	$db->setQuery($q);
	$result = $db->execute();
		

	}
catch (Exception $e)
	{
	echo '13:';
	echo $e->getMessage();
	}


	}
	
	
	

	
			
		//	print_r($payment_intent);		
try
{			
			
		$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `paymentMethod` = '" . $payment_intent->payment_method . "' WHERE `order_number` = '" .  $order_number . "'";

	$db->setQuery($q);
	$result = $db->execute();
	
	
	//$this->add_stripe_payment_intent($payment_intent_id,$stripe_intent_json, $order_number,$publishable_key);
	

	
	}
catch (Exception $e)
	{
	echo '14:';
	echo $e->getMessage();
	}




	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}
		
		
	if ($virtuemart_order_id)
	   {

		if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

		$modelOrder = VmModel::getModel("orders");
		
	$orders["order_status"] = $method->status_pending;
		
	if($payment_intent->status === 'succeeded')
		{
		$orders["order_status"] = $method->status_success;
		
	
		if(trim($first_payment_html) !== '')
			{
			$comments .= $first_payment_html;
			}		

	
	   $orders['comments'] = $comments; //'Comfirmed by JS';
		$orders["virtuemart_order_id"] = $virtuemart_order_id;
		$orders["customer_notified"] = 1;


	$paypal_fullresponse = '';// '{"PROFILEID":"' . urlencode($order_data["subcriptions_id"]) . '"}';
    
	$use_profile=true;
	
	if($source == 'JS')
		{
		$this->show_payment_details($paypal_fullresponse,$virtuemart_order_id, $orders,$use_profile);
		}
	
	
	// to do show payment plan details
	
   //$cart = VirtueMartCart::getCart ();
	
	//$selected = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id);
	
	//if($selected)
	//{
	//list($html_pplan,$use_profile,$profile_error,$first_payment_html) = $this->get_payment_name($selected,0,null);

	//$orderitems = $modelOrder->getOrder($virtuemart_order_id);	
	//echo $html_pplan;
	//}
	

	$orderitems = $modelOrder->getOrder($virtuemart_order_id);	

	
	
	$already_confirmed = 0;
	
	foreach($orderitems['history'] as $status)
		{
		//echo $status->order_status_code;
		if($status->order_status_code == $method->status_success)
			{
			$already_confirmed = 1;
			}
		}
	
	if($already_confirmed == 0)
		{
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}
		
		}
	else
	{
		
		
		echo 'We have been unable to process this payment <br><br><br> This payment has not been processed. Your card has not been charged.';	
		
	echo '
		
<br><br>
		<input
    action="action"
    onclick="window.history.go(-2); return false;"
    type="submit"
    value="Click to Return"
/>
		';
	echo $this->hidessc();;		
	}
	
	
	return;
	
		
		
	   }

	


		 
		 
		return; 
	 }
	
		
	 
function hidessc()
	{
	$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
.vm-order-done
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>

<img id='hidessc'/>
";
	return $hidessc;
	
	}
	 
			 
	 
function plgVmOnUserPaymentCancel()
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );


	
	$jinput =JFactory::getApplication()->input;
	$order_number = $jinput->get->get('on', null, 'CMD');
	$virtuemart_paymentmethod_id = $jinput->get->get('pm', null, 'CMD');


	if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id))
		{
		return NULL;
		}
   
	if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number)))
		{
		return NULL;
		}
   
   if (!($paymentTable = $this->getDataByOrderNumber($order_number)))
		{
		return NULL;
		}

	//check token?
		
	$method = $this->getPluginMethod($virtuemart_paymentmethod_id);
	$mod = VmModel::getModel('orders');
	$order = $mod->getOrder($virtuemart_order_id);
	if ($order['details']['BT']->order_status == $method->status_success) // || $order['details']['BT']->order_status == $method->status_pending) // || $order['details']['BT']->order_status == $method->status_capture)
		{
		return NULL;
		}
		
	if ($order['details']['BT']->order_status != $method->status_pending) // || $order['details']['BT']->order_status == $method->status_capture)
		{
		return NULL;
		}
		    
	$session = JFactory::getSession();
	$return_context = $session->getId();
	if (strcmp($paymentTable->plg_session_id, $return_context) === 0)
		{
		VmInfo(Jtext::_('VMPAYMENT_STRIPE_SSC_PAYMENT_CANCELLED'));
		$this->handlePaymentUserCancel($virtuemart_order_id);
		}    
	    

	return true;
    }




// Process silent post

// index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component

function PPHttpPost($method,$methodName_, $nvpStr_) {

	if(!ini_get('safe_mode'))
		{
		if(ini_get('max_execution_time') < 45)
			{ 
			if(false === strpos(ini_get("disable_functions"), "set_time_limit"))
				{
				//echo "set_time_limit functions are available.<br />\n";
				set_time_limit(45);
				}
		//	else
		//		{
				//echo "set_time_limit are not available.<br />\n";
		//		}          
			}
		}
		
	//echo 'time: ' . ini_get('max_execution_time');
		
// Set up your API credentials, PayPal end point, and API version.
	
	$API_UserName = trim($method->ssc_api_username);
	$API_Password = trim($method->ssc_api_password);
	$API_Signature = trim($method->ssc_api_signature);
	$API_Endpoint = "https://api-3t.paypal.com/nvp";
	
	$d = 0;
	
	if($method->ssc_environment === "sandbox" || $d == 1)
		{
		$API_UserName = trim($method->ssc_api_sb_username);
		$API_Password = trim($method->ssc_api_sb_password);
		$API_Signature = trim($method->ssc_api_sb_signature);
   	$API_Endpoint = "https://api-3t.sandbox.paypal.com/nvp";
		}
	

	$version = urlencode('114.0');

	// Set the curl parameters.
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $API_Endpoint);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);

	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
	
	 curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/fields/cacert.pem');

	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POST, 1);
	
		curl_setopt($ch, CURLOPT_TIMEOUT,35);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 35);

	
	// Set the API operation, version, and API signature in the request.
	$nvpreq = "METHOD=$methodName_&VERSION=$version&PWD=$API_Password&USER=$API_UserName&SIGNATURE=$API_Signature$nvpStr_";

//print 'nvpreq ' . "METHOD=$methodName_&VERSION=$version&PWD=$API_Password&USER=$API_UserName&SIGNATURE=$API_Signature" .'<br><br>';

	// Set the request as a POST FIELD for curl.
	curl_setopt($ch, CURLOPT_POSTFIELDS, $nvpreq);

	// Get response from the server.
	$httpResponse = curl_exec($ch);

	if(!$httpResponse) {
		exit("$methodName_ failed: ".curl_error($ch).'('.curl_errno($ch).')');
	}

	// Extract the response details.
	$httpResponseAr = explode("&", $httpResponse);

	$httpParsedResponseAr = array();
	foreach ($httpResponseAr as $i => $value) {
		$tmpAr = explode("=", $value);
		if(sizeof($tmpAr) > 1) {
			$httpParsedResponseAr[$tmpAr[0]] = $tmpAr[1];
		}
	}

	if((0 == sizeof($httpParsedResponseAr)) || !array_key_exists('ACK', $httpParsedResponseAr)) {
		exit("Invalid HTTP Response for POST request($nvpreq) to $API_Endpoint.");
	}

	return $httpParsedResponseAr;
}




function billing_shipping_address($address,$del_address,$country,$del_country,$state,$del_state)
{


 $pageURL = 'http';

if(isset($_SERVER["HTTPS"]))
 if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";};


 $pageURL .= "://";
 if ($_SERVER["SERVER_PORT"] != "80") {
  $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
 } else {
  $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
 }
$form_url = $pageURL;

//$script_name = $_SERVER["SCRIPT_NAME"];

$billing_script_name = $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT';

$shipping_script_name = $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST';

$order_data = $this->post_strings();
//$order_get = $this->get_strings();	


$cc_month='00';
$cc_year='00';
$cc_security_code='';
$cc_type='';
$cc_number='';

if(isset($order_data['cc_month']))
   {
   $cc_month=$order_data['cc_month'];
   }
 
if(isset($order_data['cc_year']))
   {
   $cc_year=$order_data['cc_year'];
   }


if(isset($order_data['cc_security_code']))
   {
   $cc_security_code=$order_data['cc_security_code'];
   }


if(isset($order_data['cc_type']))
   {
   $cc_type=$order_data['cc_type'];
   }

if(isset($order_data['cc_number']))
   {
   $cc_number=$order_data['cc_number'];
   }



$currency_code = 'USD';

$credit_cards=
'<option value="Visa">Visa</option>
<option value="MasterCard">MasterCard</option>
<option value="Discover">Discover</option>
<option value="Amex">American Express</option>
'; 

$start_date = '';
$issue_number = '';

if($currency_code == 'GBP')
   {

$start_date = '<tr>
       <td style="border-style:hidden" align="right">Start Date: Maestro/Solo Only:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><select name="cc_start_month" size="1">
        <option value=""> Month </option>
        <option value="01">01</option>
        <option value="02">02</option>
        <option value="03">03</option>
        <option value="04">04</option>
        <option value="05">05</option>
        <option value="06">06</option>
        <option value="07">07</option>
        <option value="08">08</option>
        <option value="09">09</option>
        <option value="10">10</option>
        <option value="11">11</option>
        <option value="12">12</option>
      </select><select name="cc_start_year" size="1">
        <option value=""> Year </option>
        <option value="2011">2011</option>
        <option value="2010">2010</option>
        <option value="2009">2009</option>
        <option value="2008">2008</option>
        <option value="2007">2007</option>
        <option value="2006">2006</option>
        <option value="2005">2005</option>
        <option value="2004">2004</option>
        <option value="2003">2003</option>
        <option value="2002">2002</option>
        <option value="2001">2001</option>
        <option value="2000">2000</option>
      </select></td>
    </tr>';


$issue_number = '
   <tr>
       <td style="border-style:hidden" align="right">Issue Number: Maestro/Solo Only:&nbsp; </td>
       <td style="border-style:hidden" align="left"><input
      name="cc_issue_number" size="3" MAXLENGTH="2" type="text"></td>
    </tr>';
    
$credit_cards .= '<option value="Solo">Solo</option>
   <option value="Switch">Maestro</option>';
	
   }        	
	
    
$order_form_html = <<<directorderform

<script language="JavaScript">
<!--

var submitted = 0;


      
function Form_Validator(theForm)
{
if(submitted==1)
   {
   alert("You have already submitted this form");
   return false;
   }

if (theForm.cc_number.value == "")
  {
    alert("Please enter a credit card number.");
    theForm.cc_number.focus();
    return (false);
  }

if (theForm.cc_security_code.value == "")
  {
    alert("Please enter a Security Code (CVV).");
    theForm.cc_security_code.focus();
    return (false);
  }

  if(submitted==0)
    {
    //form.submitit.disabled=true;
    submitted = 1;
    }

  return (true);
}
//--></script>


<form method="post" action="$form_url" name="Form1"
onsubmit="return Form_Validator(this)">
directorderform;


$editbillingaddress =  JText::_('VMPAYMENT_STRIPE_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_STRIPE_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_STRIPE_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_STRIPE_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_STRIPE_SSC_COUNTRY');
$order_form_zip = JText::_('VMPAYMENT_STRIPE_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_STRIPE_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_STRIPE_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_STRIPE_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_STRIPE_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL');
//$order_form_place_order = JText::_('VMPAYMENT_STRIPE_SSC_PLACE_ORDER');


$order_form_html_billing = <<<directorderform
 
<table cellspacing="0" cellpadding="2">
<tbody>
       
    <tr>
       <td style="border-style:hidden" colspan="2"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
      
$address->first_name $address->last_name 
      
</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
      
$address->address_1     
      
      </td>
    </tr>
    <tr>
directorderform;
    
    
if($address->address_2 != '')    
{    
$order_form_html_billing .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->address_2
      </td>
    </tr>
directorderform;

}

   
    
$order_form_html_billing .=
<<<directorderform
    <tr>
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->city   
     </td>
    </tr>
directorderform;
    
    
if($state != '')    
{
$order_form_html_billing .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$state</td>
	</tr>
directorderform;
}
    
$order_form_html_billing .= <<<directorderform
    <tr>
       <td style="border-style:hidden" align="right">$order_form_country:</td>    
      
       <td style="border-style:hidden" align="left" >&nbsp;
$country
      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->zip 
</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_email:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->email
      </td>
      </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_telephone:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->phone_1
      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
   </tbody>
  </table>
directorderform;

    
$editshippingaddress =  JText::_('VMPAYMENT_STRIPE_SSC_EDIT_SHIPPING_ADDRESS');

    
$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
directorderform;


if($del_address->address_2 != '')    
{    
$order_form_html_shipping .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
directorderform;
}


$order_form_html_shipping .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->city
      </td>
    </tr>
directorderform;
    
    
if($del_state != '')    
{
$order_form_html_shipping .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$del_state</td>
	</tr>
directorderform;
}
    
$order_form_html_shipping .= <<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_country:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>

    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
    
   </tbody>
  </table>
directorderform;

$credit_card_html = <<<directorderform
<table cellspacing="0" cellpadding="2">

  <tr>
       <td style="border-style:hidden" colspan="2" align="center" ><strong>Credit/Debit Card Details</strong></td>
      
  </tr>

  <tr>
       <td style="border-style:hidden" align="right">Credit/Debit Card
      Type:&nbsp; </td>
       <td style="border-style:hidden" align="left" >
      <select name="cc_type" size="1"  style="border: 1px solid #000000; margin: 2px;"; margin: 2px;">

$credit_cards

	 </select></td></tr>
    <tr>
       <td style="border-style:hidden" align="right">Card
      Number:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><input name="cc_number" value="$cc_number" size="40" type="text" style="border: 1px solid #000000; margin: 2px;"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">Security Code
      (CVV):&nbsp; </td>
       <td style="border-style:hidden" align="left" ><input
      name="cc_security_code" value="$cc_security_code" size="4" maxlength="4" type="text"  style="border: 1px solid #000000; margin: 2px;"></td>
    </tr><tr>
    
$issue_number
    
$start_date
directorderform;
    
$expiry_date = '<td style="border-style:hidden" align="right">Expiry Date:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><select name="cc_month" size="1" style="border: 1px solid #000000; margin: 2px;">
         <option value="00"> Month </option>
        <option value="01">01</option>
        <option value="02">02</option>
        <option value="03">03</option>
        <option value="04">04</option>
        <option value="05">05</option>
        <option value="06">06</option>
        <option value="07">07</option>
        <option value="08">08</option>
        <option value="09">09</option>
        <option value="10">10</option>
        <option value="11">11</option>
        <option value="12">12</option>';
        
              
$expiry_date = str_replace("value=\"$cc_month", "selected value=\"$cc_month", $expiry_date);

        
$expiry_year =         
      '</select><select name="cc_year" size="1"  style="border: 1px solid #000000; margin: 2px;">
        <option value="00"> Year </option>
        <option value="2010">2010</option>
        <option value="2011">2011</option>
        <option value="2012">2012</option>
        <option value="2013">2013</option>
        <option value="2014">2014</option>
        <option value="2015">2015</option>
        <option value="2016">2016</option>
        <option value="2017">2017</option>
        <option value="2018">2018</option>
        <option value="2019">2019</option>
        <option value="2020">2020</option>
        <option value="2021">2021</option>
        <option value="2022">2022</option>
      </select></td>';
      

$expiry_year = str_replace("value=\"$cc_year", "selected value=\"$cc_year", $expiry_year);      
      
$credit_card_html .= <<<directorderform
$expiry_date
$expiry_year 
    </tr>
       <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ><input
      value="Place Order" name="B1" type="submit"> <input value="Reset" name="B2" type="reset">&nbsp;
      </td>
    </tr>
  </table>
<input type='hidden' name='task' value='confirm'/>
		<input type='hidden' name='option' value='com_virtuemart'/>
		<input type='hidden' name='view' value='cart'/>
</form>
<p align="center">&nbsp;</p>
directorderform;

$order_form_html .= $order_form_html_billing . $credit_card_html;

return array($order_form_html,$order_form_html_billing,$order_form_html_shipping);

}


function shipping_address_html($del_address,$del_country,$del_state)
{

$editbillingaddress =  JText::_('VMPAYMENT_STRIPE_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_STRIPE_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_STRIPE_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_STRIPE_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_STRIPE_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_STRIPE_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_STRIPE_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_STRIPE_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_STRIPE_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_STRIPE_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL');


$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->city
      </td>
    </tr>
directorderform;
    
    
if($del_state != '')    
{
$order_form_html_shipping .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$del_state</td>
	</tr>
directorderform;
}
    

$order_form_html_shipping .= <<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_country:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>

    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    </tbody>
  </table>
directorderform;

return $order_form_html_shipping;
}



function log($txt)
	{
	$myfile = fopen("plugins/vmpayment/stripessc/log.txt", "a");# or die("Unable to open file!");
	fwrite($myfile, "\n". $txt);
	fclose($myfile);
	}
	
	
	
	
	
	
function check_signature($method)

{

$payload = file_get_contents('php://input');


$secret_key = $method->ssc_ssc2;
$endpoint_secret = $method->ssc_whsec;

if($method->ssc_environment == "sandbox")
   {

	$secret_key = $method->ssc_ssc2_sb;
	$endpoint_secret = $method->ssc_whsec_sb;
   }
	
$secret_key = trim($secret_key);
$endpoint_secret = trim($endpoint_secret);

\Stripe\Stripe::setApiKey($secret_key);
	
//ssc_whsec

$sig_header = $_SERVER['HTTP_STRIPE_SIGNATURE'] . 'a';
$event = null;

//$this->log('check Signature');

try {
    $event = \Stripe\Webhook::constructEvent(
        $payload, $sig_header, $endpoint_secret
    );
} catch(\UnexpectedValueException $e) {
    // Invalid payload
	$this->log('invalid payload');
    http_response_code(400);
    exit();
} catch(\Stripe\Exception\SignatureVerificationException $e) {
    $this->log('Invalid signature');
    http_response_code(400);
	// printf('sig');
	 printf($sig_header);
    exit();
}


$this->log('Signature Verified');


}	
	
	


function verify_webhook()
{
		if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
		 
	//echo '######################';
	//get the webhook payload

$requestBody = file_get_contents('php://input');

//check if webhook payload has data
if($requestBody) {
//request body is set
} else {
//request body is not set
return;
//exit(); 
}


require_once __DIR__  . '/stripe-php/init.php';

//$secret_key = $method->ssc_ssc2;

$payload = file_get_contents('php://input');

//$this->log('stripe sig' . $_SERVER['HTTP_STRIPE_SIGNATURE']);




try {
    $event = \Stripe\Event::constructFrom(
        json_decode($payload, true)
    );
} catch(\UnexpectedValueException $e) {
    // Invalid payload
	echo 'Invalid Payload';
    http_response_code(400);
    exit();
}








#### find method ####

  $intent = $event->data->object;
  
  //$this->log('Intent ID: ' . $intent->id);

	$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `paymentId` = '" .  $intent->id . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	 // $this->log('order number: ' . $order_number);
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
	
		 // $this->log('Virtuemart Order id: ' . $virtuemart_order_id);
	
	if (!$virtuemart_order_id)
		{
		//return;
		http_response_code(200);
		printf('No Virtuemart Order Id');
		exit();
		}
	

	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		http_response_code(200);
		printf('Payment is Null');
		exit();
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);

#### end of find method ####

	$this->check_signature($method);




//$output = print_r($event,true);

//$output = print_r($_SERVER,true);



///echo $event->id;

//$this->log('Webhook: ' . $output);

if ($event->type == "payment_intent.payment_failed")
	{
    $intent = $event->data->object;
    $error_message = $intent->last_payment_error ? $intent->last_payment_error->message : "";
    printf("Failed: %s, %s", $intent->id, $error_message);
    http_response_code(200);
	 //return;
    exit();
	}

	if (!class_exists("VirtueMartModelOrders"))
			require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

if ($event->type == "payment_intent.succeeded")
	{
	
	$intent = $event->data->object;
	
	$this->log( $intent->id);
	$first_payment_html='';
	
	
	$this->process_stripe_payment($intent,'Webhook',$order_number,$first_payment_html);
	
	
   printf("Succeeded: %s", $intent->id);
   http_response_code(200);
	exit();
	
	 /*
	$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `paymentId` = '" .  $intent->id . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
	
	if (!$virtuemart_order_id)
		{
		//return;
		http_response_code(200);
		printf('No Virtuemart Order Id');
		exit();
		}
	

	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		http_response_code(200);
		printf('Payment is Null');
		exit();
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		//return false;
		http_response_code(200);
		printf('Element Not Selected');
		exit();
		}
	
//$this->process_stripe_payment($payment_intent_id,$source);	
		$modelOrder = VmModel::getModel("orders");
		$orders["order_status"] = $method->status_success;
	
	   $orders['comments'] = 'Comfirmed by Webhook';
		$orders["virtuemart_order_id"] = $virtuemart_order_id;
		$orders["customer_notified"] = 1;
		

		$orderitems = $modelOrder->getOrder($virtuemart_order_id);	
	
		//if((isset($orderitems['details']['BT']->order_status) && ($orderitems['details']['BT']->order_status == 'P')))
		//	{
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		//	}

	
	//echo 'Status Updated';
	//return;
		http_response_code(200);
	printf('Attempt to Update Order');		
	exit();
		*/
	   }


	
	
	//return;
			http_response_code(200);
	printf($event->type);
	exit();
	


	
	
	
} 

	


// blank page no html background

// index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component
//verify_webhook

function plgVmOnPaymentNotification()
	{
	if (!class_exists('VirtueMartModelOrders'))
		{
		require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php');
		}
		

	//	$post_data = $this->post_strings();
	$get_data = $this->get_strings();		
	


	if(isset($get_data["cs"]))
		{
		if($json = json_decode(file_get_contents("php://input"), true))
			{
		//	$this->create_subscription($json);
			return;
			}
		}	



		
if($json = json_decode(file_get_contents("php://input"), true))
	{

	$this->verify_webhook($json);

	return;
	}

	
		

		
return null;
	

}


function real_shipping_address($httpResponse) 
 {
 
$editbillingaddress =  JText::_('VMPAYMENT_STRIPE_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_STRIPE_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_STRIPE_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_STRIPE_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_STRIPE_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_STRIPE_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_STRIPE_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_STRIPE_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_STRIPE_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_STRIPE_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_STRIPE_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL');
 
 
$SHIPTOSTREET2=''; 

if(isset($httpResponse["SHIPTOSTREET2"]))
	{
	$SHIPTOSTREET2=$httpResponse["SHIPTOSTREET2"];
	}

$PHONENUM=''; 
	if(isset($httpResponse["PHONENUM"]))
	{
	$PHONENUM=$httpResponse["PHONENUM"];
	}

 
 
$table =
'<table cellspacing="0" cellpadding="2">
<tbody>
 
    <tr>
    <tr>
       <td style="border-style:hidden" colspan="2"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse['SHIPTONAME']) .

'</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse["SHIPTOSTREET"]) .

'      </td>
    </tr>
    <tr>
      <td></td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($SHIPTOSTREET2) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["SHIPTOCITY"]) .

'     </td>
    </tr><tr>
       <td style="border-style:hidden" align="right">$order_form_state:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["SHIPTOSTATE"]) .

'      </td>
    </tr><tr>
       <td style="border-style:hidden" align="right">$order_form_country:</td>    
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["COUNTRYCODE"]) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse["SHIPTOZIP"]) .

'</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_email:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["EMAIL"]) .

'      </td>
      </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_telephone: </td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($PHONENUM) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
   </tbody>
  </table>';
  
  return($table);
 }



function order_form($order,$method,$customer_currency)
{

if (!class_exists('CurrencyDisplay'))
    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');

$paymentCurrency = CurrencyDisplay::getInstance();

if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
	}



// no payment method id is set. Order is null. First run

if(!isset($order['details']['BT']->virtuemart_paymentmethod_id))
	{
	
	//echo '--------- order is null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$cart->virtuemart_paymentmethod_id = $virtuemart_paymentmethod_id;
	$cart->setCartIntoSession();
	}
else
   {
   //echo '--------- order is not null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	
	//$db = JFactory::getDbo();
	//$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
	//$db->setQuery($q);
	//$virtuemart_paymentmethod_id = $db->loadResult();
	
	//$cart->virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
	//$cart->setCartIntoSession();
   
   }

#print "--------------------------------------------------<br>\n\n";
#print_r($cart);
#print "--------------------------------------------------<br>\n\n";
//print_r($order);
#print "--------------------------------------------------<br>\n\n";

//$method->ssc_multi_currency=0;

if($method->debug)
	{
	echo '$method->ssc_multi_currency ' . $method->ssc_multi_currency . '<br>';
	echo '$customer_currency ' . $customer_currency . '<br>';
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	}

$this->getPaymentCurrency($method);  // code 0 is default ??

if($method->ssc_multi_currency)
	{
	$prices_currency = $customer_currency;
	}
else
	{
	$prices_currency = $method->payment_currency;
	}




if($method->debug)
	{
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	echo '$prices_currency ' . $prices_currency . '<br>';	
	}
	
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$dp=2;

if($currency_code_3 == 'JPY')
	{
	$dp=0;
	}

//echo '22222222222222';
//echo $currency_code_3;
//echo '+++++++++++++';


$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';

$db->setQuery($q);
$currency_symbol = $db->loadResult();

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$inc_tax = 0;




$unit_price = JText::_('VMPAYMENT_STRIPE_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

$table = '<table border="1" width="600" cellspacing="0" cellpadding="2" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_STRIPE_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_STRIPE_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_TOTALS') . '</font></strong></td>
</tr>';

 //   <td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
 //   size="2">&nbsp;Line&nbsp;Total</font></strong></td>
 // </tr>';
 

$i = 1;

foreach ($order["items"] as $key => $product)
//--foreach ($cart->products as $key => $product)
	{
	$line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
	//--$line_item_name = substr(strip_tags($product->product_name), 0, 127);
	     
	     
	$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
	//--$line_id = substr(strip_tags($product->product_sku), 0, 127);
	     
	//$cost = number_format($product->product_item_price,$dp,'.','');
	$cost = $product->product_item_price;
	//--$cost = $cart->pricesUnformatted[$key]["basePrice"];
	
	$cost = $paymentCurrency->convertCurrencyTo($prices_currency, $cost, false);
	$cost = number_format($cost,$dp,'.','');
	     
	// $line = $product->product_subtotal_with_tax;
	     
	// $line = $paymentCurrency->convertCurrencyTo($prices_currency, $line, false);
	     
	// $line = number_format($line,$dp,'.','');
	     

     
	//--$qty = $product->quantity;
	
	$qty = $product->product_quantity;
	     
	$line_fields = $product->product_attribute;
	//--$line_fields = '';//$product->customfields; xx


	
	if (!empty($product->product_attribute))
		{
		if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'customfields.php');
		$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
		}
	
	$strip_line_fields = strip_tags($line_fields);


	if($line_fields === '')
		{
	    $line_description = substr($line_id, 0, 127);
		}
	else
		{
		$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
		}
	     
	$n = $i-1;
	    
	$line_order_details .= 
	"&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($line_item_name) .
	"&L_PAYMENTREQUEST_0_NUMBER" . "$n=" . urlencode($line_description) .
	"&L_PAYMENTREQUEST_0_QTY" . "$n=" . $qty .  
	"&L_PAYMENTREQUEST_0_AMT" . "$n=" . $cost;
	
	

    
    
		
    
	$line_order_total += $qty * $cost;
     
     
	$table = $table . '<tr>';    
   
	$table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
	$table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
	$table = $table . '</td>'; 
      
	$table = $table . '<td valign="top" align="right">' .  $currency_symbol . $cost . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,$dp,'.','') . '</td>'; 
  
   
// $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' . number_format($line,$dp,'.','') . '</td>'; 
  
	$table = $table . '</tr>';
    
	$i++;
	     
	} 	  
	// print '-----------';
	// print $line_order_details;
	// print '-----------';     	     

//echo $cart->pricesUnformatted["paymentValue"];

//order_payment ???
	  if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
	  //--if(isset($cart->pricesUnformatted["paymentValue"]) && $cart->pricesUnformatted["paymentValue"] > 0)
	     {  
	     //--$order_payment = $cart->pricesUnformatted["paymentValue"];
	     $order_payment = $order['details']['BT']->order_payment;
	     
         $order_payment = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $payment_fee = JText::_('VMPAYMENT_STRIPE_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($payment_fee) .
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $order_payment;
         
         
 
         
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . $payment_fee . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . $currency_symbol . number_format($order_payment,$dp,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,$dp,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,$dp);

$shipping = 0;

//--	if(isset($cart->pricesUnformatted["shipmentValue"]) && $cart->pricesUnformatted["shipmentValue"] > 0)
//--		{  
//--    $shipping = $cart->pricesUnformatted["shipmentValue"];
	    
	if(isset($order['details']['BT']->order_shipment) && $order['details']['BT']->order_shipment > 0)
		{  
	   $shipping = $order['details']['BT']->order_shipment;
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($prices_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,$dp,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,$dp,'.','') . '</td></tr>';
	    }


//number_format($amount,$dp,'.','');
$total_tax = 0;
/*
	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {  
	     $total_tax = $order['details']['BT']->order_tax;
	     
	     $total_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $total_tax, false);
         }	     

	  if(isset($order['details']['BT']->order_shipment_tax) && $order['details']['BT']->order_shipment_tax > 0)
	     {
         $order_shippment_tax = $order['details']['BT']->order_shipment_tax;
         
         $order_shippment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_shippment_tax, false);
         
	     $total_tax += $order_shippment_tax;
	     }

	  if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
	     {
         $order_payment_tax = $order['details']['BT']->order_payment_tax;
         
         $order_payment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment_tax, false);
         
	     $total_tax += $order_payment_tax;
	     }
*/

//paymentTax

	if(isset($order['details']['BT']->order_billTaxAmount) && $order['details']['BT']->order_billTaxAmount > 0)
	//--if(isset($cart->pricesUnformatted["billTaxAmount"]) && $cart->pricesUnformatted["billTaxAmount"] > 0)
	     {
         $order_bill_tax = $order['details']['BT']->order_billTaxAmount;
         //--$order_bill_tax = $cart->pricesUnformatted["billTaxAmount"];
        
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     	//	echo 'Order bill tax set ' . $order_bill_tax;
	     	}
	     }


      if($total_tax > 0 || $shipping > 0)
       {
	    $total_tax = number_format($total_tax,$dp,'.','');
	    
// add surcharge to tax total	    

	    $line_order_total2 = number_format($line_order_total,$dp,'.','');
		$shipping2 = number_format($shipping,$dp,'.','');
		$total_tax2 = number_format($total_tax,$dp,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,$dp,'.','');

		$cart_order_total2 = $order['details']['BT']->order_total;
		//--$cart_order_total2 = $cart->pricesUnformatted["billTotal"];
		
		
		$cart_order_total2 = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total2,false); //convert1

		$cart_order_total2 = number_format($cart_order_total2,$dp,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
			//$order_total2 = $cart_order_total2;
			$total_discount2 = number_format($total_discount2,$dp,'.','');
			    
	    	//if($total_tax-$total_discount2>0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	
	    	//if($total_tax > 0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	//elseif($shipping > 0)
	    	//	{
	    	//	$shipping +=  $total_discount2;
	    //	//	$line_order_total -= $total_discount2;
	    	//	}
				
			
			
	    	if($shipping > 0)
	    		{
	    		$shipping +=  $total_discount2;
	    //		$line_order_total -= $total_discount2;
	    		}
			elseif($total_tax > 0)
	    		{
	    		$total_tax += $total_discount2;
	    		}				

	    
	    	}

//end of surchange adjustment



 
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,$dp,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;
//billDiscountAmount

/*
	  if(isset($order['details']['BT']->coupon_discount) && $order['details']['BT']->coupon_discount > 0)
	     {  
	     $total_discount = $order['details']['BT']->coupon_discount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Coupon+Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$order->couponCode" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Coupon:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
	     
	     
$total_discount = 0;
//billDiscountAmount
	  if(isset($order['details']['BT']->order_billDiscountAmount) && $order['details']['BT']->order_billDiscountAmount >0)
	     {  
	     $total_discount = $order['details']['BT']->order_billDiscountAmount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     // $total_discount = round($paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false),$dp);
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Discount:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
*/


$line_order_total = number_format($line_order_total,$dp,'.','');
$shipping = number_format($shipping,$dp,'.','');
$total_tax = number_format($total_tax,$dp,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,$dp,'.','');


$cart_order_total = $order['details']['BT']->order_total;
//**$cart_order_total = $cart->pricesUnformatted["billTotal"];

$cart_order_total = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total,false); //convert 2

$cart_order_total = number_format($cart_order_total,$dp,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
         
         
    

    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $surcharge = urlencode(JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE'));
	     $surcharge = 'sur';
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=$surcharge" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$surcharge" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
         
  
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,$dp,'.','') . '</td></tr>';

 $table .= '</table>';

  $table .= '<p style="font-size: small">';
	
	$table .= '<table cellspacing="0" cellpadding="2">';
	//$table .= '<tr><td style="border-style:hidden">';
	//$table .= JText::_('VMPAYMENT_STRIPE_SSC_ORDER_NUMBER') . ':</td>';
	//$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
	//$table .= $order["details"]["BT"]->order_number;
	//$table .= '</td></tr>';
	
	$table .= '<tr><td style="border-style:hidden; text-align: right;">';
	$table .= JText::_('VMPAYMENT_STRIPE_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
	$table .= $currency_code_3;
	$table .= '</td></tr>';
	
	$table .= '</table>';
	
	$table .= '</style>';

//$method->debug = 0;
if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>3<br/>";
	echo '</span>';

//print_r($order);
//print_r($cart);

echo '<br><br>';
echo $_SERVER["SERVER_PORT"] .'<br>';
echo $_SERVER["SERVER_NAME"] .'<br>';
echo $_SERVER["REQUEST_URI"] .'<br>';

if(isset($_SERVER["HTTPS"]))
	{
	echo $_SERVER["HTTPS"]  . '<br>';
	}
else
	{
	echo'No<br>';
	}

echo 'JURI root: ' . JURI::root()  . '<br>';
//echo 'JURI root: ' . JURI::root(false,'')  . '<br>';
}
//echo "<br>Order Total: $order_total<br>
//Line Order Total: $line_order_total<br>
//Total Discount: $total_discount<br>
//Total Tax: $total_tax<br>
//Shipping: $shipping<br>";





##pplan
$INITAMT=0;
$installment=0;

list($html,$use_profile,$profile_error,$first_payment_html,$INITAMT,$installment,$no_of_monthly_payments) = $this->get_payment_name($method,$order_total,$order);



	$invoice_num = $order["details"]["BT"]->order_number;
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `total_payments` = '" . $order_total   . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo '15:';
	echo $e->getMessage();
	}
	


try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `no_of_monthly_payments` = '" . $no_of_monthly_payments   . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo '16:';
	echo $e->getMessage();
	}

		
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `first_payment` = '" . $INITAMT  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo '17:';
	echo $e->getMessage();
	}
	
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `monthly_payment` = '" . $installment  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo '18:';
	echo $e->getMessage();
	}
	
	
	
$order_seconds = time();
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `order_seconds` = '" . $order_seconds  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo '19:';
	echo $e->getMessage();
	}	
	
	
	
	
	
	
	
$datetime = new JDate('now');
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `created_on` = '" . $datetime  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo '20:';
	echo $e->getMessage();
	}	

	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `defer_installments` = '" . $method->ssc_pplan_defer  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}	

	date_default_timezone_set('UTC');
	
	

	if($method->ssc_pplan_defer == '1')
		{
		$zulu = $method->ssc_pplan_defer_date;
		}	
			
	
try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `defer_date` = '" . $zulu  . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}	
	
	




$pppitems = array();

return array($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems);

}


################ begin success ##################



function process_success($paymentId,$PayerID,$pectransid)
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );


$order_data = $this->post_strings();
$order_get = $this->get_strings();	
		

//print_r($order_data);


	//$post_msg ='';
		
	//foreach ($order_data as $key => $value)
	//   {
	//   $post_msg .= $key . "=" . $value . "<br />";
	//   }
	
	//echo $post_msg;
	
	
	//	$httpResponse['TOKEN'],$httpResponse['PAYERID'],$order_data["pectransid"]
//$TOKEN,$PAYERID,$pectransid
//function doexpress($TOKEN,$PAYERID,$pectransid)	
	
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($pectransid);
//**	$this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');

	if (!$virtuemart_order_id)
	  {
	  return;
	  }


	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	if (!$this->selectedThisElement($method->payment_element)) {
	
	print 'no order id for ppp';
	    return false;
	}
	

	

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);



//print_r($method);
//print print_r($order);

//print print_r($payment);
	

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

//if($method->ssc_multi_currency)
//	{
	$customer_currency = trim($payment->alt_currency);
//	}
//else
//	{
//	$customer_currency = $method->payment_currency;
//	}


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);



$address = $order['details']['BT'];

$del_address = null;
	
if(isset($order['details']['ST']))
   {
   $del_address = $order['details']['ST'];
   }
else
   {
   $del_address = $order['details']['BT'];
   }


$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";

list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

$shop_code = $payment->currency_code;

//$method->ssc_multi_currency=0;

if($method->ssc_multi_currency)
	{
	$customer_currency = trim($payment->alt_currency);
	$this->getPaymentCurrency($method);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $customer_currency  . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$shop_code = $db->loadResult();
	}



####### Begin Update ##############
$httpResponse = null;
   
//ssc_show_thank_you
//ssc_show_receipt_address
//ssc_api_receipt_header
//ssc_api_receipt_header

///////////// Update Order Log/////////////////



$transactions = $payment->getTransactions();

$transaction = $transactions[0];

$payer = $payment->getPayer();

//print_r($payer);

$httpResponse =  new StdClass;



/*

[payment_instruction] => Array
	(
	[reference_number] => 7FC35911MD7697828
	[instruction_type] => PAY_UPON_INVOICE
	[recipient_banking_instruction] => Array
		(	
		[bank_name] => Deutsche Bank
		[account_holder_name] => PayPal Europe
		[international_bank_account_number] => DE07120700888000XXXXXX
		[bank_identifier_code] => DEUTDEDBPAL
		)
[amount] => Array
	(
	[value] => 4.99
	[currency] => EUR
	)

[payment_due_date] => 2015-09-24
[links] => Array
	(
	[0] => Array
		(
		[href] =>
		https://api.paypal.com/v1/payments/payment/PAY-
		1VG08356YH269600PKXOBRAY/payment-instruction
		[rel] => self
		[method] => GET
 * 
 * 


*/


$comment = '';

if(isset($payment->payment_instruction->recipient_banking_instruction->bank_name))
{
$httpResponse->bank_name  = $payment->payment_instruction->recipient_banking_instruction->bank_name;
$httpResponse->account_holder_name = $payment->payment_instruction->recipient_banking_instruction->account_holder_name;
$httpResponse->international_bank_account_number = $payment->payment_instruction->recipient_banking_instruction->international_bank_account_number;
$httpResponse->bank_identifier_code = $payment->payment_instruction->recipient_banking_instruction->bank_identifier_code;

$httpResponse->value = $payment->payment_instruction->amount->value;
$httpResponse->currency = $payment->payment_instruction->amount->currency;
$httpResponse->payment_due_date = $payment->payment_instruction->payment_due_date;
$httpResponse->href = $payment->payment_instruction->links[0]->href;


$httpResponse->reference_number = $payment->payment_instruction->reference_number;

$httpResponse->instruction_type = $payment->payment_instruction->instruction_type;

$comment = 'Kauf auf Rechnung<br />' .	
$httpResponse->bank_name . '<br />' .		  
$httpResponse->account_holder_name . '<br />' .
$httpResponse->international_bank_account_number . '<br />' .
$httpResponse->bank_identifier_code . '<br />' .
		  
$httpResponse->value  . '<br />' .
$httpResponse->currency  . '<br />' .
'Faelligkeit: ' . $httpResponse->payment_due_date . '<br />' .
'Referenznummer:' . $httpResponse->reference_number;

}

//Amount
$httpResponse->total = $transaction->amount->total;
$httpResponse->currency = $transaction->amount->currency;

$httpResponse->subtotal = $transaction->amount->details->subtotal;
$httpResponse->tax = $transaction->amount->details->tax;
$httpResponse->shipping = $transaction->amount->details->shipping;


$httpResponse->merchant_id = $transaction->payee->merchant_id;

$httpResponse->description = $transaction->description;
$httpResponse->invoice_number = $transaction->invoice_number;

$httpResponse->shipping_recipient_name   = $transaction->item_list->shipping_address->recipient_name;
$httpResponse->shipping_line1   = $transaction->item_list->shipping_address->line1;
$httpResponse->shipping_city   = $transaction->item_list->shipping_address->city;
$httpResponse->shipping_state   = $transaction->item_list->shipping_address->state;
$httpResponse->shipping_postal_code = $transaction->item_list->shipping_address->postal_code;
$httpResponse->shipping_country_code   = $transaction->item_list->shipping_address->country_code;

$httpResponse->id = $transaction->related_resources[0]->sale->id;
$httpResponse->state = $transaction->related_resources[0]->sale->state;


$httpResponse->payment_mode = $transaction->related_resources[0]->sale->payment_mode;

$httpResponse->protection_eligibility  = $transaction->related_resources[0]->sale->protection_eligibility;
$httpResponse->protection_eligibility_type = $transaction->related_resources[0]->sale->protection_eligibility_type;


$httpResponse->parent_payment = $transaction->related_resources[0]->sale->parent_payment;

//property of non object???
//$httpResponse->transaction_fee_value = $transaction->related_resources[0]->sale->transaction_fee->value;
//$httpResponse->transaction_fee_currency = $transaction->related_resources[0]->sale->transaction_fee->currency;

$httpResponse->create_time = $transaction->related_resources[0]->sale->create_time;
$httpResponse->update_time = $transaction->related_resources[0]->sale->update_time;

$httpResponse->payment_method = $payer->payment_method;
$httpResponse->payer_status = $payer->status;


$httpResponse->email = $payer->payer_info->email;
$httpResponse->first_name = $payer->payer_info->first_name;
$httpResponse->last_name = $payer->payer_info->last_name;
$httpResponse->payer_id = $payer->payer_info->payer_id;
$httpResponse->phone = $payer->payer_info->phone;
$httpResponse->country_code = $payer->payer_info->country_code;



$paypal_fullresponse = json_encode($httpResponse);

$db = JFactory::getDBO();

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `paypal_fullresponse` = '" . $paypal_fullresponse . "' WHERE `#__virtuemart_payment_plg_stripessc`.`virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	//$db->query($q);
	$db->execute();

	}
catch (Exception $e)
	{
	echo '21:';
	echo $e->getMessage();
	}

	
	
//////////// End Update Order Log ////////////////	


if($method->ssc_show_thank_you)
	{
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_STRIPE_SSC_THANK_YOU_FOR_YOUR_ORDER') . "</p>";
	}
   
echo $method->ssc_receipt_header;
echo '<br/><br/>';
echo $table;
echo '<br/>';

//$order_form_html_billing = $this->shipping_address_html($del_address,$del_country,$del_state);

if($method->ssc_show_receipt_address)
	{
	
$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_BILLING_ADDRESS')  . '</b><br/><br/>';
//print $this->billing_address_html($address,$country,$cc_state);
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING_ADDRESS') . '</b><br/><br/>';
	//	print $this->shipping_address_html($del_address,$del_country,$del_state);
	echo $order_form_html_shipping;
	}

print '</td></tr></table>';
	
	}

$table = '<p style="font-size: small">';
	
$table .= '<table cellspacing="0" cellpadding="2">';
$table .= '<tr><td style="border-style:hidden">';
$table .= JText::_('VMPAYMENT_STRIPE_SSC_ORDER_NUMBER') . ':</td>';
$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
$table .= $order["details"]["BT"]->order_number;
$table .= '</td></tr>';
	
//$table .= '<tr><td style="border-style:hidden; text-align: right;">';
//$table .= JText::_('VMPAYMENT_STRIPE_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
//$table .= $currency_code_3;
//$table .= '</td></tr>';
	
$table .= '</table>';
	
$table .= '</style>';

echo $table;

echo $method->ssc_receipt_footer;

echo $method->ssc_raw;



//process_order

$new_status = "C";
	
	if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

	$modelOrder = VmModel::getModel("orders");
	
	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	$nb_history = count($orderitems['history']);
	
	$orders["order_status"] = "C";
	$orders["virtuemart_order_id"] = $virtuemart_order_id;
	$orders["customer_notified"] = 1;
	$orders["comments"] = $comment;


/*
 $orderitems = $modelOrder->getOrder($virtuemart_order_id);
	    
	    $nb_history = count($orderitems['history']);
	    
	    if($nb_history == 1)
	       {
		   $order['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PAYPAL_EMAIL_SENT');
		   $order['customer_notified'] = 0;
	       }
	    else
	       {
		   $order['customer_notified'] = 1;
	       }
	*/       


	if ($orderitems['history'][$nb_history - 1]->order_status_code != $orders['order_status'])
		{
		$orders['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_STRIPE_SSC_CONFIRMED_EMAIL_SENT');
		$orders['customer_notified'] = 1;	
		}
	else
		{
		$orders['customer_notified'] = 0;		
		}


	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	
	$already_confirmed = 0;
	
	foreach($orderitems['history'] as $status)
		{
		//echo $status->order_status_code;
		if($status->order_status_code == 'C')
			{
			$already_confirmed = 1;
			}
		}
	
	
	if($already_confirmed == 0)
		{
		//echo '--------- Confirm Order ----------------' . $orderitems['details']['BT']->order_status;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}
	

echo $this->hidessc();;


$this->emptyCart(null);


 
return;
   
#####  end update ##########
}

################ end success ###################




function order_form_cart($order,$method,$customer_currency)
{
	


if (!class_exists('CurrencyDisplay'))
    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');

$paymentCurrency = CurrencyDisplay::getInstance();

if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
	}



############# Begin Express Code #####################

/*
// no payment method id is set. Order is null. First run

if(!isset($order['details']['BT']->virtuemart_paymentmethod_id))
	{
	//echo '--------- order is null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$cart->virtuemart_paymentmethod_id = $virtuemart_paymentmethod_id;
	$cart->setCartIntoSession();
	}
else
   {
   //echo '--------- order is not null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	
	//$db = JFactory::getDbo();
	//$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
	//$db->setQuery($q);
	//$virtuemart_paymentmethod_id = $db->loadResult();
	
	//$cart->virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
	//$cart->setCartIntoSession();
   
   }
   
*/   
############ End Express Code ############################# 


############# PayPal Plus Code #################

# virtuemart_paymentmethod_id not required

$cart = VirtueMartCart::getCart ();
$cart->prepareCartData(); //xxx
$cart->getCartPrices();

############ End PayPal Plus Code #############



  

#print "--------------------------------------------------<br>\n\n";
#print_r($cart);
#print "--------------------------------------------------<br>\n\n";
//print_r($order);
#print "--------------------------------------------------<br>\n\n";

//$method->ssc_multi_currency=0;

if($method->debug)
	{
	echo '$method->ssc_multi_currency ' . $method->ssc_multi_currency . '<br>';
	echo '$customer_currency ' . $customer_currency . '<br>';
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	}

$this->getPaymentCurrency($method);  // code 0 is default ??

if($method->ssc_multi_currency)
	{
	$prices_currency = $customer_currency;
	}
else
	{
	$prices_currency = $method->payment_currency;
	}




if($method->debug)
	{
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	echo '$prices_currency ' . $prices_currency . '<br>';	
	}
	
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$dp=2;

if($currency_code_3 == 'JPY')
	{
	$dp=0;
	}

//echo '22222222222222';
//echo $currency_code_3;
//echo '+++++++++++++';


$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';

$db->setQuery($q);
$currency_symbol = $db->loadResult();

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';

$trusted_line_items=''; 
$line_order_total = 0;
$trusted_line_items='';    ## Tracking
$inc_tax = 0;




$unit_price = JText::_('VMPAYMENT_STRIPE_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

$table = '<table border="1" width="600" cellspacing="0" cellpadding="2" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_STRIPE_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_STRIPE_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_STRIPE_SSC_TOTALS') . '</font></strong></td>
</tr>';

 //   <td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
 //   size="2">&nbsp;Line&nbsp;Total</font></strong></td>
 // </tr>';
$pppitems = array();
$i = 1;

//--foreach ($order["items"] as $key => $product)
foreach ($cart->products as $key => $product)
	{
	//--$line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
	$line_item_name = substr(strip_tags($product->product_name), 0, 127);
	     
	     
	//--$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
	$line_id = substr(strip_tags($product->product_sku), 0, 127);
	     
	//$cost = number_format($product->product_item_price,$dp,'.','');
	//--$cost = $product->product_item_price;
	$cost = $cart->pricesUnformatted[$key]["basePrice"];
	
	$cost = $paymentCurrency->convertCurrencyTo($prices_currency, $cost, false);
	$cost = number_format($cost,$dp,'.','');
	     
	// $line = $product->product_subtotal_with_tax;
	     
	// $line = $paymentCurrency->convertCurrencyTo($prices_currency, $line, false);
	     
	// $line = number_format($line,$dp,'.','');
	     

     
	$qty = $product->quantity;
	
	//--$qty = $product->product_quantity;
	     
	//--$line_fields = $product->product_attribute;
	$line_fields = '';//$product->customfields; xx


	
	if (!empty($product->product_attribute))
		{
		if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'customfields.php');
		$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
		}
	
	$strip_line_fields = strip_tags($line_fields);


	if($line_fields === '')
		{
	    $line_description = substr($line_id, 0, 127);
		}
	else
		{
		$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
		}
	     
	$n = $i-1;
	    
	$line_order_details .= 
	"&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($line_item_name) .
	"&L_PAYMENTREQUEST_0_NUMBER" . "$n=" . urlencode($line_description) .
	"&L_PAYMENTREQUEST_0_QTY" . "$n=" . $qty .  
	"&L_PAYMENTREQUEST_0_AMT" . "$n=" . $cost;
	
	
         
  /// $pppitem = new \PayPal\Api\Item();
   
   
   
   
	//$pppitem->setName($line_item_name)
   // ->setCurrency($currency_code_3)
   // ->setQuantity($qty)
   // ->setSku($line_description) // Similar to `item_number` in Classic API
   // ->setPrice($cost);
   
	///if(trim($line_description) == '')
	///	{
	
	///$pppitem->setName($line_item_name)
   ///setCurrency($currency_code_3)
   /// ->setQuantity($qty)
   /// ->setPrice($cost);
   
	///	}
	///else
	///	{
    
 ///   $pppitem->setName($line_item_name)
  ///  ->setCurrency($currency_code_3)
  ///  ->setQuantity($qty)
  ///  ->setSku($line_description) // Similar to `item_number` in Classic API
  ///  ->setPrice($cost);
    
	///	}

    
    
    
    
 
    
    
    
///	$pppitems[$n] = $pppitem;
	
	
	if($i>1){$trusted_line_items = $trusted_line_items .  ',';}
	
	$trusted_line_items .=
	'{' .
	'"name": ' . json_encode($line_item_name) . ',' .
	# urlencode($line_description) .
		'"unit_amount":  {
					"value": ' . json_encode($cost) . ',
               "currency_code": ' . json_encode($currency_code_3) . '
               
            },' .
		'"quantity": ' . json_encode($qty) .
	'}'; 
	
	

	
    
	$line_order_total += $qty * $cost;
     
     
	$table = $table . '<tr>';    
   
	$table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
	$table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
	$table = $table . '</td>'; 
      
	$table = $table . '<td valign="top" align="right">' .  $currency_symbol . $cost . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,$dp,'.','') . '</td>'; 
  
   
// $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' . number_format($line,$dp,'.','') . '</td>'; 
  
	$table = $table . '</tr>';
    
	$i++;
	     
	} 	  
	// print '-----------';
	// print $line_order_details;
	// print '-----------';     	     

//echo $cart->pricesUnformatted["paymentValue"];

//order_payment ???
	  //--if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
	  if(isset($cart->pricesUnformatted["paymentValue"]) && $cart->pricesUnformatted["paymentValue"] > 0)
	     {  
	     $order_payment = $cart->pricesUnformatted["paymentValue"];
	     //--$order_payment = $order['details']['BT']->order_payment;
	     
         $order_payment = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $payment_fee = JText::_('VMPAYMENT_STRIPE_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($payment_fee) .
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $order_payment;
         
         

	///		$pppitem = new \PayPal\Api\Item();
	///		$pppitem->setName($payment_fee)
	///			->setCurrency($currency_code_3)
	///			->setQuantity(1)
	///			->setPrice($order_payment);
				
			//->setSku('') // Similar to `item_number` in Classic API				
				
	///		$pppitems[$n] = $pppitem;

			
	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode($payment_fee) . ',' .
	'"unit_amount":  {
						"value": ' . json_encode($order_payment) . ',
						"currency_code": ' . json_encode($currency_code_3) . '
							},' .
	'"quantity": "1"' .
	'}';
		     
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . $payment_fee . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . $currency_symbol . number_format($order_payment,$dp,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,$dp,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,$dp);

$line_items_total =  $line_order_total;

$shipping = 0;

	if(isset($cart->pricesUnformatted["shipmentValue"]) && $cart->pricesUnformatted["shipmentValue"] > 0)
		{  
    $shipping = $cart->pricesUnformatted["shipmentValue"];
	    
//--	if(isset($order['details']['BT']->order_shipment) && $order['details']['BT']->order_shipment > 0)
//--		{  
//--	   $shipping = $order['details']['BT']->order_shipment;
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($prices_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,$dp,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,$dp,'.','') . '</td></tr>';
	    }


//number_format($amount,$dp,'.','');
$total_tax = 0;
/*
	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {  
	     $total_tax = $order['details']['BT']->order_tax;
	     
	     $total_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $total_tax, false);
         }	     

	  if(isset($order['details']['BT']->order_shipment_tax) && $order['details']['BT']->order_shipment_tax > 0)
	     {
         $order_shippment_tax = $order['details']['BT']->order_shipment_tax;
         
         $order_shippment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_shippment_tax, false);
         
	     $total_tax += $order_shippment_tax;
	     }

	  if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
	     {
         $order_payment_tax = $order['details']['BT']->order_payment_tax;
         
         $order_payment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment_tax, false);
         
	     $total_tax += $order_payment_tax;
	     }
*/

//paymentTax

	//--if(isset($order['details']['BT']->order_billTaxAmount) && $order['details']['BT']->order_billTaxAmount > 0)
	if(isset($cart->pricesUnformatted["billTaxAmount"]) && $cart->pricesUnformatted["billTaxAmount"] > 0)
	     {
         //--$order_bill_tax = $order['details']['BT']->order_billTaxAmount;
         $order_bill_tax = $cart->pricesUnformatted["billTaxAmount"];
        
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     	//	echo 'Order bill tax set ' . $order_bill_tax;
	     	}
	     }


      if($total_tax > 0 || $shipping > 0)
       {
	    $total_tax = number_format($total_tax,$dp,'.','');
	    
// add surcharge to tax total	    

	    $line_order_total2 = number_format($line_order_total,$dp,'.','');
		$shipping2 = number_format($shipping,$dp,'.','');
		$total_tax2 = number_format($total_tax,$dp,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,$dp,'.','');

		//--$cart_order_total2 = $order['details']['BT']->order_total;
		$cart_order_total2 = $cart->pricesUnformatted["billTotal"];
		
		
		$cart_order_total2 = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total2,false); //convert1

		$cart_order_total2 = number_format($cart_order_total2,$dp,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
			//$order_total2 = $cart_order_total2;
			$total_discount2 = number_format($total_discount2,$dp,'.','');
			    
	    	//if($total_tax-$total_discount2>0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	
	    	//if(total_tax > 0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	//elseif($shipping > 0)
	    	//	{
	    	//	$shipping +=  $total_discount2;
	    //	//	$line_order_total -= $total_discount2;
	    	//	}
			
			
			if($shipping > 0)
	    		{
	    		$shipping +=  $total_discount2;
	    //		$line_order_total -= $total_discount2;
	    		}
			elseif($total_tax > 0)
	    		{
	    		$total_tax += $total_discount2;
	    		}

	    
	    	}

//end of surchange adjustment



 
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,$dp,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;
//billDiscountAmount

/*
	  if(isset($order['details']['BT']->coupon_discount) && $order['details']['BT']->coupon_discount > 0)
	     {  
	     $total_discount = $order['details']['BT']->coupon_discount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Coupon+Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$order->couponCode" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Coupon:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
	     
	     
$total_discount = 0;
//billDiscountAmount
	  if(isset($order['details']['BT']->order_billDiscountAmount) && $order['details']['BT']->order_billDiscountAmount >0)
	     {  
	     $total_discount = $order['details']['BT']->order_billDiscountAmount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     // $total_discount = round($paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false),$dp);
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Discount:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
*/


$line_order_total = number_format($line_order_total,$dp,'.','');
$shipping = number_format($shipping,$dp,'.','');
$total_tax = number_format($total_tax,$dp,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,$dp,'.','');


//--$cart_order_total = $order['details']['BT']->order_total;
$cart_order_total = $cart->pricesUnformatted["billTotal"];

$cart_order_total = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total,false); //convert 2

$cart_order_total = number_format($cart_order_total,$dp,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
    
         
  ///       $pppitem = new \PayPal\Api\Item();
	///		$pppitem->setName('Discount')
	///			->setCurrency($currency_code_3)
	///			->setQuantity(1)
	///			->setSku('Discount') // Similar to `item_number` in Classic API
	///			->setPrice($total_discount);
				
	///		$pppitems[$n] = $pppitem;
         
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     $adjustment = $total_discount;
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $surcharge = urlencode(JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE'));
	     $surcharge = 'sur';
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=$surcharge" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$surcharge" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
    
         #    urlencode($line_item_name) .
         
            
      ///   $pppitem = new \PayPal\Api\Item();
		///	$pppitem->setName($surcharge)
		///		->setCurrency($currency_code_3)
		///		->setQuantity(1)
		///		->setPrice($total_discount)
				
		///	->setSku($surcharge); // Similar to `item_number` in Classic API
				
				
		///	$pppitems[$n] = $pppitem;
			
			
			
			
			
			
						  	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode('Ajustment') . ',' .
	'"unit_amount":  {
							"value": ' . json_encode($adjustment) . ',
							"currency_code": ' . json_encode($currency_code_3) . '					
							},' .
	'"quantity": "1"' .
	'}';
		
			
			
         
         
 //   print_r($pppitems);
         $line_order_total = $line_order_total + $total_discount;
			
			$line_items_total =  number_format($line_order_total,2,'.','');
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_STRIPE_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,$dp,'.','') . '</td></tr>';

 $table .= '</table>';

  $table .= '<p style="font-size: small">';
	
	$table .= '<table cellspacing="0" cellpadding="2">';
	//$table .= '<tr><td style="border-style:hidden">';
	//$table .= JText::_('VMPAYMENT_STRIPE_SSC_ORDER_NUMBER') . ':</td>';
	//$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
	//$table .= $order["details"]["BT"]->order_number;
	//$table .= '</td></tr>';
	
	$table .= '<tr><td style="border-style:hidden; text-align: right;">';
	$table .= JText::_('VMPAYMENT_STRIPE_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
	$table .= $currency_code_3;
	$table .= '</td></tr>';
	
	$table .= '</table>';
	
	$table .= '</style>';

//$method->debug = 0;
if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>4<br/>";
	echo '</span>';

//print_r($order);
//print_r($cart);

echo '<br><br>';
echo $_SERVER["SERVER_PORT"] .'<br>';
echo $_SERVER["SERVER_NAME"] .'<br>';
echo $_SERVER["REQUEST_URI"] .'<br>';

if(isset($_SERVER["HTTPS"]))
	{
	echo $_SERVER["HTTPS"]  . '<br>';
	}
else
	{
	echo'No<br>';
	}

echo 'JURI root: ' . JURI::root()  . '<br>';
//echo 'JURI root: ' . JURI::root(false,'')  . '<br>';
}
//echo "<br>Order Total: $order_total<br>
//Line Order Total: $line_order_total<br>
//Total Discount: $total_discount<br>
//Total Tax: $total_tax<br>
//Shipping: $shipping<br>";

return array($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems,$trusted_line_items,$line_items_total);

}




function https_check($url)
	{
	//echo '<br><br>';
	//echo $_SERVER["SERVER_PORT"] .'<br>';
	//echo $_SERVER["SERVER_NAME"] .'<br>';
	//echo $_SERVER["REQUEST_URI"] .'<br>';

	if(isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] === 'on')
		{
		//$url = str_replace("http://", "https://", $url, 1);
		$url = preg_replace("/^http:/", "https:", $url);
		}
		
	return $url;

	}




function _getTablepkeyValue($virtuemart_order_id) {
	$db = JFactory::getDBO();
	$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
	$db->setQuery($q);

	if (!($pkey = $db->loadResult())) {
	    //J Error::raiseWarning(500, $db->getErrorMsg());
	    JFactory::getApplication()->enqueueMessage($db->getErrorMsg());
	    return '';
	}
	return $pkey;
    }

    /**
     * Display stored payment data for an order
     * @see components/com_virtuemart/helpers/vmPSPlugin::plgVmOnShowOrderBEPayment()
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {

	if (!$this->selectedThisByMethodId($payment_method_id)) {
	    return null; // Another method was selected, do nothing
	}
	
	if (!($method = $this->getVmPluginMethod ($payment_method_id))) { //$this->_currentMethod
			return NULL; // Another method was selected, do nothing   // xxx
		}

		
						$user = JFactory::getUser();        // Get the user object

$isroot = $user->authorise('core.admin');
//	if($user->id != 0)

		
		

	$db = JFactory::getDBO();
	$q = 'SELECT * FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
	$db->setQuery($q);
	if (!($paymentTable = $db->loadObject())) {
	    // J Error::raiseWarning(500, $db->getErrorMsg());
	    return '';
	}
	$this->getPaymentCurrency($paymentTable);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();
	
	$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->payment_currency . '" ';
	
	$db->setQuery($q);
	$currency_symbol = $db->loadResult();
	
	$html = '<table class="adminlist">' . "\n";
//	$html .=$this->getHtmlHeaderBE();
//	$html .= $this->getHtmlRowBE('Payment Method', $paymentTable->payment_name);

	
	$modelOrder = new VirtueMartModelOrders(); 
	
	$order = $modelOrder->getOrder($virtuemart_order_id);	
	
	$address = $order['details']['BT'];
	
		$cc_name = trim($address->first_name) . ' ' . trim($address->last_name);
		/*
		$first_name = trim($address->first_name);
		$last_name = $address->last_name;
		$cc_address_line_1 = $address->address_1;
		$cc_address_line_2 = $address->address_2;
		//$admin_area_2 = $address->city;
		$cc_city = $address->city;
		$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, 'country_2_code');
		$cc_postal_code = $address->zip;
		$cc_phone = $address->phone_1;
		$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";
	
	*/	
		$cc_email = $address->email;
	
  
	//$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	//	$virtuemart_paymentmethod_id = $order_data["pm"];

	//$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
		$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	

	
			$db = JFactory::getDBO();
	$q = "SELECT `paymentId` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$payment_id = $db->loadResult();
	
	
				$db = JFactory::getDBO();
	$q = "SELECT `paymentMethod` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$payment_method = $db->loadResult();
	
	
		$db = JFactory::getDbo();
	$q = 'SELECT `stripe_intent_id` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = "'. $order_number . '"';
	$db->setQuery($q);

	$id = $db->loadResult();
	

	
	$db = JFactory::getDbo();
	$q = 'SELECT `stripe_intent_json` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = "'. $order_number . '"';
	$db->setQuery($q);

	$json = $db->loadResult();
	
	$json = json_decode($json);
	
			$post_data = $this->post_strings();
	$get_data = $this->get_strings();


	
	if(isset($post_data["future_payments"]) && $post_data["future_payments"] == 'off_session')
	   {
		try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `setupFutureUsage` = 'off_session' WHERE `order_number` = '" .  $order_number . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}

		}
			
if(isset($post_data["future_payments"]) && $post_data["future_payments"] == 'cancelled')
	   {
		try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_stripessc` SET `setupFutureUsage` = 'cancelled' WHERE `order_number` = '" .  $order_number . "'";

	$db->setQuery($q);
	$result = $db->execute();
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}

		}	
			
	
	
	
	// first payemnt
	$amount = ($json->amount)/100;
	$amount = number_format($amount,2,'.','');
	
	
		$db = JFactory::getDBO();
	$q = "SELECT `total_payments` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$total_payments = $db->loadResult();
	
	
	$db = JFactory::getDBO();
	$q = "SELECT `monthly_payment` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$monthly_payment = $db->loadResult();
	

	$db = JFactory::getDBO();
	$q = "SELECT `no_of_monthly_payments` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$no_of_monthly_payments = $db->loadResult();
	
	$db = JFactory::getDBO();
	$q = "SELECT `first_payment` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$first_payment = $db->loadResult();
	
	
		$db = JFactory::getDbo();
	$q = "SELECT `defer_date` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);

	$defer_date = $db->loadResult();
	
			$db = JFactory::getDbo();
	$q = "SELECT `defer_installments` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);

	$defer_installments = $db->loadResult();

	
	
		$db = JFactory::getDBO();
	$q = "SELECT `stripe_customer_id` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);

	$stripe_customer_id = $db->loadResult();
	
			$db = JFactory::getDBO();
	$q = "SELECT `setupFutureUsage` FROM `#__virtuemart_payment_plg_stripessc` WHERE `virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	
	$setup_future_usage =  $db->loadResult();
	
	
		
	$off_session='';
	$cancelled='';
	
if($setup_future_usage === 'off_session')
	{
	$off_session='selected';		
	}
 else
	{
	$cancelled='selected';		
	}


	

	
	
	$db = JFactory::getDbo();
	$q = 'SELECT `created_seconds` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = "'. $order_number . '"';
	$db->setQuery($q);

	$date_seconds = $db->loadResult();

	
	$date = date("M j, Y, g:i a", $date_seconds);
	

		
		$account_id = $method->ssc_ssc1;
$secret_key = $method->ssc_ssc2;
//$merchant_id = $method->ssc_merchant_id;


if($method->ssc_environment == "sandbox")
   {
	$account_id = $method->ssc_ssc1_sb;
	$secret_key = $method->ssc_ssc2_sb;
	//$merchant_id = $method->ssc_sb_merchant_id;
   }
	
$account_id = trim($account_id);
$secret_key = trim($secret_key);	 
		 

require_once __DIR__  . '/stripe-php/init.php';
$stripe = new \Stripe\StripeClient(
  $secret_key
);
		




	############## start pm ##########
/*
echo '########### pm ##############################';
	
	$paymentmethods = 	$stripe->customers->allPaymentMethods(
	
	$stripe_customer_id,
	['limit' => 10]
		  
	,		  
		  ["stripe_account" => $method->ssc_connected_account_id]			  
		  
	);
	
	// = $paymentmethods->data[0]->id;
	
	
	
	$new_fingerprint = $json->charges->data[0]->payment_method_details->card->fingerprint;
	
	$new_payment_method_id = $json->charges->data[0]->payment_method;
	
	$new_payment_method = $json->charges->data[0];
	
	echo '-- created ---';
	
	echo $new_payment_method->created;

foreach ($paymentmethods as $paymentMethod)
	{
		echo '<br>-----------------------<br>';
	echo $paymentMethod->id;
	echo '<br>';
	echo $paymentMethod->card->fingerprint;
		echo '<br>';
		echo $paymentMethod->card->last4;
		echo '<br>';
	echo $paymentMethod->customer;


	if($paymentMethod->card->fingerprint === $new_fingerprint)
		{
		echo "<br>Fingerprint Match<br>";
		
		if($new_payment_method_id === $paymentMethod->id)
			{
			echo 'ID Match<br>';	
			}
		else
			{
		#	stripe.PaymentMethod.detach($paymentMethod->id);
			echo $paymentMethod->id;
			echo '<br>';
			}
		}
	
	
		echo '<br>-----------------------<br>';}

*/
	
	############## end pm ##########









	
		
			$order_rank = null;
	
	//"stripessc" AND `published` = 1
	if(isset($get_data["payment_no"]))
		{
		$db = JFactory::getDbo();
		$q = 'SELECT `order_rank` FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = "'. $order_number . '" AND `order_rank` = "' . $get_data["payment_no"]  . '"';
		$db->setQuery($q);
		$order_rank = $db->loadResult();
		}

				
		
		# check if payment has previouly been made
		
	if (isset($post_data["future"]) && $order_rank == null)
	   {
		//	print_r($get_data["future"]);
			$monthly_payment = round($monthly_payment*100);
		$first_payment = round($first_payment*100);
	
		
		/*
		$payments = $order_total - $order_payment - $order_payment_tax;// - $pplan_admin_fee;
		$installment = $payments/$no_of_payments;
		$installment = floor($installment * 100) / 100;
		$remainer = $payments - ($installment*$no_of_payments);
		$INITAMT = $installment + $remainer + $order_payment + $order_payment_tax;
		$INITAMT = number_format($INITAMT,2,'.','');
		$installment = number_format($installment,2,'.','');
		*/
		

	   if($post_data["future"] == 'process')
	      {
 	 
		

		//pi_3OkCQnGhPg0yig8B1MFR6

	\Stripe\Stripe::setApiKey($secret_key);

$description = $this->description_order($order,$virtuemart_order_id);

$installment_number = $get_data["payment_no"] . '/' . $no_of_monthly_payments;

$meta_data_invoice_number = $order_number . ' ' . $get_data["payment_no"] . '/' . $no_of_monthly_payments;

$description = $order_number . ' (' . $installment_number . ') ' . $description;

if(strlen($description) > 349)
	{
	$description = substr($description,0,348);
	}

//$description = str_pad($description, 600, "-=", STR_PAD_LEFT);	
	
	
	
	
	
	
	$paymentmethods = 	$stripe->customers->allPaymentMethods(
	
	$stripe_customer_id,
	['limit' => 3]
		  
	,		  
		  ["stripe_account" => $method->ssc_connected_account_id]			  
		  
	);
	
	$payment_method = $paymentmethods->data[0]->id;
	
	
	
	//$fingerprint = $json->charges->data[0]->payment_method_details->card->fingerprint;
/*
foreach ($paymentmethods as $paymentMethod)
	{
	
//	echo $paymentMethod->id;
//	echo '<br>';
//	echo $paymentMethod->card->fingerprint;
//		echo '<br>';
//		echo $paymentMethod->card->last4;
//		echo '<br>';
//	echo $paymentMethod->customer;
//	echo '<br>-----------------------<br>';

	if($paymentMethod->card->fingerprint === $fingerprint)
		{
		if($json->charges->data[0]->payment_method === $paymentMethod->id)
		{
		echo 'Match<br>';	
		}
		else
		{
	echo $paymentMethod->id;
		echo '<br>';
		}

		}
	
	
	}

*/
	
	
	
	
	

if(!$method->ssc_enable_conected_payments)
	{


	$paymentIntent = \Stripe\PaymentIntent::create([
    "amount" => $monthly_payment,
    "currency" => $currency_code_3,
	 // In the latest version of the API, specifying the `automatic_payment_methods` parameter is optional because Stripe enables its functionality by default.
    "automatic_payment_methods" => ["enabled" => true],
	"customer" => $stripe_customer_id,
			 "description" => $description,
    "payment_method" => $payment_method,
    "return_url" => JURI::root(),
    "off_session" => true,
    "confirm" => true,
	"metadata"=> ["invoice"=> $order_number,"payment_no"=> $get_data["payment_no"]]
    ]);

    $output = [
        "clientSecret" => $paymentIntent->client_secret,
    ];
			}
			else
	 
			{


$application_fee_percent = $method->ssc_application_fee_percent;

$application_fee_percent = ($monthly_payment/100)*$application_fee_percent;

$application_fee_percent = number_format($application_fee_percent,0,".","");

/*
$payment_method = \Stripe\PaymentMethod::create([
  "customer" => $stripe_customer_id,
  "payment_method" => $payment_method],
["stripe_account" => $method->ssc_connected_account_id,]);
*/

			
		$paymentIntent = \Stripe\PaymentIntent::create([
        "amount" =>   $monthly_payment,
        "currency" => "$currency_code_3",
	  "automatic_payment_methods" => ["enabled" => true],
	"customer" => $stripe_customer_id,
	"description" => $description,
    "payment_method" => $payment_method,
    "return_url" => JURI::root(),
    "off_session" => true,
	  "confirm" => true,
	"application_fee_amount" => $application_fee_percent,
	"metadata"=> ["invoice"=> $order_number,"payment_no"=> $get_data["payment_no"]]
		],		  
		  ["stripe_account" => $method->ssc_connected_account_id]				  
				  
				  );	
		
		}
			

		 
		 
    $stripe_intent_json = json_encode($paymentIntent);
	 
	 $db = JFactory::getDBO();
	 
	// if($method->debug){
	// print_r($paymentIntent);
	// }
	 
		 $publishable_key='';
		 
		
	$this->add_stripe_payment_intent($paymentIntent->id, $stripe_intent_json, $order_number,$publishable_key,$get_data['payment_no']);
		 
		   	    
	      }
	   }





	
	

	

#	$html .= 'no of monthly payments' .  $no_of_monthly_payments . '<br>';
	

	
	
	
	
//	for($n=1;$n < $no_of_monthly_payments;$n++)
//	{

		
//		$html .= '<tr><td>' . date("Y/m/d", strtotime("+$n month", $date_seconds)) . "</td><td>Payment </td><td>" . $json->status . '</td><td>' . $currency_symbol . $monthly_payment . '</td>';
		
		
		
//	$html .= '<td>';	
		
//	$stripe 	
		//stripe_intent_id
		//vm_order_no
		//stripe_intent_json
		
				//	$date_seconds 
	//$date = date("M j, Y, g:i a", $date_seconds);
		
	$payment_details = $paymentTable->payment_name;
	
				$payment_details .= '<br>';
	$payment_details .= $cc_name;
			$payment_details .= '<br>';
				$payment_details .= $cc_email;
	//		$payment_details .= '<br>';
	//$payment_details .= 'Customer ID: ' . $stripe_customer_id;
		$payment_details .= '<br>';
	$payment_details .= 'VM Order Number: ' . $order_number;
		$payment_details .= '<br>';
//			$payment_details .= 'Order Date: ' . $date;
		
	$payment_details .= '<br>';
				
	$url = JURI::root() . "index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&view_stripe_single_subscription=1&virtuemart_order_id=" . $virtuemart_order_id;

				
	if($setup_future_usage === 'off_session' || $setup_future_usage === 'cancelled')
	{
				if($isroot)
		{	
		
	$html .= '
	<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '">';
	
	$payment_details .=	"<label for='future'>Future Payments:</label>
 
	<select name='future_payments' onchange='this.form.submit()'>
	<option value='off_session' $off_session>Enabled</option>
  	<option value='cancelled' $cancelled>Cancelled</option>
	</select>

	<input type='hidden' name='show_details' value='yes'/>
	
	</form><br>";
		}
	$payment_details .= '<div><b>Monthly payment.</b></div>';	
	}
else
	{
	$payment_details .= '<div><b>One off payment.</b></div>';	
	}
				
				
		
		$payment_details .= '<br><br>';
		
		
	//		$payment_details .= ': ' . $date;
	//	$payment_details .= '<br>';	
		 
    //$stripe_intent_json = json_encode($paymentIntent);
		
	$html .= $payment_details;
	

	
/*
$payment_intents = $stripe->paymentIntents->all(['limit' => 3]);	

$n=0;

//function add_stripe_payment_intent($stripe_intent_id , $stripe_intent_json,$vm_order_no,$ssc_ssc1,$order_rank=0)

   while(isset($payment_intents['data'][$n]))
   {
echo $payment_intents['data'][$n]->status;
echo '<br>';
$n++;
	}

#print_r($payment_intents);

*/
	
	$q = 'SELECT * FROM `#__virtuemart_payment_plg_stripessc_intents` WHERE `vm_order_no` = "'. $order_number . '"';
	
	$db->setQuery($q);

	$payments = $db->loadAssocList();
	
	$successful_payments = 0;
	
	$payment_attempts = 0;
	
	$total_paid = 0;
	
	$html .= '<table cellpadding="2" cellspacing="0" style="width: 500px; border-style: solid; border-width: 2px">';
	$html .= "<tr><td style='border: 1px solid #000000' >Date </td><td style='border: 1px solid #000000' >Payment Intent </td><td style='border: 1px solid #000000'>Status</td><td style='border: 1px solid #000000'>Amount </td><td>No.</td></tr>";
	
	foreach($payments as $payment)
		{
	
	
//	$payment_date = date('Y/m/d H:i', $seconds);
	
	$json = json_decode($payment['stripe_intent_json']);
	
	$html .= "<tr><td style='border: 1px solid #000000'>" . date("M j, g:i a, Y", $payment["created_seconds"]) . "</td><td style='border: 1px solid #000000'>$json->id </td><td style='border: 1px solid #000000'>" . $json->status . "</td><td style='border: 1px solid #000000'>" . $currency_symbol . number_format(($json->amount/100),2,'.','') . '</td>';
	
	$payment_attempts++;
	
	$html .= "<td style='border: 1px solid #000000'>$payment_attempts</td></tr>";
	
	if($json->status ==='succeeded')
	{
	$successful_payments++;
	
	$total_paid += $json->amount;
	}
		}
		
	$html .= "<tr><td style='border: 1px solid #000000'></td><td style='border: 1px solid #000000'></td><td style='border: 1px solid #000000'></td><td style='border: 1px solid #000000'>" . $currency_symbol . number_format(($total_paid/100),2,'.','') . '</td>';
		
		
	$html .= '</table>';
	
$html .= '<div><br>';
$html .= 'No of Payment Attempts: ' . $payment_attempts;
$html .= '</div>';	
	
$html .= '<div><br>';
$html .= 'No of Successful Payments: ' . $successful_payments;
$html .= '</div>';

$html .= '<div><br>';
$html .= 'Payments Received : ' . $currency_symbol . number_format(($total_paid/100),2,'.','');
$html .= '</div>';
//date("y-m-d",strtotime($result->defer_date)) 

//$date = date('Y-m-d', strtotime('+1 month'));

$defer_time = strtotime($defer_date);

$offset = -1;

if($defer_installments == '0')
	{
	$defer_time = $date_seconds;
	$offset=0;
	}

	
$next_payment = $successful_payments + $offset;

$next_month = $next_payment+2;
	

//$next_payment = 'No. ' . $next_month .' due ' . date('M j, Y', strtotime('+' . $next_payment . ' month',$defer_time));
$next_payment = date('M j, Y', strtotime('+' . $next_payment . ' month',$defer_time));


	
$payment_attempts++;



  

$url = JURI::root() . "administrator/index.php?option=com_virtuemart&view=orders&task=edit&virtuemart_order_id=$virtuemart_order_id";

//$url = JURI::root() . "administrator/index.php?option=com_virtuemart&view=orders&task=edit&virtuemart_order_id=" . $virtuemart_order_id . '#order_details';


$url = JURI::root() . "index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&view_stripe_single_subscription=1&virtuemart_order_id=" . $virtuemart_order_id;

//if($monthly_payment > 0)

//monthly_payment
//monthly_payment


if($setup_future_usage !== 'cancelled')
	{

if($no_of_monthly_payments > 0)
	{
	if($isroot)
	{
	$html .= '<br>
	<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '&payment_no=' . $payment_attempts . '">';

	$html .= "

	<input type='hidden' id='ssc_order_rank' name='order_rank' value='$payment_attempts'/>
		
	<input type='hidden' name='future' value='process'/>
	
	<input type='hidden' name='show_details' value='yes'/>
		
	<input onclick='return confirm(\"Process this payment. Are you sure?\");' type='submit' value='$next_payment'/>
	</form><br>";
	}
	$html . 	$html .= "<div><br><b>Next payment. $next_payment</b><br><br></div>";
	
	}
else
	{
	$html .= '<div><b>One off payment. No future payments are possible</b></div>';	
	}
}

//$html .= $json->setup_future_usage;

$html .= "Expiry Date: " . $json->charges->data[0]->payment_method_details->card->exp_month . '/' . $json->charges->data[0]->payment_method_details->card->exp_year;

$html .= "<br>";

$html .= "Issuing Country: " . $json->charges->data[0]->payment_method_details->card->country;

$html .= "<br>";

$html .= "Last 4 digits: " . $json->charges->data[0]->payment_method_details->card->brand . ' ' . $json->charges->data[0]->payment_method_details->card->last4;

$html .= "<br><br>";

//$html .= print_r($json,true);




	$account_id = $method->ssc_ssc1;
$secret_key = $method->ssc_ssc2;
//$merchant_id = $method->ssc_merchant_id;


if($method->ssc_environment == "sandbox")
   {
	$account_id = $method->ssc_ssc1_sb;
	$secret_key = $method->ssc_ssc2_sb;
	//$merchant_id = $method->ssc_sb_merchant_id;
   }
	
$account_id = trim($account_id);
$secret_key = trim($secret_key);	 
		 

require_once __DIR__  . '/stripe-php/init.php';
$stripe = new \Stripe\StripeClient(
  $secret_key
);	




//$stripe->paymentMethods->detach($paymentMethod->id, []);


		//	$stripe_customer_id = 'cus_Q3Dw7wjVdIv59t';






/*

$customer_portal = $stripe->billingPortal->sessions->create(
[
  'customer' => $stripe_customer_id,
  'return_url' => 'https://www.online-store.co.uk',
],
		  
		  ['stripe_account' => $method->ssc_connected_account_id]			  
		  	  
		  
		  
		  );
*/

/*
$portal = $stripe->billingPortal->configurations->create([
  'business_profile' => [
		
		'headline'  => 'Dance School',
    'privacy_policy_url' => 'https://demo.1danceschool.com',
    'terms_of_service_url' => 'https://demo.1danceschool.com',
  ],
  'features' => [
    'customer_update' => [
      'allowed_updates' => ['email', 'tax_id'],
      'enabled' => true,
    ],
		
	'payment_method_update' =>  ['enabled' => true],
    'invoice_history' => ['enabled' => true],
  ],
	 
	
],
		    	  ['stripe_account' => $method->ssc_connected_account_id]);

*/
////echo ' #################### ';
//echo $portal->id;
//echo ' #################### ';

//bpc_1PZuLcGhPg0yig8BpVvOjVoi
//bpc_1PZuae2cRCVprvbSdYsyIGPU

//bpc_1PZv0m2cRCVprvbSNFi7X6rl
/*
$portal_id = 'bpc_1PZv0m2cRCVprvbSNFi7X6rl';

$customer_portal = $stripe->billingPortal->sessions->create(
[
  'customer' => $stripe_customer_id,
  'configuration' => $portal_id,
  'return_url' => 'https://www.online-store.co.uk'		  
	 
],
		  	  ['stripe_account' => $method->ssc_connected_account_id]	
		  );

//	  ['stripe_account' => $method->ssc_connected_account_id]

*/	
		/*
$paymentmethods = 	$stripe->customers->allPaymentMethods(
	
	$stripe_customer_id,
	['limit' => 100]
		  
	,		  
		  ["stripe_account" => $method->ssc_connected_account_id]			  
		  
	);

*/
//echo $customer_portal->url;


	echo '<br>';
		echo '<br>';
			echo "Customer :  $stripe_customer_id";

		echo '<br>';
			echo 'Payment Method: ' . $payment_id;
		echo '<br>';

	echo '<br>fingerprint: ';
	
	
	   //           echo $json->charges->data[0]->payment_intent;
      //           echo $json->charges->data[0]->payment_method;
	
		echo  $json->charges->data[0]->payment_method_details->card->fingerprint;
	echo '<br>';
//print_r($json);


//$fingerprint = $json->charges->data[0]->payment_method_details->card->fingerprint;
/*
foreach ($paymentmethods as $paymentMethod)
	{
	
//	echo $paymentMethod->id;
//	echo '<br>';
//	echo $paymentMethod->card->fingerprint;
//		echo '<br>';
//		echo $paymentMethod->card->last4;
//		echo '<br>';
//	echo $paymentMethod->customer;
//	echo '<br>-----------------------<br>';

	if($paymentMethod->card->fingerprint === $fingerprint)
		{
		if($json->charges->data[0]->payment_method === $paymentMethod->id)
		{
		echo 'Match<br>';	
		}
		else
		{
	echo $paymentMethod->id;
		echo '<br>';
		}

		}
	
	
	}

*/







//print_r($methods);
/*
$stripe->billingPortal->sessions->create
([
  'customer' => $stripe_customer_id,
["on_behalf_of" => $method->ssc_connected_account_id]	
		  
]);










//$html .= print_r($json->charges->data[0]->payment_method_details,true);



$html .= $this->hidessc();


//	$html .= $this->getHtmlRowBE('&nbsp;','Kauf auf Rechnung');
			
		//$html .= $this->getHtmlRowBE('Bank','11','yuyy');

	
	
	
	/*if(empty($id))
		{		

		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);
		
		$created_seconds = time();
		
		// Insert columns.
		$columns = array('stripe_intent_id','stripe_intent_json' , 'stripe_publishable_key', 'vm_order_no', 'vm_email', 'created_on','created_seconds', 'created_by','modified_on','modified_by','locked_on','locked_by');

	
	/*
	
		$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_stripessc` WHERE `paymentId` = '" .  $paymentId . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	*/
	
	
	return $html;
    }

 /*
    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
	if (preg_match('/%$/', $method->cost_percent_total)) {
	    $cost_percent_total = substr($method->cost_percent_total, 0, -1);
	} else {
	    $cost_percent_total = $method->cost_percent_total;
	}
//	return (10.01);
	return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }
*/    

    /**
     * Check if the payment conditions are fulfilled for this payment method
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
   


		protected function checkConditions ($cart, $method, $cart_prices) {

		$this->convert ($method);
		
		$cat_cond = true;
		
		
		if( !empty($method->categories) or !empty($method->blocking_categories) ){
			if(!empty($method->categories)) $cat_cond = false;
			//vmdebug('hmm, my $cat_cond',$method);
			//if at least one product is  in a certain category, display this shipment
			if(!is_array($method->categories)) $method->categories = array($method->categories);
			if(!is_array($method->blocking_categories)) $method->blocking_categories = array($method->blocking_categories);

			$msg = 'None of the products is in a category of the method '. $method->{$this->_psType.'_name'} . '<br>';
			
			//Gather used cats
			foreach($cart->products as $product)
				{
				if(array_intersect($product->categories,$method->categories)){
					//echo "allowed category found<br>";
					$cat_cond = true;
					//break;
				}
				
				if(array_intersect($product->categories,$method->blocking_categories)){
					$cat_cond = false;
					//echo "blocked category found<br>";
					$msg = 'At least one of the products is in a category which blockes the method '.$method->{$this->_psType.'_name'};
					break;
				}
			}
			//if all products in a certain category, display the shipment
			//if a product has a certain category, DO NOT display the shipment
			
			//echo $msg;
			
			if(!$cat_cond) {
				//vmdebug($msg);
				return false;
			}
		}

		// Fix for VM 3.6
		
		//$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
		
		$address = $cart->getST();
		

		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array ($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array ($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array ($address['virtuemart_country_id'], $countries) || count ($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}

		return FALSE;
	}

	/**
	 * @param $method
	 */
	function convert ($method) {

		$method->min_amount = (float)$method->min_amount;
		$method->max_amount = (float)$method->max_amount;
		
		//$method->min_amount = (float)str_replace(',','.',$method->min_amount);
		//$method->max_amount = (float)str_replace(',','.',$method->max_amount);
	}



  function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

	return $this->onStoreInstallPluginTable($jplugin_id);
    }



function plgVmOnCheckoutAdvertise($cart, &$payment_advertise)
	{
	return null;
	}






function plgVmOnProductDisplayPayment($product, &$productDisplay)
	{

	$vendorId = 1;
	if ($this->getPluginMethods($vendorId) === 0)
		{
		return FALSE;
		}

$button_code =
'
<form name="pos_ssc">
<input type="hidden" name="place" value="1">
</form>

<script type="text/javascript">
function func1()
{

var position=0;

for (var i=0; i<document.forms.length; i++)
	{
	try{
		if(document.forms[i].name == "pos_ssc")
			{
			//alert("Found" + i);
			position=i;
			i=document.forms.length;	
			}
		}
	catch(err)
		{
		//alert("error found");
		}
	}


try{
	if(typeof document.forms[position+1].addtocart != "object" && position>0)
		{
		position=position-1;
		//alert("non standard layout");
		}
	else
		{
		//alert("standard layout");
		}	
	}
	catch(err)
		{
		//alert("error found");
		}



	
//alert(vmSiteurl + Virtuemart.addtocart_popup);
if(typeof Virtuemart !== "undefined")
	{
	Virtuemart.addtocart_popup=0;
	}
for (var i=position; i<document.forms.length; i++)
	{
	try{
		if(typeof document.forms[i].addtocart == "object")
			{
			//setCookie("ssc_ecob","1","path=/");
			document.cookie = "ssc_ecob=1;path=/";
			document.forms[i].addtocart.click();
			//alert("error");
			i=document.forms.length;	
			}
		}
	catch(err)
		{
		//alert("error found");
		}
	}
}


function setCookie(cname,cvalue,exdays)
{
var d = new Date();
//d.setTime(d.getTime()+(exdays*24*60*60*1000));
//var expires = "expires="+d.toGMTString();
var expires="";
document.cookie = cname + "=" + cvalue + "; " + expires;
}

function getCookie(cname)
{
var name = cname + "=";
var ca = document.cookie.split(";");
for(var i=0; i<ca.length; i++)
  {
  var c = ca[i].trim();
  if (c.indexOf(name)==0) return c.substring(name.length,c.length);
}
return "";
}
//document.cookie = "ssc_ecob=0;path=/";
</script>' .

'<br/><img style="border:0;margin-right:7px;cursor: pointer" src="https://fpdbs.paypal.com/dynamicimageweb?cmd=_dynamic-image" onclick="func1();" alt="PayPal" align="left"><br/><br/>';


$db = JFactory::getDbo();
$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
$db->setQuery($q);
$virtuemart_paymentmethod_id = $db->loadResult();

if(!is_null($virtuemart_paymentmethod_id))
	{
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	
	##rest
	$method->ssc_short_cut_cart=0;
	if($method->ssc_short_cut_cart == '1')
		{
		$productDisplay[] = $button_code;
		//echo 'Selected';
		}
	else
		{
		//echo 'Not Selected';	
		}
	
	}
else
	{
	echo 'Null';
	}

		
	$session = JFactory::getSession();

	if(is_null($session->get('session_token')))
		{
		//echo 'Session Token is null<br/>';
		}
	else
		{
		//echo 'Session Token is reset: ' . $session_token . '<br/>';
	
		$session->set('session_token', null);
		$session->set('session_PayerID', null);
		}

		return TRUE;
	}


	function plgVmDisplayLogin2($user, &$html, $from_cart = FALSE)
		{
		$ver = VmConfig::getInstalledVersion();

		if (version_compare ($ver, '3.2.0', '>='))
			{
			return null;
			}
			
		$template = JFactory::getApplication()->getTemplate();	
		
		if($template == 'yootheme')
			{
			return null;	
			}
		
		//$html .= '***Display the Login***1';
		// only to display it in the cart, not in list orders view
		if (!$from_cart)
			{
			return NULL;
			}
					
		$vendorId = 1;
		if (!class_exists('VirtueMartCart'))
			{
			require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php'); // xx JPATH_VM_SITE
			}

		$cart = VirtueMartCart::getCart();
		if ($this->getPluginMethods($cart->vendorId) === 0)
			{
			return FALSE;
			}
		
		//if ($cart->pricesUnformatted['salesPrice'] <= 0.0)
		if (isset($cart->pricesUnformatted['salesPrice']) && $cart->pricesUnformatted['salesPrice'] <= 0.0)
			{
			return FALSE;
			}
			
		if (!isset($cart->pricesUnformatted['salesPrice']))
			{
			return FALSE;
			}			
			
		
		if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id)))
			{
			return NULL;
			}

		//$html .= '***Display the Login***2';
		
		$html = $this->html_code();

	}


function html_code()
{

$html='';

$css= "<style>
	//span.vmpayment_name + * + h3
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

	//span.vmpayment_name + * + h3 + *
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

	//input[name=virtuemart_paymentmethod_id]
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

form#com-form-login
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
display:none
}

</style>
";

/*
$session = JFactory::getSession();

$new_price = 0;

if($session->get('session_ssc_total') != $cart->pricesUnformatted["billTotal"])
	{
	$new_price = 1;
	$session->set('session_ssc_total', $cart->pricesUnformatted["billTotal"]);
	}

if($new_price) echo 'New Price: ' . $cart->pricesUnformatted["billTotal"] . '<br/>';
*/		

/*
		<fieldset class='vm-fieldset-tos'>
		<div  class='cart tos' >
		<span class='cart tos' >Terms of Service</span>

						<input type='hidden' name='tos' value='0' /><input class='terms-of-service'  type='checkbox' name='tos' value='1'  /><div class='terms-of-service'>
	<label for='tos'>
		<a href='/store/joomla33/index.php/vendor/virtuemart-3-sample-store/tos' class='terms-of-service' id='terms-of-service' rel='facebox'
		   target='_blank'>
			<span class='vmicon vm2-termsofservice-icon'></span>
			Click here to read terms of service and check the box to accept them.		</a>
	</label>

	<div id='full-tos'>
		<h2>Terms of service</h2>
		<h5>This is a demo store. Your orders will not proceed. You have not configured any terms of service yet. Click <a href='/store/joomla33/administrator/index.php?option=com_virtuemart&amp;view=user&amp;task=editshop'>here</a> to change this text.</h5>		</div>
</div>
			</div>
	
	</fieldset>
*/	
	
/*	
echo "<form>
<fieldset class='vm-fieldset-tos'>
<div  class='cart tos' >
<span class='cart tos' >Terms of Service</span>

<input type='hidden' name='tos' value='0' /><input class='terms-of-service'  type='checkbox' name='tos' value='1'  /><div class='terms-of-service'>
<label for='tos'>
<a href='/store/joomla33/index.php/vendor/virtuemart-3-sample-store/tos' class='terms-of-service' id='terms-of-service' rel='facebox'
target='_blank'>
<span class='vmicon vm2-termsofservice-icon'></span>
Click here to read terms of service and check the box to accept them.</a>
</label>

<div id='full-tos'>
<h2>Terms of service</h2>
<h5>This is a demo store. Your orders will not proceed. You have not configured any terms of service yet. Click <a href='/store/joomla33/administrator/index.php?option=com_virtuemart&amp;view=user&amp;task=editshop'>here</a> to change this text.</h5>		</div>
</div>
</div>
	
</fieldset>

<div class='checkout-button-top'> <button type='submit'  id='checkoutFormSubmit' name='checkout' value='1' class='vm-button-correct' ><span>Check Out Now</span> </button></div>

<input type='hidden' name='order_language' value='en-GB'/>
<input type='hidden' name='task' value='updatecart'/>
<input type='hidden' name='option' value='com_virtuemart'/>
<input type='hidden' name='view' value='cart'/>
</form>";
*/
		
		
if($this->get_cookie('c') == '1')
	{
	$html .= '<br/><p><font face="Arial" size="5" color="#FF0000"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_STRIPE_SSC_YOUR_ORDER_IS_NOT_YET_COMPLETE') . '</b></font></p>';
	$html .= '<br/><p><font face="Arial" size="4" color="#008080"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_STRIPE_SSC_REVIEW_YOUR_ORDER_DETAILS') . '</b></font></p><br/>';
	
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"c=0;path=/\";";
	$html .= "document.cookie = \"ceco=1;path=/\";";
	$html .= "</script>" . $css;
	}	
elseif($this->get_cookie('ceco') == '1' && $this->get_cookie('ssc_checkout') == '1')
	{
	$html .= '<br/><p><font face="Arial" size="5" color="#FF0000"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_STRIPE_SSC_YOUR_ORDER_IS_NOT_YET_COMPLETE') . '</b></font></p>';
	$html .= '<br/><p><font face="Arial" size="4" color="#008080"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_STRIPE_SSC_REVIEW_YOUR_ORDER_DETAILS') . '</b></font></p><br/>';
	
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"c=0;path=/\";";
	$html .= "document.cookie = \"ceco=1;path=/\";";
	$html .= "</script>" . $css;
	}	
else
	{
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"ceco=0;path=/\";";
	$html .= "</script>";
	}

return $html;


}





function onAfterRender()
	{


	$db = JFactory::getDbo();

	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "stripessc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}


	$input = new JInput;
	$name = $input->get('view', '', '');

	if($name != 'cart')
		{
		return NULL;
		}
	

	//$name = $input->get('task', '', '');
	
	//if($name != 'updatecart' && $name != '')
	//	{
//		return NULL;
	//	}
		
	//$body = JResponse::getBody();
	$body = JFactory::getApplication()->getBody();
	$new_body = $body;
	
	

	$first_payment_html = '';
	
	$cart = VirtueMartCart::getCart ();
	
	$selected = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id);
	
	if($selected)
	{
	list($html_pplan,$use_profile,$profile_error,$first_payment_html) = $this->get_payment_name($selected,0,null);
	
	$method = $selected;
//	echo $first_payment_html;
	
	//$first_payment_html = htmlspecialchars($first_payment_html);
	
	$first_payment_html = preg_replace('/\$/','&#36;', $first_payment_html);
	
	//echo $first_payment_html;
	//$first_payment_html = '<span style="font-size: medium">' . $first_payment_html . '<\/span>';
//
	$str = '/<div class="checkout-button-top">/';
	
	$replace = '<div class="checkout-button-top" style="font-size: medium; font-weight: bold">' . $first_payment_html;
	
	$new_body = preg_replace($str, $replace, $new_body);
	
	}
	
/*	
	$str = '/<button type="submit" id="checkoutFormSubmit" /';
	
	$replace = '<button style="display: none" type="submit" id="checkoutFormSubmit" ';
	
	$new_body = preg_replace($str, $replace, $new_body);
*/	
//<button type="submit" id="checkoutFormSubmit" name="checkout"


//style="display: none"

	//if($cart->_dataValidated && $this->get_cookie('ssc_checkout') == '1' && $new_price == 0)
	
	
	if($cart->_dataValidated && $method->ssc_one_page == '1')
	{
	

//		if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id))) {
	//		return FALSE;
//		}	 
		$this->getPaymentCurrency($method);  // code 0 is default ??
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();
	
	
	    ////$this->show_order_buttons($method,$order,$currency_code_3,$virtuemart_order_id);
	
	$html = $this->show_order_buttons($method,null,$currency_code_3,null,$use_profile);
	
	//echo $html;
	
//	$str = '/<button type="submit" id="checkoutFormSubmit"/';
	
	$str = '/<div style="display:none;" id="cart-js">/';
	
	
	
	$replace = $html  . '<div style="display:none;" id="cart-js">';
	
	
	$new_body = preg_replace($str, $replace, $new_body);
	
//	<button type="submit" id="checkoutFormSubmit"


	
	}
	
	
	
	
	
	
	

	$str = '/<span class="vmpayment_name">/';
	
	$replace = '<span class="vmpayment_name notranslate">';
	
	$new_body = preg_replace($str, $replace, $new_body);
	
	
	$str = '/\$\(\'input\[name="task"\]\'\)\.val\("updateCartNoMethods"\);/';
	
	$replace = '$(\'input[name="task"]\').val("updatecart");';
	
	$new_body = preg_replace($str, $replace, $new_body);
	
	
	//$str = '/<input class="terms-of-service required"/';
	
	//$replace = '<input class="terms-of-service"';
	
	//$new_body = preg_replace($str, $replace, $new_body);
	
	/*
	$str = '/<input type="checkbox" name="Zustimmung" id="Zustimmung_field" value="1" class="required">/';
	
	$replace = '<input type="checkbox" name="Zustimmung" id="Zustimmung_field" value="1">';
	
	$new_body = preg_replace($str, $replace, $new_body);
	*/
	
	
	if($body != $new_body)
		{
		//JResponse::setBody($new_body);
		JFactory::getApplication()->setBody($new_body);
		}
	

	}


    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
	return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, J Error::raiseWarning (or J Error::raiseError) must be used to set a message.
     *
     * @author Valerie Isaksen
     * @author Max Milbers
     */
//    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
//	return $this->displayListFE($cart, $selected, $htmlIn);
//    }


	function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected, &$htmlIn) {

		//JHTML::_ ('behavior.tooltip');
		




//$cart = VirtueMartCart::getCart ();

//$method = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id);
		


		
		if ($this->getPluginMethods($cart->vendorId) === 0) {
			if (empty($this->_name)) {
				$app = JFactory::getApplication();
				$app->enqueueMessage(vmText::_('COM_VIRTUEMART_CART_NO_' . strtoupper($this->_psType)));
				return FALSE;
			} else {
				return FALSE;
			}
		}
		
		
		
		$html = array();
		$method_name = $this->_psType . '_name';
		

		//JHTML::script('vmcreditcard.js', 'components/com_virtuemart/assets/js/', FALSE);
		VmConfig::loadJLang('com_virtuemart', true);
		//vmJsApi::jCreditCard();
		$htmla = array();
		$html = array();
		

$opc = 0;
$vp_opc = 0;

		
	VmConfig::loadConfig();
	$vm_opc = vmConfig::get('oncheckout_opc',"0");
	//	vmConfig::set('oncheckout_opc', true);	
	//
	//if($method->ssc_one_page == '1' && $vm_opc == '0')
	
	
$db = JFactory::getDbo();
$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'plg_system_opc'");
$opc_enabled = $db->loadResult();
$opc = $opc_enabled;

if($opc_enabled != '1')
	{
	$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'VP One Page Checkout'");
	$opc_enabled = $db->loadResult();
	$vp_opc = $opc_enabled;
	}



//JHtml::_('jquery.framework');
$document = JFactory::getDocument();
$document->addScript('https://js.stripe.com/v3/');


$url = JURI::root() . "plugins/vmpayment/stripessc/checkout.css";
$document->addStyleSheet($url);

$error_message_shown = 0;
	
		foreach ($this->methods as $this->_currentMethod)
			{
			
			
		// begin cc_mod one page 1	

/*		
$pplan_BILLINGPERIOD = $this->_currentMethod->ssc_pplan_BILLINGPERIOD;		
		
if($pplan_BILLINGPERIOD == 'None')
{	

if($opc_enabled != '1')
	{
	//if($this->_currentMethod->ssc_one_page == '1')
	if($this->_currentMethod->ssc_one_page == '1' ||  $vm_opc == '0')
		{
		//$selected = 0;		
		return $this->displayListFE($cart, $selected, $htmlIn);		
		}
	}			
	// end cc_mod one page 1

}		
*/

		//begin fix for Joomla 2.5 a
		
		$cartprices = null;
		
		if(isset($cart->cartPrices))
			{
			$cartprices = $cart->cartPrices;
			}
		else
			{
			$cartprices = $cart->pricesUnformatted;
			}
			
			
		if ($this->checkConditions($cart, $this->_currentMethod, $cartprices))
			{
			$methodSalesPrice = $this->setCartPrices($cart, $cartprices, $this->_currentMethod);
			
	//		if ($this->checkConditions($cart, $this->_currentMethod, $cart->cartPrices))
	//			{
	//			$methodSalesPrice = $this->setCartPrices($cart, $cart->cartPrices, $this->_currentMethod);
	// end fix for Joomla 2.5
			
				$this->_currentMethod->$method_name = $this->renderPluginName($this->_currentMethod);
				$html = $this->getPluginHtml($this->_currentMethod, $selected, $methodSalesPrice);
				


$this->getPaymentCurrency($this->_currentMethod); //?????
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $this->_currentMethod->payment_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();




######## End Rest 3 #########################
				

	list($html_pplan,$use_profile,$profile_error) = $this->get_payment_name($this->_currentMethod,0,null);		

	
	//$html .= "<br>Profile Error: $profile_error <br>";
	//$html .= "Use Profile: $use_profile <br>";

	
	$pplan_BILLINGPERIOD = $this->_currentMethod->ssc_pplan_BILLINGPERIOD;		
	
//	$html .= "#############$use_profile##########";
//	$html .= "#############$profile_error##########";
//	$html .= $pplan_BILLINGPERIOD;
	
	$sel = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id);
		

	$current_payment_method = $this->_currentMethod->virtuemart_paymentmethod_id;

	$sel_payment_method = $sel->virtuemart_paymentmethod_id;
	
	
if($pplan_BILLINGPERIOD != 'None') // && $use_profile == 1)
	{
	
	if($current_payment_method ==  $sel_payment_method)
		{
		$html .= '<br/>' . $html_pplan;
		}
	
	if($use_profile == 1 && $profile_error == 1)
		{
		$html = '';
			
		if($error_message_shown == 0)
			{
			//<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>Your can not order recurring items and non recurring items at the same time. Please delete one item from your cart and continue<br/><br/><br></span><br>
		
			$html = JText::_("VMPAYMENT_STRIPE_SSC_CART_WARNING_REC");
			
			$error_message_shown = 1;
			}

		}
		
	if($use_profile == 0)
		{
		$html = '';
		}
	
	}

$htmla[] = $html;
				
				
			}
		
		}
		
		$htmlIn[] = $htmla;


		return TRUE;

	}




























    /*
     * plgVmOnSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     * @author Valerie Isaksen
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     *
     */

    public function plgVmOnSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
		{
		 
		$ver = VmConfig::getInstalledVersion();
		$arr = explode(' ',trim($ver));
		$ver = $arr[0];
		//echo $ver;

		if (version_compare ($ver, '3.7.0', '>'))
			{
		 	$cart->automaticSelectedPayment=false;
			$cart->setCartIntoSession();
			}
		 
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
		}

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */


  function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices, &$paymentCounter)
	{
			  
			  
	$ver = VmConfig::getInstalledVersion();
	$arr = explode(' ',trim($ver));
	$ver = $arr[0];
	//echo $ver;

	if (version_compare ($ver, '3.5.99', '>') && version_compare ($ver, '3.6.4', '<'))
		{
		//echo 'New';		  
	   return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
		}

	//echo 'Old';
			  
	
	$return = $this->onCheckAutomaticSelected($cart, $cart_prices);
		if (isset($return)) {
			return 0;
		} else {
			return NULL;
		}
	}



    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     * @author Max Milbers
     * @author Valerie Isaksen
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     * @author Max Milbers

      public function plgVmOnCheckoutCheckDataPayment($psType, VirtueMartCart $cart) {
      return null;
      }
     */

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	return $this->onShowOrderPrint($order_number, $method_id);
    }

    /**
     * Save updated order data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderPayment(  $_formData) {
      return null;
      }
     */
    /**
     * Save updated orderline data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderLine(  $_formData) {
      return null;
      }
     */
    /**
     * plgVmOnEditOrderLineBE
     * This method is fired when editing the order line details in the backend.
     * It can be used to add line specific package codes
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnEditOrderLineBE(  $_orderId, $_lineId) {
      return null;
      }
     */

    /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
      return null;
      }
     */
    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
	return $this->declarePluginParams('payment', $name, $id, $data);
    }

	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
	return $this->setOnTablePluginParams($name, $id, $table);
    }
    
 private function table_exist($table,$debug)
	{

	if (!class_exists('JConfig'))
		require(JPATH_CONFIGURATION . '/configuration.php');
	
	$cfg = new JConfig();
	$dbname = $cfg->db;
	$dbprefix = $cfg->dbprefix;		
		
	$table = $dbprefix . $table;

	if($debug)echo $table . '<br>Table name is ' . $table . '<br><br>';
		
	$tables = JFactory::getDbo()->getTableList();
	
	//$table = 'test';
	
	if(in_array($table,$tables))
		{
		if($debug)echo '<br>Table found<br><br>';
		return true;
		}
	else
		{
		if($debug)echo '<br>Table not found<br><br>';
		return false;
		}
	}  


public function post_strings()
	{
	$postvars = array();

	foreach ($_POST as $key => $value)
		{
		$value = preg_replace('/[^a-zA-Z0-9.\-_: \/]/', '', $value);
		$postvars[$key] = $value;
		}

	return $postvars;
	}


public function get_strings()
	{
	$getvars= array();

	foreach ($_GET as $key => $value)
		{
		$value = preg_replace('/[^a-zA-Z0-9.\-_: \/]/', '', $value);
		$getvars[$key] = $value;
		}

	return $getvars;
	}


	    
 function get_cookie($name)
	{
	$value = '';
    
	if(isset($_COOKIE[$name]))
		{
    	$value = $_COOKIE[$name];
    	//$value = preg_replace('/[^a-zA-Z0-9.-]/', '', $value);
		$value = preg_replace('/[^a-zA-Z0-9.\-_: \/]/', '', $value);
    	}
    	
	return $value;
	}


}

// No closing tag
